<?php
/*
Copyright (C) 2011 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

###################################################################
 * 
 * 
 * MyMVC_file_ini
 * Model pour le traitement des fichiers JS, CSS... 
 * Remplace la lecture de config.ini
 * 
 * 08/04/14 - Optimisation du code
 *   
 * 
 * 
 */


class MyMVC_file_ini extends MyMVC_Model {
   
   public function __construct() {
      $this->_sqlCreateTable = "( 
            `id_file` int(10) unsigned NOT NULL AUTO_INCREMENT,
            `fi_type` varchar(50) NOT NULL,
            `fi_name` varchar(255) NOT NULL,
            `fi_note` text,
            PRIMARY KEY (`id_file`)
          ) ENGINE=MyISAM DEFAULT CHARSET=utf8";

		parent::__construct('mymvc_file') ;
		$this->_setPrimaryKey("id_file",true) ;  // autoincremente	
   }
   
   public function beforeWrite($data) { return $data;  }
   
   public function afterRead($data,$aspect) { return $data; }
   
   public function isValid($col,$data) {
      $err= '';
      switch($col) {
         case 'fi_name' : if($data['fi_name']=='') $err = 'Veuillez saisir un nom de fichier'; break;
      }
      return $err;
   }
       
   public function isDeletable($id) {
      //$this->_setError('Seule les modifications sont autorisée !');
      return true;
   }
   
   /**
   * Liste les enregistrement stockées en base
   * 
   * @return array
   * 
   */
   public function getList() {
      $this->_setOrder("fi_type");
      $liste = $this->_findAllArray();
      if( $liste != null ) {
         $this->response['data'] = $liste;
         $this->response['requestOk'] = true;
         $this->response['message'] = "OK";
      } else {
         $this->response['message'] = "Aucun enregistrement trouvé";
      }
      return $this->response;
   }
   
   /**
    * Enregistre en bdd
    * INSERT ou UPDATE
    * 
    * @return array
    * 
    */
   public function save() {
      if( $_POST['id_file']=='') {
         $n = $this->_create($_POST);
         $res = $n->_save() ;
      } else {
         $res = $this->_update($_POST['id_file'], $_POST);
      }
      if($res) {
         $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = $n->_getErrors();
      }
       return $this->response;
   }
   
   /**
    * Lit un enregistrement
    * 
    * @param int $id
    * @return array
    * 
    */
   public function read($id) {
      $rec = $this->_find($id);
      if( $rec != null ) {
         $this->response['data'] = $rec->_toArray();
         $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = 'Erreur enregistrement non trouvé';
      }
       return $this->response;
   }
   
   /**
    * Supprime un enregistrement en base
    * 
    * @param int $id
    * @return array
    */
   public function delete($id) {
      if( $this->_delete($id) ) {
          $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = $this->_getLastError();
      }
       return $this->response;
   }
  
}

