<?php
/*
Copyright (C) 2013 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

###################################################################
 * 
 * 01/08/13 - Ajout fonction getList,save,delete,read
 * 
 *  
 * 
 */

class MyMVC_acl_ini extends MyMVC_Model
{
   public $response;
   public function __construct() {
      $this->_sqlCreateTable = "( 
            `id_acl` int(10) unsigned NOT NULL AUTO_INCREMENT,
            `acl_type` varchar(10) NOT NULL,
            `acl_name` varchar(50) NOT NULL,
            `acl_value` varchar(255) NOT NULL,
            `acl_enable` varchar(1) NOT NULL,
            PRIMARY KEY (`id_acl`)
          ) ENGINE=MyISAM DEFAULT CHARSET=utf8";
		parent::__construct('mymvc_acl') ;
		$this->_setPrimaryKey("id_acl",true) ;  // autoincremente	
      $this->response = array('requestOk'=>false,'message'=>'','data'=>'') ;
   }
   
   public function beforeWrite($data)
   {
      return $data;
   }
   
   public function afterRead($data,$aspect)
   {
      return $data;
   }
   
   public function isValid($col,$data) {
      $err= '';
      switch($col) {
         case 'acl_name' : if($data['acl_name']=='') $err = 'Veuillez saisir un nom'; break;
         case 'acl_value' : if($data['acl_value']=='') $err = 'Veuillez saisir une valeur';
      }
      return $err;
   }
       
   public function isDeletable($id) {
      //$this->_setError('not deletable');
      return true;
   }
   
   
    /**
   * Liste les enregistrement stockées en base
   * 
   * @return array
   * 
   */
   public function getList()
   {
      $this->_setOrder("CASE acl_type 
                        WHEN  'GROUPE' THEN 10 
                        WHEN  'CONTEXT' THEN 20 
                        WHEN  'Allow' THEN 30 
                        WHEN 'Deny' THEN 40
                     END");
      $liste = $this->_findAllArray();
      if( $liste != null ) {
         $this->response['data'] = $liste;
         $this->response['requestOk'] = true;
         $this->response['message'] = "OK";
      } else {
         $this->response['message'] = "Aucun enregistrement trouvé";
      }
      return $this->response;
   }
   /**
    * Enregistre en bdd
    * INSERT ou UPDATE
    * 
    * @return array
    * 
    */
   public function save()
   {
      if( $_POST['id_acl']=='') {
         $newAcl = $this->_create($_POST);
         $res = $newAcl->_save() ;
      } else {
         $res = $this->_update($_POST['id_acl'], $_POST);
      }
      if($res) {
         $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = $newAcl->_getErrors();
      }
       return $this->response;
   }
   /**
    * Lit un enregistrement
    * 
    * @param int $id
    * @return array
    * 
    */
   public function read($id)
   {
      $rec = $this->_find($id);
      if( $rec != null ) {
         $this->response['data'] = $rec->_toArray();
         $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = 'Erreur enregistrement non trouvé';
      }
       return $this->response;
   }
   /**
    * Supprime un enregistrement en base
    * 
    * @param int $id
    * @return array
    */
   public function delete($id)
   {
      if( $this->_delete($id) ) {
          $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = $this->_getLastError();
      }
       return $this->response;
   }
}

