<?php
/*
Copyright (C) 2011 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

###################################################################
 * 
 * MyMVC_page_ini
 * Model pour le traitement des urls de pages
 * remplacement le traitement de pages.ini
 * 
 * 08/04/14 - Optimisation du code
 * 
 * 
 */


class MyMVC_page_ini extends MyMVC_Model {
   
   public function __construct() {
      $this->_sqlCreateTable = "( 
            `id_page` int(10) unsigned NOT NULL AUTO_INCREMENT,
            `pa_url` varchar(50) NOT NULL,
            `pa_controler` varchar(50) NOT NULL,
            `pa_action` varchar(50) NOT NULL,
            `pa_params` varchar(255) NOT NULL,
            PRIMARY KEY (`id_page`),
            UNIQUE (`pa_url`)
          ) ENGINE=MyISAM DEFAULT CHARSET=utf8";

		parent::__construct('mymvc_page') ;
		$this->_setPrimaryKey("id_page",true) ;  // autoincremente	
   }
   
   public function beforeWrite($data) { return $data; }
   
   public function afterRead($data,$aspect) { return $data; }
   
   public function isValid($col,$data) {
      $err= '';
      switch($col) {
         case 'pa_url' : if($data['pa_url']=='') $err = 'Veuillez saisir une url'; break;
         case 'pa_controler' : if($data['pa_controler']=='') $err = 'Veuillez indiquer un controler'; break;
         //case 'pa_action' : if($data['pa_action']=='') $err = 'Veuillez indiquer une action ou ALL'; break;
      }
      return $err;
   }
       
   public function isDeletable($id) { return true; }
          
   /**
   * Liste les enregistrement stockées en base
   * 
   * @return array
   * 
   */
   public function getList() {
      $this->_setOrder("pa_url");
      $liste = $this->_findAllArray();
      if( $liste != null ) {
         $this->response['data'] = $liste;
         $this->response['requestOk'] = true;
         $this->response['message'] = "OK";
      } else {
         $this->response['message'] = "Aucun enregistrement trouvé";
      }
      return $this->response;
   }
   
   /**
    * Enregistre en bdd
    * INSERT ou UPDATE
    * 
    * @return array
    * 
    */
   public function save() {
      if( $_POST['id_page']=='') {
         $n = $this->_create($_POST);
         $res = $n->_save() ;
      } else {
         $res = $this->_update($_POST['id_page'], $_POST);
      }
      if($res) {
         $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = $n->_getErrors();
      }
       return $this->response;
   }
   
   /**
    * Lit un enregistrement
    * 
    * @param int $id
    * @return array
    * 
    */
   public function read($id) {
      $rec = $this->_find($id);
      if( $rec != null ) {
         $this->response['data'] = $rec->_toArray();
         $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = 'Erreur enregistrement non trouvé';
      }
       return $this->response;
   }
   
   /**
    * Supprime un enregistrement en base
    * 
    * @param int $id
    * @return array
    */
   public function delete($id) {
      if( $this->_delete($id) ) {
          $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = $this->_getLastError();
      }
       return $this->response;
   }
   
}

