<?php
/*
Copyright (C) 2011 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

###################################################################
 * 
 * MyMVC_viewvar.ini
 * Model pour la gestion des viewvars
 * Remplace le traitement de viewvars.ini
 * 
 * 08/04/14 - Optimisation code
 * 
 * 
 */


class MyMVC_viewvar_ini extends MyMVC_Model {
   
   public function __construct() {
      $this->_sqlCreateTable = "( 
            `id_viewvar` int(10) unsigned NOT NULL AUTO_INCREMENT,
            `vi_context` varchar(100) NOT NULL,
            `vi_name` varchar(100) NOT NULL,
            `vi_value` varchar(100) NOT NULL,
            `vi_note` varchar(255) NOT NULL,
            PRIMARY KEY (`id_viewvar`)
          ) ENGINE=MyISAM DEFAULT CHARSET=utf8";

		parent::__construct('mymvc_viewvar') ;
		$this->_setPrimaryKey("id_view",true) ;  // autoincremente	
   }
   
   public function beforeWrite($data) { return $data; }
   
   public function afterRead($data,$aspect) { return $data; }
   
   public function isValid($col,$data) {
      $err= '';
      switch($col) {
         case 'vi_context' : if($data['vi_context']=='') $err = 'Veuillez spécifier un context (CONTROLER:ACTION) ou ALL:ALL'; break;
         case 'vi_name' : if($data['vi_name']=='') $err = 'Veuillez indiquer un nom de variable'; break;
         case 'vi_value' : if($data['vi_value']=='') $err = 'Veuillez préciser la valeur de la variable'; break;
      }
      return $err;
   }
       
   public function isDeletable($id) { return true; }
    
   /**
   * Liste les enregistrement stockées en base
   * 
   * @return array
   * 
   */
   public function getList() {
      $this->_setOrder("vi_context,vi_name");
      $liste = $this->_findAllArray();
      if( $liste != null ) {
         $this->response['data'] = $liste;
         $this->response['requestOk'] = true;
         $this->response['message'] = "OK";
      } else {
         $this->response['message'] = "Aucun enregistrement trouvé";
      }
      return $this->response;
   }
   
   /**
    * Enregistre en bdd
    * INSERT ou UPDATE
    * 
    * @return array
    * 
    */
   public function save() {
      if( $_POST['id_viewvar']=='') {
         $n = $this->_create($_POST);
         $res = $n->_save() ;
      } else {
         $res = $this->_update($_POST['id_viewvar'], $_POST);
      }
      if($res) {
         $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = $n->_getErrors();
      }
       return $this->response;
   }
   
   /**
    * Lit un enregistrement
    * 
    * @param int $id
    * @return array
    * 
    */
   public function read($id) {
      $rec = $this->_find($id);
      if( $rec != null ) {
         $this->response['data'] = $rec->_toArray();
         $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = 'Erreur enregistrement non trouvé';
      }
       return $this->response;
   }
   
   /**
    * Supprime un enregistrement en base
    * 
    * @param int $id
    * @return array
    */
   public function delete($id) {
      if( $this->_delete($id) ) {
          $this->response['requestOk'] = true;
      } else {
         $this->response['message'] = $this->_getLastError();
      }
       return $this->response;
   }
}

