<?php
/*
Copyright (C) 2011 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

#################################################################
*/

/** ***********  AUTOLOAD function Models and Libs  */
function __autoload($pClassName) {
	$file = $pClassName."Model.php" ; // test si on cherche un model
	if( file_exists( BASE_PATH.'models/'.$file) ) {
		require_once( BASE_PATH.'models/'.$file );
	} else {
		// recherche dans application/lib
		$file = $pClassName.'.class.php';
		if( file_exists( BASE_PATH.'lib/'.$file) ) {
			require_once( BASE_PATH.'lib/'.$file );
		} else {
			throw new Exception(MyMVC::getTrad('mymvc_erreurAutoloadFichierNonTrouve',array($file)));
		}
	}
	return true;
}

/* helpers pour le dev */
function d($p) { 
	if(true===MyMVC_AJAX) {
		$r = print_r($p,true);
		print json_encode(array('requestOk'=>false,'message'=>'Dump:<br>'.$r));
	} else {
		var_dump($p); 
	}
	exit;
}

function __debug($message) { MyMVC::_getInstance()->_log(MYMVC_DEBUG,$message,MYMVC_LOG); }


// Affichage erreur avant que MyMVC ne soit opérationel
function display_html_error($pError) {
  print <<<FIN
   <html>
   <head>
   </head>
   <body>
   <h2 style="text-align:center">Erreur Traitement</h2>
   <p><strong>
   $pError</strong>
   </p>      
   </body>
  </html>
FIN;
}

/**
 * 06/03/14
 * Coupe un chaine a une longueur max plus ...
 * 
 * @param type $pStr
 * @param type $pLen
 * 
 * @return string
 */
function MyMVC_stringCut($pStr,$pLen) {
   $r = $pStr;
   if( strlen($pStr) > $pLen ) {
      $r = substr($pStr,0,$pLen).'...';
   }
   return $r;
}