<?php
/*
Copyright (C) 2003 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

###################################################################
/*
 * 
 * ##################################
 * ###		DbFunc.inc.php
 * ###		09/09/03
 * ##################################
 *
 * Fichier regroupant toutes les fonctions PHP/MySql
 * 
 * 09/09/03 : F_DoSql: Ajout message err mysql, F_DateMysqlFr
 * 26/09/03 : Modif nom constante Cs_Login...
 * 29/09/03 : Modif des var Dbhost, Dbname... => variables global pour permetre la connexion a plusieurs bases
 * 29/09/03 : Fonction F_SwapDatabase pour permetre de travailler sur plusieurs base !
 * 30/09/03 : Format date longue dans F_DateMysqlFr (4)
 * 06/10/03 : Modif DoSql,  F_NewId()
 * 08/10/03 : F_LogWrite, Log des requetes SQL
 * 10/10/03 : Lock table sur fonction F_NewId
 * 15/10/03 : Modif NewId = la valeur de l'ID créée est stockée dans un variable passe ByRef
 * 20/10/03 : F_TestDoublon
 * 22/10/03 : F_LogWrite (test fichier et Cb_LogSql)
 * 28/10/03 : F_TestDoublon condition where en parametre et renvoie l'ID du doublon
 * 25/11/03 : F_Pagination (gestion de la pagination pour les listes)
 * 26/11/03 : Maj fonction F_TestDoublon
 *
 * 05/08/04 : maj fonction F_MysqlDatefr, ajour option 5 et 6
 * 07/09/04 : F_StrLngFixe
 * 10/09/04 : F_ErrorOn() ;
 * 03/11/04 : maj F_DateMysqlFr()
 * 09/11/04 : ajout F_Decimal()
 * 
 * 17/02/05 - ajout F_DoSql2 ( $sql, &$rs, $type)
 * 01/03/05 - modif F_DateMysqlFr, suppression option 7, faisait doublons avec la 2
 * 03/03/05 - correction bug F_StrLngFixe, L et R inversé, ajout F_RecNavigation
 * 09/03/05 - suppression des espaces en trop dans F_DateMySqlFr format 2
 * 11/03/05 - F_GetOne
 * 29/03/05 - Class C_DumpDb , export XML d'une base table par table avec structure et données;
 * 26/04/05 - ajout format jjmmaaaa à F_DateMysqlFr  format numero 7
 * 09/05/05 - F_DoSql3 créé et execute une requete sql a partir d'une requete modele et d'un tableu de ref/valeur
 * 11/05/05 - creation class Db_Abstract pour pour pouvoir utiliser plusieur serveur de DBB indépendant du code
 * 12/05/05 - Class Db_Abstract
 * 07/06/05 - ajout last_query a la classe Db_Abstract
 * 09/06/05 - modif appel de la fonction mysql_fetch_array pour n'avoir en retour qu'un tableau associatif, par defaut renvoie un tableau associatif et un tableau numérique
 *  				  fix bug sur init des vars id_current et current dans DB_Abstract
 * 13/06/05 - ajout methode M_MoveNext + id_current + current pour  lire un resultset à la méthode vb !!
 * 23/06/05 - F_BoldSql pour mettre en forme une requete SQL pour affichage HTML
 * 11/08/05 - F_M_MoveFirst dans la class DB_Abstract pour se replacer sur le 1er enregistrement
 * 22/08/05 - ajout test si requete R_Sql vide => arret du script
 * 13/09/05 - maj F_BoldSql, __clone class Db_Abstract()
 * 12/12/05 - rempl __clone par M_clone dans Db_Abstract pour eviter pb si migration PHP5
 *
 * 04/10/06 - fix bug format date jj/mm/aa  manquait 1 zero si AA < 10
 *
 * 28/03/07 - integration PHPMVC
 * 17/05/07 - ajout _logSql()
 * 17/09/08 - pb path log en dur => deplacer dans config !!
 * 18/01/13 - ajout test si $RS existe pour éviter warning si pas de résultat (ligne 204)
 * 
 * 
 * ###########################################################
 * ###################    passage en OFF de F_DoSql2, F_DoSql3  !!!!
 * ###################    !!!  F_DoSql2 est utilisé pour controle login MIC !!
 * 
 * 15/11/08 - path log utilise  APP_PATH (dans path-cfg.php)
 * 20/01/10 - suppression version, date, remplacement die() par throw new Exception()
 * 						_driver, _cnx, _err, _nbLines, _currentId, _currentRow
 * 						moveNext() et moveFirst => OFF
 * 05/02/10 - add sql query to error display
 * 21/05/10 - _sqlliteConnect()
 * 04/04/11 - _createTable(), _createTableMysql()
 * 25/06/14 - modif error par défaut si erreur duplicate dans execSql()
 * 13/10/14 - Début création class Mydb_sqlite() et Mydb_mysql()
 * 
 * 
 * TODO :
 * 
 * oracle, postgresql, sqllite drivers
 * 
 * 
*/

Define('SQL_CREATE_TABLE',"CREATE TABLE `{___TABLE___}` (\n {___COLS___} )\n ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_general_ci;");

/* Class d'abstraction pour SQLite */



class MyMVC_DbConnexion {
	public $mydb = null;
	
	public function __constructor($pDriver,$pCnxData){
		switch($pDriver) {
			case 'sqlite' : $this->mydb = new Mydb_sqlite($pCnxData['database']); break;
			case 'mysql' : $this->mydb = new Mydb_mysql($pCnxData['host'],$pCnxData['login'],$pCnxData['pass'],$pCnxData['database']); break;
			default : throw new Exception(" DbfuncLib::__construct() Driver SGBD [ <b>$pDriver</b> ] non pris en compte !") ;
		}
		if( $this->mydb == false ) {
			throw new Exception(" DbfuncLib::__construct() Driver SGBD [ <b>$pDriver</b> ] erreur connexion sgbd !") ;
		}
		
	}
}



class DbfuncLib  
{
	public $_driver ;				// contient le nom du SGBD utilisé
	public $_cnx 	;	 				// id de connexion au SGBD
	public $_result ;  			// tableau de valeurs ou valeur unique (utilisation de label) 
	public $_err ;					// en cas d'erreur contient le libellé de l'erreur
	public $_nbLines 	; 		// nombre de lignes affectées par les requetes delete, update, ou nb ligne trouvée pour un select
	public $_lastQuery	;		// dernière requete exécutée
	public $_currentId ; 		// id de l'enregistrement actif
	public $_currentRow ; 	// tableau contenant l'neregistrement courant
	
	function __construct($pHost,$pLogin,$pPass,$pDatabase,$pDriver)
	{		
		$this->_result	= ''  ;  		
		$this->_err = '' ;		
		$this->_nbLines = 0 ; 		
		$this->_lastQuery	=	'' ;		
		$this->_currentId	=	-1 ;  		
		$this->_currentRow = array() ; 
		 	 		
		switch( $pDriver )
		{
			case 'mysql' :   // utilisation d'une base mysql 
			{
				//debug('mysql driver');
				$this->_cnx = $this->_mysqlConnect( $pHost, $pLogin, $pPass, $pDatabase ) ;
				break ;
			}
			
			case 'sqllite' :   // utilisation d'une base oracle
			{
				$this->_cnx = $this->_sqlliteConnect($pDatabase) ;
				break;
			}
			
			/*
			case 'postgresql' :   // utilisation d'une base postgresql
			{
				$this->_cnx = $this->postgresqlConnect( 
				$config['db']['host'] , $config['db']['login'] , $config['db']['pass'] ,$config['db']['database'] ) ;
				break ;
			}*/
			
			default :  // erreur nom SGBD non valide
			{
				//die( "Type SGBD = ".$pDriver." non valide !, <br>Erreur constructeur Dbfunc ! ") ;
				throw new Exception(" DbfuncLib::__construct() Driver SGBD [ <b>$pDriver</b> ] non pris en compte !") ;
			}
		} // switch serveur
		
		if( !$this->_cnx)
		{
			throw new Exception(" DbfuncLib::__construct() Driver SGBD [ <b>$pDriver</b> ] erreur connexion sgbd !") ;
		}
		
		$this->_driver = $pDriver ;
	} 
	
	function execSql( $R_Sql , $T_vars = '' , $type = 0 , $label='' )  // $label permet de ne récuperer qu'une valeur (voir F_GetOne) 
	{
		// 		par défaut :
		//		$T_vars = ''  indique que la requeten'est pas compléte; $T_Vars contient les paires nom/valeurs a rech/rempl dans la req
		// 		type = 0 , indique que c'est un select
		// 		label = '', indique que le result est un tableau et non une valeur simple
		// 		l'appel de la méthode peut donc se faire  par M_ExecSql( $sql)  pour un select  
		
		// ensuite si label != '', on recupere un valeur simple et non un tableau d'enregistrements
		// si type = 1 =  insert avec auto increment => maj de new_id
		// si type = 2 = insert (normal), delete, update => maj nb_lignes =  nb lignes impactées par la requete
		// si T_Vars != '' , c'est un tab de rev/valeur du type  ':1'=>'valeur', on rech/rempl dans la requete les ref par la valeur associée
		
		// raz des propriétés  avant utilisation
		$this->_nbLines			=		0 ;
		$this->_err					=		'' ;
		$this->_result			= 	'' ;
		$this->_currentId		=		-1 ;
		$this->_currentRow 	=		array() ;
		$ReturnVal = false ;
		
		$RS = '' ;  // stockage temporaire du résultat de la requetes
		
		if( $R_Sql == '' )
		{
			//die(' Erreur : requete sql vide' );
			throw new Exception(" DbfuncLib::execSql() requete vide");
		}
		
		if( !$this->_cnx )  // a t-on une connexion dispo ?
		{
			//$this->_err = 'Erreur : pas de connexion bdd disponible' ;
			//die('err pas de cnx bdd');
			throw new Exception(" DbfuncLib::execSql() aucune connexion disponible");
			//$ReturnVal = false ;	
		} else {
			// creation de la requete si besoin
			if( is_array($T_vars) )
			{
				foreach( $T_vars as $ref=>$val)
				{
					###fecho( " ref=$ref - var=$val " );
					$R_Sql = str_replace( "$ref", "$val" , $R_Sql ) ;  // on remplace dans R_Sql tous les champs refs par leurs valeurs
					###fecho($R_Sql );
				}
			}
			
			switch( $this->_driver )
			{
				case 'mysql' :
				{
               //echo $R_Sql;
					if( ! ($RS = mysql_query( $R_Sql , $this->_cnx ))  )
					{
						$errorExec = "DbfuncLib::execSql() mysql error : ".mysql_error() . "<br/><b>$R_Sql</b>";
						//d(mysql_errno());
						switch(mysql_errno()) {
							case '1062' : { // duplicate
								$errorExec = MyMVC::getTrad('mymvc_dbfunc_enregistrementImpossibleCreationDeDoublon');
							}
						}
						throw new Exception($errorExec);
					} else {
						$ReturnVal = true ;
						switch( $type ) // 0 = select, 1 = insert auto increment, 2 = insert, delete, update
						{
							case '0' :   // select par défaut
							{
                        $this->_nbLines = 0 ;
                        if(  count($RS)>0 )
                        {
                           $this->_nbLines = @mysql_num_rows($RS) ;
                        }
								if( $label != '' and  $this->_nbLines > 1  )
								{
										$this->_err = "Erreur: requete :<br> ' $R_Sql' <br>avec demande label = '$label'  " ;
										$ReturnVal = false ;
								} else {
									if( $label != '' )  // recup d'une valeur simple
									{
										$T_tmp = mysql_fetch_array( $RS ) ;
										$this->_result = $T_tmp[$label] ;
									}  else { 
										// requete select et tableau de valeur
										if ( $this->_nbLines > 0 )
										{
											$i = 0 ;
											while( $T_tmp = mysql_fetch_array( $RS , MYSQL_ASSOC) )  // ne renvoie qu'un tableau associatif
											{
												$this->_result[$i] = $T_tmp ;
												$i++ ;
											} // while 
										} // row > 0
									} // if label != ''
								}	 // if label et row != 1
								break ;
							}
							
							case '1' :  // insert avec auto increment 
							{
								$this->new_id = mysql_insert_id() ;  // on renvoi l'id auto increment qui vient d'�tre cr��
								break ;
							}
							
							case '2' :  // insert (normal), update, delete
							{ 
								$this->_nbLines = mysql_affected_rows() ;
								break ;
							}
						
							default :
							{
								$ReturnVal = false ;
								$this->_err = "type requete $type non valide <br> requête : $R_Sql ". mysql_error()."</b></p>" ;
							}
							
						} // switch type 
					} // if $RS 
					break ;
				} // case mysql 
				
				case 'sqllite' : {
					if( !$RS = $this->_cnx->query($R_Sql) )
					{
						// etudier solution pour logguer les erreur SQL avant de faire le die
						// la solution doit être portable car cette class est utilisée par plusieur application
						// dans lesquelles le nombres d'infos à logguer peut être differrent
						//die( "Erreur execution requête SQL : <br> $R_Sql <p><b> ". mysql_error()."</b></p>" )  ;
						throw new Exception("DbfuncLib::execSql() sqllite error : ".mysql_error() . "<br/><b>$R_Sql</b>");
					} else {
						$ReturnVal = true ;
						switch( $type ) // 0 = select, 1 = insert auto increment, 2 = insert, delete, update
						{
							case '0' :   // select par défaut
							{
								$this->_nbLines = $RS->numRows();
								if( $label != '' and  $this->_nbLines > 1  )
								{
										$this->_err = "Erreur: requete :<br> ' $R_Sql' <br>avec demande label = '$label'  " ;
										$ReturnVal = false ;
								} else {
									if( $label != '' )  // recup d'une valeur simple
									{
										$T_tmp = $RS->fetch(SQLITE_ASSOC);
										$this->_result = $T_tmp[$label] ;
									}  else { 
										// requete select et tableau de valeur
										if ( $this->_nbLines > 0 )
										{
											$i = 0 ;
											while( $T_tmp = $RS->fetch(SQLITE_ASSOC) )  // ne renvoie qu'un tableau associatif
											{
												$this->_result[$i] = $T_tmp ;
												$i++ ;
											} // while 
										} // row > 0
									} // if label != ''
								}	 // if label et row != 1
								break ;
							}
							
							case '1' :  // insert avec auto increment 
							{
								$this->new_id = $this->_cnx->lastInsertRowId() ;  // on renvoi l'id auto increment qui vient d'�tre cr��
								break ;
							}
							
							case '2' :  // insert (normal), update, delete
							{ 
								$this->_nbLines = $this->_cnx->changes() ;
								break ;
							}
						
							default :
							{
								$ReturnVal = false ;
								$this->_err = "type requete $type non valide <br> requête : $R_Sql ". mysql_error()."</b></p>" ;
							}
							
						} // switch type 
					} // if $RS
					break;
					} // case sqllite
				default : {
					//die('Err driver bdd inconnu');
					throw new Exception("DbfuncLib::_execSql() driver BDD inconnue " . $this->_driver);
					break ;
				}
			} // switch serveur
			$this->_lastQuery 		= 		$R_Sql ;  // on garde la dernière requete exécutée pour debug par exemple
		} // if cnx 
		return $ReturnVal ;
	} // M_ExecSql 
	
	
	private function _mysqlConnect( $h , $l , $p , $d )  // connexion à un serveur MySQL
	{
		// connexion bdd
		if(  ! $cnx = @mysql_connect( $h, $l, $p) ) 
		{
			//die ( "Connexion impossible: (L:$l, P:$p , H:$h )<p>Erreur Mysql => <b>". mysql_error()."</b></p>" ) ;
			throw new Exception("DbfuncLib::_mysqlConnect() login ou mot passe incorrect <br/>".mysql_error());
		}
		// selection de la base
		if( !@mysql_select_db( $d , $cnx ) )
		{
			//die ( "Erreur sélection base Mysql : $b <p>Erreur Mysql => <b>". mysql_error()."</b></p>") ;
			throw new Exception("DbfuncLib::_mysqlConnect()  BDD introuvable <br/>". mysql_error());
		}
		return  $cnx ;
	} // MysqlConnect
	
	private function _sqlliteConnect($dbFile)
	{		
		$cnx = new SQLiteDatabase($dbFile);
		if( !$cnx ) //error
		{
			throw new Exception("DbfuncLib::_sqlLiteConnect() error $dbFile") ;
		}
		return $cnx;
	} // _sqllisteConnect()
	

	/**
     * Creation d'un table SQL,
     * le schema est contenu dans config/schemaDb.ini
     * 
     * @param aray $pTableSchema  schema de la table
     * 
     */
	public function _createTable($pTableName,$pTableSchema)
	{
		if(is_array($pTableSchema))
		{
			switch($this->_driver) {
				case 'mysql' :  $this->_createTableMysql($pTableName,$pTableSchema); break;
				case 'sqllite' : break;
			}
		}	
	}
	
	
    protected function _createTableMysql($pTableName,$pTableSchema)
    {
    	$final = array();
    	$currentCol = null;
		// création de la table à partir du schema
		foreach($pTableSchema as $row=>$val) // chaque ligne
		{
	  		$name = explode('.',$row);  // nom.attribut
	  		$attrib = $name[1];
	  		if( $currentCol != $name[0] )
	  		{
	  			if($currentCol != null) $final[$currentCol] = $colData ; 
	  			$colData = array('null'=>false,'autoincrement'=>false) ;
	  			$currentCol = $name[0];
	  			$colData[$attrib] = $val ;
	  		} else {
	  			$colData[$attrib] = $val ; 
	  		}
	  	}
	  	$final[$currentCol] = $colData ; 
			  	
	  	foreach($final as $col=>$attribs)
	  	{
	  		$sql = " `$col` {___TYPE___}" ;
	  		$a=0;
	  		foreach( $attribs as $name=>$val)
	  		{
	  			switch($name) {
	  				case 'type': $sql = str_replace ('{___TYPE___}',$val,$sql); $a++; break;  // obligatoire
	  				case 'default': 
	  					switch($val) {
			  						case 'NULL' : $sql .= " DEFAULT NULL " ; break;
			  						case 'CURRENT_TIMESTAMP' : $sql .= " DEFAULT CURRENT_TIMESTAMP" ; break;
				  						default: $sql .= " DEFAULT '$val' " ; 
				  					} 
				  					break ;
	  				case 'autoincrement': $sql .= ($val==1)? " AUTO_INCREMENT" : '' ; break;
	  				case 'commentaire': $sql .= " COMMENT `$val`"; break;
	  				case 'null':  $sql .= ($val == 1)? ' NULL' : ' NOT NULL'; break ;
	  				case 'primary': $sql .= " PRIMARY KEY"; break;
	  				case 'index': if( $val == 1 ) { $index[] = " INDEX ( `$col` )"; } ;break;
	  				case 'unique':if( $val == 1) { $index[] = " UNIQUE (`$col`)" ; } break;
	  			}
	  		}
	  		// check si attrib TYPE fourni
	  		if($a>0)
	  		{ 
	  			$a=0;
	  			$cols[] = $sql;
	  		} 
		}
		$cols = implode(",\n",$cols) ; 
		if( count($index)>0) $cols .= ",\n". implode(",\n",$index);
		$createSql = str_replace('{___COLS___}',$cols, SQL_CREATE_TABLE);
		$createSql = str_replace('{___TABLE___}',$pTableName,$createSql);
		// création de la table SQL
		$this->execSql($createSql,'',2);
    }
    	
    /** a tester */
     public function dumpMySQL($serveur, $login, $password, $base, $mode)
     {
         $connexion = mysql_connect($serveur, $login, $password);
         mysql_select_db($base, $connexion);

         $entete = "-- ----------------------\n";
         $entete .= "-- dump de la base ".$base." au ".date("d-M-Y")."\n";
         $entete .= "-- ----------------------\n\n\n";
         $creations = "";
         $insertions = "\n\n";

         $listeTables = mysql_query("show tables", $connexion);
         while($table = mysql_fetch_array($listeTables))
         {
             // si l'utilisateur a demandé la structure ou la totale
             if($mode == 1 || $mode == 3)
             {
                 $creations .= "-- -----------------------------\n";
                 $creations .= "-- creation de la table ".$table[0]."\n";
                 $creations .= "-- -----------------------------\n";
                 $listeCreationsTables = mysql_query("show create table ".$table[0], $connexion);
                 while($creationTable = mysql_fetch_array($listeCreationsTables))
                 {
                   $creations .= $creationTable[1].";\n\n";
                 }
             }
             // si l'utilisateur a demandé les données ou la totale
             if($mode >= 1)
             {
                 $donnees = mysql_query("SELECT * FROM ".$table[0]);
                 $insertions .= "-- -----------------------------\n";
                 $insertions .= "-- insertions dans la table ".$table[0]."\n";
                 $insertions .= "-- -----------------------------\n";
                 while($nuplet = mysql_fetch_array($donnees))
                 {
                     $insertions .= "INSERT INTO ".$table[0]." VALUES(";
                     for($i=0; $i < mysql_num_fields($donnees); $i++)
                     {
                       if($i != 0)
                          $insertions .=  ", ";
                       if(mysql_field_type($donnees, $i) == "string" || mysql_field_type($donnees, $i) == "blob")
                          $insertions .=  "'";
                       $insertions .= addslashes($nuplet[$i]);
                       if(mysql_field_type($donnees, $i) == "string" || mysql_field_type($donnees, $i) == "blob")
                         $insertions .=  "'";
                     }
                     $insertions .=  ");\n";
                 }
                 $insertions .= "\n";
             }
         }

         mysql_close($connexion);

        $name = "backup/sauv-$base-".date("Y-M-d").".sql";

         $fichierDump = fopen($name, "wb");
         fwrite($fichierDump, $entete);
         fwrite($fichierDump, $creations);
         fwrite($fichierDump, $insertions);
         fclose($fichierDump);
     }
}	


