<?php
/*
Copyright (C) 2010 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

###################################################################
 * 
 *  03/01/10 : formatMoney()
 *  
 *  08/07/10 -	validFloat(), validInt(), formatFloat()
 *  
 *  
 */
 
 class NumbersLib
 {
 
 	public function formatMoney($pVal,$pFormat = 1 )
 	{
		switch($pFormat)
		{
			case 1 : $val = number_format($pVal,2,'.',' '); break;
         case 2 : $val = number_format($pVal,2,'.',''); break;
		}
		return $val;
 	}
 	 	
 	public function formatFloat($pVal)
 	{
 		$val = str_replace(',','.',$pVal);
 		return floatval($val);	
 	}
 		
 	
 	/* true si la valeur reçu est un float  avec 2 decimals
 	 * et compris entre min et max
 	 * >= min et <= max
 	 */
 	public function validFloat($pVal,$min,$max)
 	{
 		$valid 	= false;
 		$pVal 	= str_replace(',','.',$pVal); // accepte , et . comme séparateur décimal
 		$result	= array();
		$regex 	= "/[0-9]*\.?[0-9]?[0-9]?/";
		if( preg_match( $regex ,$pVal,$result) )
		{
			// controle si tous les chr sont valides et le min et max
			if( strlen($result[0]) == strlen($pVal) and floatval($pVal) >= $min and floatval($pVal) <= $max)
			{
				$valid = true;
			}
		}
 		return $valid;
 	}
 	
 	/* true si la valeur est un int et 
 	 * >=$min et <=$max
 	 */
 	public function validInt($pVal,$min,$max)
 	{
 		$valid 	= false ;
 		$result	= array();
		$regex 	= "/[0-9]*/" ;
		if( preg_match( $regex ,$pVal,$result) )
		{
			// controle si tous les chr sont valides et le min et max
			if( strlen($result[0]) == strlen($pVal) and $pVal >= $min and $pVal <= $max)
			{
				$valid = true ;
			}
		}
 		return $valid ;
 	}
 	
}
 
