<?php 
/*
Copyright (C) 2009 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

###################################################################
 * 
 * MyMVC Validators for models
 * 12/12/09
 * 
 * 13/12/09 - MyMVC_ValidorInt(), String(), Date()
 * 14/12/09 - MyMVC_ValidatorFloat()
 * 20/03/14 - utilisation de filter_var($val, FILTER_VALIDATE_FLOAT)
 * 16/09/14 - fix bug preg dans valid email, pb avec le char -
 * 
 * 
 * TODO make a static class to clean code
 * 
 * 
 */

/**
 * 11/03/13
 * 
 * Vérifie si $pVal contient uniquement des caractères présents dans pattern
 * 
 * 
 * @param string $pVal
 * @param string $pattern
 * 
 * 
 */
function MyMVC_ValidatorPattern($pVal,$pattern)
{
   if( $pVal!='' and $pattern!='')
   {
      $l = strlen($pVal);
      for($i=0;$i<$l;$i++)
      {
         $c = substr($pVal,$i,1);
         if( strpos($pattern,$c)===false ) // caractère non trouvé dans pattern
         {
            return false; // non valide
         }
      }
      return true; // ok
   }
   return false; // err param
}


// format :  day : dd, month: mm, year: yy or yyyy
// exemple : dd/mm/yy   yyyy-mm-dd  ddmmyy 
function MyMVC_ValidatorDate($pVal,$pFormat)
{
	$valid = false ;
	$l = strlen($pVal);
	$lf = strlen($pFormat);
	if( $l == $lf )
	{
		$d = strpos($pFormat,'dd') ;
		$m = strpos($pFormat,'mm');
		$y = strpos($pFormat,'yyyy');
		$ly = 4 ; // length year
		if( $y === false)
		{
			$y = strpos($pFormat,'yy') ;
			$ly = 2 ;
		}
		if( $d !== false) $day = substr($pVal, $d,2);
		if( $m !== false) $month = substr($pVal,$m,2);
		if( $y !== false) $year = substr($pVal,$y,$ly);
		if( @checkdate($month,$day,$year) ) $valid = true ;
		
	}	
	return $valid;
}

/**
 * Valid float number with . or , as decimal separator
 *
 * @param string $pVal
 * @return bool
 * 
 */
function MyMVC_ValidatorFloat($pVal)
{
	$regex = "/\d*\.?\d*/";//\.?[0-9]?[0-9]?" ;
   return filter_var($pVal,FILTER_VALIDATE_FLOAT);
	
   /*if( preg_match( $regex, $pVal))
	{
		$valid = true; 
	} else {
		$valid = false;
	}
	return $valid ;*/
	/*
	$valid = false;
	$nums = "0123456789.," ; //valid chrs
	$l = strlen($pVal);
	$ic=0;
	//echo " - $l - $pVal" ;
	if( $l>0 ) 
	{
		for($f=0;$f<$l;$f++)
		{
			if( strpos($nums, substr($pVal,$f,1) ) === false )
			{
				$ic++; // invalid chr 
			}
			//echo substr($pVal,$f,1).'<br>';
		}
		if($ic==0) $valid = true ;
	}
	return $valid ;*/
}


function MyMVC_ValidatorEmail($pEmail)
{
	$valid = true ;
	$okChar = "abcdefghijklmnopqrstuv_.-@";
	for($i=0;$i<strlen($pEmail);$i++) {
		if( strpos($okChar,substr($pEmail,$i,1)) === false ) {
			$valid=false;
			break;
		} 
	}
	/*
	$regexp = "/^[^0-9][A-z0-9_]+([.][\-][A-z0-9_-]+)*[@][A-z0-9_]+([.][A-z0-9_-]+)*[.][A-z]{2,4}$/";
	if (preg_match($regexp, $pEmail)) {
    $valid = true ;
	} else {
    $valid = false ; 
	}*/
	return $valid ;
}


function MyMVC_ValidatorInt($pVal)
{
	$valid = false;
	$nums = "0123456789" ; //valid chrs
	$l = strlen($pVal);
	$ic=0;
	//echo " - $l - $pVal" ;
	if( $l>0 ) 
	{
		for($f=0;$f<$l;$f++)
		{
			if( strpos($nums, substr($pVal,$f,1) ) === false )
			{
				$ic++; // invalid chr 
			}
			//echo substr($pVal,$f,1).'<br>';
		}
		if($ic==0) $valid = true ;
	}
	return $valid ;
}

function MyMVC_ValidatorString($pVal)
{
	$valid = false ;
	if( $pVal != '' and is_string($pVal))
	{
		$valid = true ;
	}
	return $valid;
}

?>