<?php
/*
Copyright (C) 2011 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

#################################################################

 * Class model 
 * 
 * 06/10/07 - fic bug  default primaryKey = "id" ;
 * 07/10/07 - unserialize dans _afterReadfunc, constantes relations
 * 17/10/07 - modif appel class DbQuery() pour utiliser myMVC->dbConfig
 * 13/07/09 - new version from scratch for mymvc 1.0b
 * 27/07/09 - find()
 * 01/09/09 - setHasOne(), add pForeignCol param, $_keyAutoIncrement, $_keyGenFunc, $setPrimaryKeyGenFunc()
 *          - create()
 * 04/09/09 - getLastError(), _lastError(); create();
 * 02/10/09 - check logSQL config to log sql querys
 * 07/11/09 - _isValid() and _isDeletable() 
 * 13/11/09 - $lastQuery =>  $_lastQuery
 * 06/01/10 - _setFormatAspect(), _formatAspect
 * 07/01/10 - nettoyage code, ajout _ au methode
 * 15/01/10 - nbLignes =>  _nbLines, supp $this->_showError() => throw new exception(..)
 * 20/01/10 - nbLines, _lastQuery, _log(), _getDbQuery()
 * 31/01/10 - add prefix to _table
 * 03/02/10 - _addSpecialCol(), _specialCols array
 * 10/03/10 - fix bug PREFIX table name in _hasOne()
 * 17/03/10 - _applyReadWriteFunc  permet de désactiver les fonctions afterRead et beforeWrite
 * 18/03/10 - _updateCollection($where,$colsValues)
 * 20/03/10 - _setWhere()
 * 23/04/10 - fix bug _count() nom table, maj _delete() 
 * 29/04/10 - _addSerializedCol()
 * 30/04/10 - _setWhere()   ajout concatenation pour filtre multiple, _resetWhere(), _getWhere()
 * 					- suppression autoload => deplacement dans mymvc.class.php
 * 18/05/10 - ajout defautlValue pour _create()
 * 15/06/10 - modif valeur retournée par isValid() => '' au lieu de true
 * 09/07/10 - _sum()
 * 06/09/10 - _setSelect(), $_defaultSelect, _setFrom(), $_defaultFrom
 * 04/10/10 - ajout _groupBy();
 * 08/03/11 - _update($key, $data) pour mettre à jour un rec rapidement
 * 01/04/11 - _createTable()
 * 09/03/12 - modif test rech table, pour comparer en lowercase
 * 08/04/12 - ajout $_sqlCreateTable pour automatiser la création des tables
 * 02/07/12 - integration de "CREATE TABLE IF NOT EXISTS" dans la fonction _createTable()
 * 10/09/12 - appel _updateSpecialCols()  dans _getResult()
 * 03/12/12 - fix _sum() pour utiliser _from et non _table 
 * 05/12/12 - Suppression test $val!='' dans _beforeWriteFunc() pour permettre le formattage d'un champ vide
 * 14/12/12 - remplacement de _setFormatAspect() par _setAspect(), et _formatAspect par _aspect
 * 17/12/12 - fix bug recherche liste des tables dans la registry
 * 18/12/12 - retourne valeur 0 si aucun résultat pour _sum()
 * 21/12/12 - ajout de _maxValue() et _minValue()
 * 02/01/13 - utilisation de fonctions globale  beforeWrite() et afterRead() au lieu de fonction spécifiques à chaque colonne
 * 08/01/13 - _findWhere($where), ajout $userPrefix=true dans le construteur pour pouvoir utiliser des tables globales
 * 15/02/13 - _create(), ajout valeur null pour toutes les colonnes pour avoir un vrai dbObject vide
 * 25/02/13 - modif _update() pour ne pas utiliser de dbObject mais directement dbQuery() poru faire un update simple
 * 26/02/13 - _getColValue($col,$where);
 * 07/03/13 - _reset(), _resetSelect(), _resetFrom(), _resetGroupBy(), _resetOrder(), _resetLimit(), _resetOffset()
 * 11/03/13 - _createTable(), simplification du traitement requete SQL CREATE TABLE ... IF NOT EXIST, meilleurs perf
 * 26/03/13 - Maj __createTable() pour exécuter initTable uniquement lors de la création de la table
 * 10/04/13 - Optimisation _findAllArray() et _getResult(), _afterReadFormat()
 * 12/04/13 - ajout param $log dans _directQuery() pour ne pas logger les requetes SQL de log !
 * 18/04/13 - Mise à jour defaultFrom et defaultSelect dans _setHasOne() si param $updateDefault = true 
 * 24/04/13 - fix bug _reset...() pour fixer valeur null et non ''
 * 03/06713 - _appendToSelect() 
 * 16/10/13 - _findAllArrayIndexed(), _deleteCollection($where)
 * 24/01/14 - _getTrad($texteId)
 * 18/02/14 - ajout erreur 'non trouvé' avec trad si find ne trouve rien
 * 20/02/14 - optimisation _getResult() , renommage en __getResult()
 * 25/02/12 - ajout _addDebug()
 * 04/03/14 - suppr _getTrad()
 * 05/03/14 - ajout test si condition != '' dans _makeSqlWhere()
 * 14/03/14 - remplace $this->__log par MyMVC::_getInstance()->_log
 * 20/03/14 - fix bug dans _getColValue()
 * 20/03/14 - ajout afterSave() pour éviter erreur retro compatibilité avec ancien model
 * 07/04/14 - beforeSave(), permet d'effectuer des contrôles avant de sauvegarder les données
 * 18/04/14 - Utilisation de MyMVC_ERROR pour stocker les erreurs
 * 1.0.3
 * 15/05/14 - ajout $pType à _setHasOne() pour autoriser la création de relation LEFT JOINT (par défaut), RIGHT JOIN et INNER JOIN
 * 26/05/14 - ajout _log() pour permetre de logger depuis le modele directement 
 * 26/05/14 - _findWhere($where,$options) ajout $option pour ajouter des options a la requete SQL (ORDER BY)
 * 1.0.4
 * 27/05/14 - _setHasOne() $pType = 'left' par défaut
 * 01/05/14 - instanciation model dans _setHasOne() pour le cas ou la table n'existe pas encore
 * 02/05/14 - Appel initTable() apres création de la table 
 * 1.0.5
 * 03/06/14 - Ajout return false ou nb ligne supprimées dans _deleteCollection($where)
 * 04/06/14 - _deleteCollection(), return true si ok, _nbLines contient le nb de lignes supprimées
 * 1.0.6
 * 10/06/14 - Ajout log debug pour chaque fonction
 * 11/06/14 - _listArrayOf
 * 20/06/14 - ajout log SQL dans _count()
 * 26/06/14 - _storeValue() et _getValue()
 * 27/06/14 - _getResult() return null (au lieu de '') si pas de résultat
 * 30/06/14 - Ajout _regsitry pour permetre l'accès a la registry depuis les classes model
 * 06/10/14 - Ajout Log _directQuery()
 * 17/10/14 - Mise à jour isValid() pour eviter erreur Strict
 * 20/10/14 - Mise à jour traduction
 * 
 * 
 * 
 * TODO:
 * 
 * add methods to do somme special query like
 * posibility to set select and from statement to make special sql query
 * ex  select max(x) as MAX from xxx ....
 * 
 * possibilite de passer un array pour _setOrder() { col1=>desc|asc, col2=>desc|asc...}
 * 
 * pouvoir créer des where complexe avec des OR et AND 
 * _setWhere()  ajout param  groupe pour regrouper entre parenthése certaines conditions
 * possibilité également de préciser OR (AND par défaut)
 * 
 * _setDateCol(colName)
 *  
 */

define ('MyMVC_MODEL_VERSION','1.06');  // 27/05/14


class MyMVC_Model {
	
	public $_name									= null;
	public $_key									= null;
	public $_keyAutoIncremente		= null;
	public $_keyGenFunc						= null;			// func to create a key when not autoincremented
	public $_table								= null;
	public $_tableStruct					= null;
	public $_dbConfig							= null;
	//public $_lastError						= null;
	 
	public $_serializedCols				= array() ;	// format cols before write or after read
	public $_defaultValueFuncs 		= array() ;
	public $_applyReadWriteFunc		= true ;		// apply afterReadFuncs and beforeWriteFuncs by default
	public $_specialCols ; 
	public $_lastQuery						= null;			// last executed query
	public $_nbLines							=	0 ;				// nb modified lines by last query
	public $_sqlCreateTable ;									// code SQL pour créer la table si besoin
	
	private $_select					= null ;		// sql part to make the final query
	private $_defaultSelect		= null ;
	private $_from						= null ;
	private $_defaultFrom			= null ;
	private $_where						= null ;
	private $_limit						= null ;
	private $_offset					= null ;
	private $_order						= null ;
	private $_groupBy					= null ;
	//private $_join						= null;			// jointure entre table 
	private $_aspect					= null ;		// default aspect for afterRead funcs
	public $_registry					= null; // object registry

	/**
	* constructor
	*
	* @param string $pTable
	*/
	public function __construct($pName = null, $usePrefix=true) {
		$this->_dbConfig = MyMVC_Config::_getInstance()->dbConfig ;
		if( $pName != null ) {
			if($usePrefix) {
				//echo " $pName - ".$this->_dbConfig['prefix'];
				 $this->_table 	= $this->_dbConfig['prefix'].$pName ;
			} else {
				 $this->_table 	= $pName ;
			}
			$this->_name = get_class($this);
		} else 	{
			throw new Exception('Error MyMVC_Model::__construct() invalide table name');
		}
		$this->_select = $this->_table.'.*' ;
		$this->_from = $this->_table ;
      
		// check si la table existe, sinon tente de la créer avec les infos dans config/schemaDb.ini	
		$this->__createTable();
		
		// load table struct
		$this->__loadStructure() ;
		$this->_specialCols = array();
		$this->_defaultSelect = $this->_select; // backup du select par défaut
		$this->_defaultFrom = $this->_from ; // idem pour le from
		$this->_registry = MyMVC_Registry::_getInstance();
	}
  
	/** stockage de variable globale pendant l'exécution du script uniquement */
	public function _storeValue($pName,$pValue) { MyMVC::_getInstance()->_storeValue($pName,$pValue); }
	/** récupération de variable globale */
	public function _getValue($pName) { return MyMVC::_getInstance()->_getValue($pName); }
	
	/** ajoute un texte a afficher dans la zone debug */
	public function _addDebug($pTexte) { MyMVC::_getInstance()->__addDebug($pTexte); }
  
	public function _log($pMessage) {
		MyMVC::_getInstance()->_log(MYMVC_INFO,$pMessage);
	}
	
	
	/**
	 * Retourne un tableau avec la liste des valeurs de $pCols
	 * extraites du tableau de dbOjects $pDbObjects
	 */
	public function _listArrayOf($pCol, array $pDbObjects) {
		$liste = array();
		if( $pCol != '' ) {
			foreach($pDbObjects as $one) {
				//echo('-'.$one->$pCol);
				$liste[] = $one->$pCol;
				// @TODO check if $one is a dbOject
			}
		}
		return $liste;
	}
	
	
	/**
	 * 03/06/13
	 * 
	 * Ajoute une colonne calculée dans le code SQL de la requête
	 * C'est le code SELECT de la requete qui est modifié
	 * ex:  prixTotal=qt*prixUnitaire
	 * La valeur _defaultSelect n'est pas modifiée
	 *  
	 * @param string $pCol
	 * @param string $pSql
	 * 
	 */
	public function _addCalculatedCol($pCol,$pSql) {
		if( $pCol != '' and $pSql!='') {
			 $this->_select .= ",$pCol=$pSql";
		}
	}
   
	/****   ##########  methode public   ###########   */

	/**
	* Mise à jour d'un objet en base 
	* 
	* @param int/string $pKey
	* @param array $pData  col=>Val
	* 
	* @return boolean
	*/
	public function _update($pKey, $pData) {
		if(!is_array($pData)) {
			$this->_setError(MyMVC::getTrad('mymvc_Model_update_parametreDataIncorrect'));
		}
		$execOk = false ;
		$dbObject = $this->_find($pKey);
		//d($dbObject);
		if( $dbObject != null ) {
			$i=0; //nb de col modifiées
			foreach($pData as $c=>$v) {
				if(array_key_exists($c,$this->_tableStruct) ) // ne garde que les col de la table
				{
					$dbObject->$c = $v ;// remplace valeur
					$i++;
				}
			}
			if( $i>0 )
			{
				$dbObject->_isModified = true;
				//d($dbObject->_toArray());
				if( !$dbObject->_save() )
				{
					//$this->_setError($dbObject->_getErrors());
				} else {
					$execOk = true;
				}
			}
		}
		return $execOk; 
	}	
	
	/**
    * 
	 * Ajoute une colonne 'virtuelle' 
    * 
    * Cette colonne et sa valeur ne seront pas enregistrées en base
	 *
	 * @param string $sColName  		nom de la colonne virtuelle
	 * @param string $sMethodeName   methode du model 			
	 * 
	 */
	public function _addSpecialCol($sColName, $sMethodeName)
	{
		$this->_specialCols[$sColName] = $sMethodeName ;
	}
	
	/**
	 * Permet de gérer un colonne dont le contenu est sérialisé en base
	 * le model s'occupe de désérialiser après lecture 
	 * et de sérialiser avant écriture
	 *
	 * @param string $pColName
    * 
	 */
	public function _addSerializedCol($pColName)
	{
		$this->_serializedCols[] = $pColName ;
	}
	
   /**
    * 
    * Définit l'Aspect de l'objet.
    * Cette valeur peut être ensuite utilisée dans les fonctions de convertion ( AfterRead...)
    * pour effectuer des transformations spécifiques.
    * 
    * @param string $pFormatAspect
    * 
    */
	public function _setAspect($pAspect)
	{
		$this->_aspect = $pAspect ;
	}
	
   
   /**
    * Active ou désactive les fonctions AfterRead et BeforeWrite sur les objets
    * lu et ecrit en BDD
    * 
    * @param bool $pBool
    * 
    */
	public function _setApplyReadWriteFunc($pBool)
	{
		$this->_applyReadWriteFunc = $pBool  ;
	}
	
	/**
	 * Retourne le dernier message d'erreur du model
	 * 
	 * @return string  error message
	 *
	 */
	public function _getLastError() { return MyMVC_ERROR::_getInstance()->_getLastError(); }
	
   /**
    * Permet d'enregistrer une erreur
    * @param string $pError
    * 
    */
	public function _setError($pError) { MyMVC_ERROR::_getInstance()->_addError($pError); }
	
   /**
    * Méthode magique appeler si une méthode inconnue est spécifiée
    * 
    * @param string  $pMethodeName
    * @param array $pParams
    * @throws Exception
    * 
    */
	public function __call($pMethodeName, $pParams) {
		throw new Exception("MyMVC_Model call to unknown method : $pMethodeName");
	}
	
	/**
    * définit le contenu du SELECT dans la requete SQL 
    * 
    * @param string $pSelect
    * 
    */
	public function _setSelect($pSelect = null) {
		if( $pSelect == null) {
			$this->_select = $this->_defaultSelect;
		} else {
			$this->_select = $pSelect;
		}
	}
	
	/** 03/06/13
    * 
    * Ajout direct de code SQL dans la clause SELECT du model
    * La valeur _defaultSelect n'est pas modifiée
    * 
    * @param string $pSql
    * 
    */
	public function _appendToSelect($pSql = null, $setDefault=false){
		if($pSql != null and $pSql != '') {
			$this->_select .= ",$pSql";
			if($setDefault) $this->_defaultSelect = $this->_select;
		}
	}
	
	/* 
	* 28/02/13
	* 
	* Définit le contenu du FROM dans la requete SQL 
	* si $append=true, la clause est ajouté au FROM existant
	* 
	* @param string $pFrom
	* @param bool  $append
	* 
	*/
	public function _setFrom($pFrom = null, $append = false) {
		if( $pFrom == null) {
			$this->_from = $this->_defaultFrom;
		} else {
			if($append) {
				$this->_from .= ' '.$pFrom ;
			} else {
				$this->_from = $pFrom ;
			}
		}
	}
	
	/** définit la clause LIMIT pour SQL */
	public function _setLimit($pLimit) {
		if( $pLimit>0 ) $this->_limit = $pLimit ;
	}
   
	/** définit la clause OFFSET pour SQL */
	public function _setOffset($pOffset) {
		if($pOffset>0) $this->_offset = $pOffset ;
	}
	
	/**
	 * 
    * Définit la clause ORDER pour SQL
	 *
	 * @param string $pOrder
	 * 
	 */
	public function _setOrder($pOrder) {
		if($pOrder != '') $this->_order = $pOrder ;
	}
	
   /** Définit la clause GROUP BY pour SQL */
	public function _setGroupBy($pGroupBy) {
		if($pGroupBy != '') $this->_groupBy = $pGroupBy;
	}
	
	
	/**
	 * def des conditions WHERE qui seront utilisées 
	 * par _findAll() etc...
	 * 
	 * @param string $where
	 * 
	 */
	public function _setWhere($where) {
		if($where!='') 
		{
			if( $this->_where != '' )
			{
				$this->_where .= " AND ($where)";
			} else {
				$this->_where = "($where)";
			}
		}
	}
	
	/** raz des clauses SQL */
	public function _resetWhere() { $this->_where = '' ; }
	public function _resetSelect() { $this->_select = $this->_defaultSelect ; }
	public function _resetFrom() { $this->_from = $this->_defaultFrom ; }
	public function _resetGroupBy() { $this->_groupBy = '' ; }
	public function _resetOrder() { $this->_order = null ; }
	public function _resetLimit() { $this->_limit = null ; }
	public function _resetOffset() { $this->_offset = null ; }
	
	/** RAZ global de toutes les variables SQL */
	public function _resetSql() {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_resetSql()',MYMVC_LOG);
		$this->_resetFrom();
		$this->_resetGroupBy();
		$this->_resetLimit();
		$this->_resetOffset();
		$this->_resetOrder();
		$this->_resetSelect();
		$this->_resetWhere();
	}	
   
   /**
    * Remise à zéro de tous les params
    * reprend le SELECT et le FROM par défaut
    * 
    */
   public function OFF_reset() {
		$this->_where		= '';
		$this->_groupBy = '';
		$this->_order		= null;
		$this->_from		= $this->_defaultFrom;
		$this->_select	= $this->_defaultSelect ;
		$this->_limit		= null;
		$this->_offset	= '';
   }
   
	/** Lecture du WHERE */
	public function _getWhere() { 
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_getWhere()',MYMVC_LOG);
		return $this->_where ;
	}
	
	/**
	* set primary key, 
	*
	* @param string $pKey
	* @param unknown_type $pAutoIncremente
	*/
	public function _setPrimaryKey($pKey, $pAutoIncremente = true ) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_setPrimaryKey()',MYMVC_LOG);
		//if( $pKey != 'login' and $pKey != 'id_compte' and $pKey != 'id_operation' 
		//        and $pKey != 'id_budget' and $pKey != 'id_typeop') d($pKey);
		$this->_key = $pKey ;
		$this->_keyAutoIncremente = $pAutoIncremente ;
	}
	
	/**
	* set the local function to execute to get
	* a primary key before insert an row in db
	* only used when _keyAutoIncremente = false ;
	* the func must return a string/int value to store in db row
	* 
	* @param string $pFunc
	*/
	public function _setPrimaryKeyGenFunc( $pFunc = null) { 
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_setPrimaryKeyGenFunc()',MYMVC_LOG);
		$this->_keyGenFunc = $pFunc ;
	}
   
	/**
	 * Définit une relation de type N=>1
	 *
	 * @param string $pTable  nom de la table a lier
	 * @param string $pKey   nom de la colonne pour la relation (locale)
   * @param string $pForeignKey   nom de la colonne pour la relation ($pTable), =null si identique à $pKey
   * @param bool $updateDefault  si = true, le select et le from par défaut sont mis à jour
	 * @param string $pType, inner, right ou left (default = left) type de JOIN
	 * @param string $pType  inner|left|right  type de relation entre les deux tables
    *
	 */
	public function _setHasOne($pTable, $pKey, $pForeignKey=null, $updateDefault=true, $pType='left') {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_setHasOne()',MYMVC_LOG);
		if( $pTable == '' or $pKey == '') return; // ne fait rien si param incorrect
    $test = new $pTable(); // permet de créer la table si besoin  
		$pTable = $this->_dbConfig['prefix'].$pTable;
		switch($pType) {
			case 'inner' : $pType = "INNER";break;
			case 'right' : $pType = "RIGHT";break;
			default: $pType = 'LEFT';
		}
		if( $pForeignKey == null) { // les 2 colonnes pour la relation ont le même nom
			$this->_from .= " $pType JOIN $pTable USING ($pKey)" ;
		} else {
			$this->_from .= " $pType JOIN $pTable ON {$this->_table}.$pKey = $pTable.$pForeignKey " ;		
		}
		$this->_select .= ",$pTable.*" ;
		// mise à jour des valeurs par défaut
		if($updateDefault) {
			$this->_defaultFrom = $this->_from;		
			$this->_defaultSelect = $this->_select;
		}
		
	}
	
   /** 
	* 
	* Recherche la valeur max d'une colonne avec un filtre facultatif
	* 
	* @param string $col
	* @param string $where
	* 
	* @TODO:  utiliser _where global
	*/
	public function _maxValue($col,$where=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_maxValue()',MYMVC_LOG);
		$query = 'SELECT MAX('.$col.') AS max FROM '.$this->_table ;
		if( $where != null) $query .= ' WHERE '.$where ;
		$rs = $this->_directQuery($query);
		return intval($rs[0]['max']);
	}
   
   /** 
    * 
    * Recherche la valeur min d'une colonne avec un filtre facultatif
    * 
    * @param string $col
    * @param string $where
    * 
    * @TODO utiliser _where global
    * 
    */
	public function _minValue($col,$where=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_minValue()',MYMVC_LOG);
		$query = 'SELECT MIN('.$col.') AS min FROM '.$this->_table ;
		if( $where != null) $query .= ' WHERE '.$where ;
		$rs = $this->_directQuery($query);
		return intval($rs[0]['min']);
	}
	
	 /**
    * 30/05/13
    * Supprimer un ensemble d'enregistrement correspondant à la clause where
    * 
    * @param string $pWhere
    */
	public function __deleteCollection($pWhere = null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::__deleteCollection()',MYMVC_LOG);
		$res = false ;
		if( $pWhere != null)
		{
			$db = new MyMVC_DbQuery( $this->_dbConfig ) ;
			$res = $db->_deleteBySQl($this->_table, $pWhere);
			$this->_nbLines = $db->_getNbLines(); // nb lignes supprimées
			$this->_lastQuery = $db->_getLastQuery();
		} else {
			throw new Exception('MyMVC_Model::_deleteCollection() => erreur paramètre incorrect');
		}
		return $res;
	}
   
	 /**
		* Exécute un requete update sur plusieurs enregistrement (collection)
		* définit par le $where
		* log une erreur dans mymvc.log si les paramètres sont incorrects
		*
		* @param string $where
		* @param array $cols
		* 
		* @return bool
		* 
		*/
	public function _updateCollection($where=null, $cols=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_updateCollection()',MYMVC_LOG);
		//MyMVC::_getInstance()->_log(MYMVC_INFO,'--- updateCollection');
		$res = true ;
		if( $where != null and $cols != null) {
			// controle si valeur OK, methode isValid du model
			$obj = $this->_create($cols);
			if( !$obj->_validDbObject() ) {   
				$res = false;
				//$this->_lastError = $obj->_getErrors() ;
			} else {
				$db = new MyMVC_DbQuery( $this->_dbConfig ) ;
				$res = $db->_updateBySql($this->_table , $where, $cols);
				$this->_lastQuery = $db->_getLastQuery() ;
				MyMVC::_getInstance()->_log(MYMVC_SQL, $this->_lastQuery,MYMVC_LOG);

				if(!$res) {
					//$this->_lastError = 'Erreur appel MyMVC_DbQuery::_updateBySql()';
					MyMVC_ERROR::_getInstance()->_addError('Erreur appel MyMVC_DbQuery::_updateBySql()');
					MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_updateCollection() => erreur appel MyMVC_DbQuery::_updateBySql()',ERROR_LOG);
				}
				MyMVC::_getInstance()->_log(MYMVC_SQL,$db->_getLastQuery(),MYMVC_LOG);
			}  
		} else {
			// log error but no error in app 
			MyMVC::_getInstance()->_log(MYMVC_ERROR,'MyMVC_Model::_updateCollection() => erreur paramètre incorrect',MYMVC_LOG);
			throw new Exception('MyMVC_Model::_updateCollection() => erreur paramètre incorrect');
			$res = false;
		}
		return $res;
    }
   
   /**
	 * return count of record in db
	 * use $where condition if provided
	 * 
	 * @param string $where
	 * @return int
	 * 
	 */
	public function _count($pWhere=1)
	{	 	
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_count()',MYMVC_LOG);
		$db = new MyMVC_DbQuery( $this->_dbConfig );
		$ret = $db->_count($this->_from, $pWhere);
		$this->_lastQuery = $db->_getLastQuery();
		MyMVC::_getInstance()->_log(MYMVC_SQL,$db->_getLastQuery(),MYMVC_LOG);
		return $ret;
	}
	
	public function _getColValue($col,$where)
	{
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_getColValue()',MYMVC_LOG);
		if( $col == '' or $where == '') {
			// TODO log error
			$result = 0;
		} else {
			$this->_setLimit(1);
			$rs = $this->_findAll($where);
			if( $this->_nbLines != 1 ) {
				$result = '' ;
			} else {
				$result = $rs[0]->$col;
			}
		}
		return $result;
	}
   
   
	/**
	* Sum sur une colonne du modele 
	* avec un where optionnel
	* 
	* TODO 
	* 
	* Tenir compte de condition définies avec _setWhere(); ??
	* Check $pCol existe dans le model
	* 
	*/
	public function _sum($pCol, $pWhere=1)
	{
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_sum()',MYMVC_LOG);
		if( $pWhere == '' or $pCol == '') return 0;
		//if( $this->_where != '') $pWhere .= ' AND '.$this->_where;
		$db = new MyMVC_DbQuery( $this->_dbConfig );
		$rs = $db->_sum($this->_from, $pCol,$pWhere);
		if( $rs == '' ) $rs=0 ; // retourne 0 si aucun résultat
		MyMVC::_getInstance()->_log(MYMVC_SQL,$db->_getLastQuery(),MYMVC_LOG);
		$this->_lastQuery = $db->_getLastQuery();
		return $rs;
	}
	
	/**
	* direct query db, need a valid sql statement
	* 
	* @param string $pSql
	* @return array db result without reformat
	*/
	public function _directQuery($pSql, $log=false)
	{
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_directQuery()',MYMVC_LOG);
		$db = new MyMVC_DbQuery( $this->_dbConfig ) ;
		$result = $db->_query($pSql) ;
	 	$this->_lastQuery = $db->_getLastQuery() ;
	 	$this->_nbLines = $db->_getNbLines() ;
		// il faut désactiver le log pour SQL en DB sinon on créer une boucle sans fin !
		MyMVC::_getInstance()->_log(MYMVC_SQL, $db->_getLastQuery(), MYMVC_LOG);
	 	return $result;
	}
   
   /*   ##########  Méthodes privées  ######### */
  	
	/**
	* 
	* 26/03/13
	* 
	* Vérifie si la table existe, sinon tente de la créer 
	* exécute initTable() pour précharger des données dans la table si besoin
	* 
	*
	 * TODO check errors
	*/
	protected function __createTable() {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::__createTable()',MYMVC_LOG);
		$error = '';
		$rs = $this->_directQuery('SHOW TABLES LIKE "'.$this->_table.'"'); 
		if( count($rs)==0 ) { // table non trouvée
			if( $this->_sqlCreateTable!='') {
				$rs = $this->_directQuery('CREATE TABLE '.$this->_table.' '.$this->_sqlCreateTable);
				// chargement des données dans la table
				$this->initTable();
			} else {
				throw new Exception('Variable sqlCreateTable non définie dans le model : ' . $this->_name);
			}
		}
		//if( $error != '') { throw new Exception($error); }
		return true;
	}
	
	/**
	 * load model table structure from db
	 * check if cache is enabled, so read data from cache is available
	 * 
	 *  TODO :
	 *  get cached data instead of reading in DB 
	 * 
	 */
	private function __loadStructure() {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_loadStructure()',MYMVC_LOG);
		if( $this->_table == '' ) { // or $this->_key== '' )
			throw new Exception('Erreur MyMvc_Model class::_loadStruture() , incorrect params!');
		}
		
		$db = new MyMVC_DbQuery( $this->_dbConfig ) ;
		$res = $db->_getTableStruct($this->_table) ;    	
		if( $res === false  or count($res)==0 ) {
			 throw new Exception('Erreur MyMvc_Model class::_loadStruture() , error in query result !');
		}
		foreach( $res as $oneCol ) {
			// on garde les infos sur la stucture de la table
			$this->_tableStruct["{$oneCol['Field']}"] = array( 
				'Type'=>$oneCol['Type'],'Null'=>$oneCol['Null'], 'Key'=>$oneCol['Key'],
				'Default'=>$oneCol['Default'],'Extra'=>$oneCol['Extra'] );
		}
	}
		
	/**
	 * used to create an empty dbObject
	 * or an prefilled dbObject with pData
	 *
	 * @param array $pData
	 */
	public function _create($pData = null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_create()',MYMVC_LOG);
		// filtre les colonnes non présente dans la structure de la table
		//$data = array();
		/*foreach($pData as $c=>$v)
		{
			if(array_key_exists($c,$this->_tableStruct))
			{
				 $data[$c] = $v;
			}
		}*/
		// ajout des colonnes restante pour avoir un dbObject complet
		/*foreach( $this->_tableStruct as $oneCol=>$data)
		{
			 if( ! array_key_exists($oneCol, $data)) $n->$oneCol = '';
		}
		*/
      
		if( count($pData)>0 ) {
			$n = new MyMVC_DbObject($this, $pData); // fill dbObject with pData values
		} else {
			$n = new MyMVC_DbObject( $this ); // empty dbObject 
		}

		// apply default value
		if( count( $this->_defaultValueFuncs) > 0) {
			foreach($this->_defaultValueFuncs as $col=>$f) {
				if( $n->$col == null ) { // si valeur non defini on applique valeur par défaut
					$func = $f[0];
					switch($f[1]) {
						case true: 
							if(method_exists($this,$func)) {
								$n->$col = $this->$func($col);
							} else {
								throw new Exception('Méthode defaultValueFunc => <b>'.$func.'</b> non trouvée pour le model <b>'. $this->_name.'</b>');
							}
							break;
						case false:
							if(function_exists($func)) {  // fonction  
								$n->$col = $func($col);  
							} else {
								throw new Exception('Fonction defaultValueFunc => <b>'.$func.'</b> non trouvée pour le model <b>'. $this->_name.'</b>');
							}
							break;
					} // switch
				} // == null
			} // foreach
		} // if count
		return $n;
	}
	
   /**
    * 
    * Supprime un enregistrement à partir de sa clé primaire
    * 
    * @param Int / String  $pKey
    * @return boolean
    */
	public function _delete($pKey) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_Delete()',MYMVC_LOG);
		if($pKey != '') {
			$rec = $this->_find($pKey) ;
			if( $rec != null ) {
				if( !$ret = $rec->_delete()) { // si erreur _lastError contient l'erreur (voir methode isDeletable() du model)
					$this->_lastError = $rec->_errors[0] ; // recup dernière erreur sur dbObject
				}
			} else {
				$ret = false ;
				//$this->_lastError = 'Suppression impossible, enregistrement inéxistant';
				MyMVC_ERROR::_getInstance()->_addError(MyMVC::getTrad('mymvc_Model_suppressionImpossibleEnregistrementInexistant'));
			}
		} else {
			//$this->_lastError = 'Suppression impossible, id incorrect';
			MyMVC_ERROR::_getInstance()->_addError(MyMVC::getTrad('mymvc_Model_suppressionImpossibleErreurId'));
			$ret = false;
		}
		return $ret ;
	}
	
   /**
    * Supprimer un ensemble d'enregistrement 
    * filtrés par un WHERE
    * 
    * @param string $where
    * 
    */
	public function _deleteCollection($where=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_deleteCollection()',MYMVC_LOG);
		if($where!=null) {
			$liste = $this->_findAll($where);
			if($this->_nbLines>0) {
				foreach($liste as $one) {
					if(!$one->_delete()) {
						return false; // arrêt sur la première erreur
					}
				}
			}
		}
		return true;
	}
   
	/**
	 * Recherche 1 enregistrement à partir de la clé primaire
	 *
	 * @param string/int $pKey
	 * @return DbObject or Null
	 * 
	 */
	public function _find($pKey) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_find()',MYMVC_LOG);
		// protection des donnnées si magic_quote OFF
		if(!get_magic_quotes_gpc()) $pKey = addslashes($pKey);
		$ret = null ;
		$sql = $this->__prepareSql(SQL_FIND) ;
		$sql = str_replace('{WHERE}',  $this->_makeSqlWhere("{$this->_table}.{$this->_key}='$pKey'"), $sql);
		$sql = str_replace('{LIMIT}','limit 1',$sql) ;
		$sql = str_replace('{OPTION}','',$sql) ;
		$res = $this->__getResult($sql,false); // return an array of DbOjects
		if( $res != null ) {
			$ret = $res[0] ; 	// return 1st record found
		} else {
			//$this->_setError(MyMVC::getTrad('mymvc_enregistrementNonTrouve'));
			MyMVC_ERROR::_getInstance()->_addError(MyMVC::getTrad('mymvc_enregistrementNonTrouve'));
			$ret = null;
		}
		return $ret ;
	}
	
   /**
    * 
    * Recherche le premier enregistrement qui correspond
    * au Where, retourne null si aucun enregistrement trouvé
    * 
    * @param string $where
    * @return dbObject
    */
	public function _findWhere($pWhere,$pOptions='') {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_findWhere()',MYMVC_LOG);
		// protection des donnnées si magic_quote OFF
		$ret = null ;
		if( $pWhere != '') {
			$sql = $this->__prepareSql(SQL_FIND) ;
			$sql = str_replace('{WHERE}', $pWhere , $sql);
			$sql = str_replace('{LIMIT}','limit 1',$sql) ;
			$sql = str_replace('{OPTION}',$pOptions,$sql) ;
			$res = $this->__getResult($sql); // return an array of DbOjects
			if( $res != null ) {
				$ret = $res[0] ; 	// return 1st record found
			} else {
				$ret = null ;
			}
		}
		return $ret ;
	}
   
	/**
	 * find all record 
	 * return an array of dbObject
	 *
	 * @param string $pCondition
	 * @return array
	 * 
	 */
	public function _findAll($pCondition=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_findAll()',MYMVC_LOG);
	 	$sql = $this->__prepareSql(SQL_FIND) ;
	 	$sql = str_replace('{WHERE}',$this->_makeSqlWhere($pCondition),$sql);
	 	$sql = str_replace('{OPTION}', $this->_makeSqlOption() , $sql) ;
	 	return $this->__getResult($sql,false) ; // return an array of DbOjects
	}
	
   
   /**
    * 22/07/13
    * 
    * Return serach result in an array
    * the array key is the primary key of each record
    *  
    * @param string $pCondition
    */
	public function _findAllIndexedArray($pCondition=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_findAllIndexedArray()',MYMVC_LOG);
		$result = $this->_findAllArray($pCondition);
		$tmp = array();
		if($this->_nbLines>0) {
			foreach($result as $one) {
				$id = $one[$this->_key] ;
				//unset($one[$this->_key]);
				$tmp[$id] = $one;
			}
		}
		return $tmp;
	}
   
	/**
	 * return same result as findAll, except
	 * each  db row is in an associatif array
	 *
	 * @param string $pCondition
	 * @return array
	 * 
	 */
	public function _findAllArray($pCondition=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_findAllArray()',MYMVC_LOG);
    $sql = $this->__prepareSql(SQL_FIND) ;
	 	$sql = str_replace('{WHERE}',$this->_makeSqlWhere($pCondition),$sql);
	 	$sql = str_replace('{OPTION}', $this->_makeSqlOption() , $sql) ;
	 	return $this->__getResult($sql,true) ; // retour sous forme de tableau
    /*
	 	$r = $this->_findAll($pCondition);
	 	if( count($r) > 0)
	 	{
	 		$ar = array();
	 		foreach( $r as $one)
	 		{
	 			$ar[] = $one->_toArray(); // use toArray() func of dbObject to transform result
	 		}
	 	} else {
	 		$ar = null;
	 	}
	 	return $ar;*/
	}
	 
	/**
    * Définit le SELECT et le FROM pour la requete SQL en cours
    * 
    * 
    * @param string $pSql
    * @return string
    * 
    */ 
	protected function __prepareSql($pSql) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::__prepareSql()',MYMVC_LOG);
		$pSql = str_replace('{SELECT}', $this->_select , $pSql);
		$pSql = str_replace('{TABLE}' ,$this->_from , $pSql ) ;
		return $pSql ;
	}
   
   /**
    * Construit la clause WHERE
    * 
    * @param string $pCondition
    * @return string
    */
	protected function _makeSqlWhere($pCondition=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_makeSqlWhere()',MYMVC_LOG);
	 	$w = ' 1' ;
	 	// ajoute where du model
		if( $this->_where != null ) {
      $w = $this->_where ;
    } 
		// ajoute where optionel
		if( $pCondition !== null and $pCondition != '') {
			$w .= ' and '.$pCondition ;
		}
		return $w ;	 		
	}
		 
	/**
    * Construction des clause GROUP BY, ORDER BY, LIMIT et OFFSET
    * 
    * @param  $pOptions
    * @return type
    */	 
	protected function _makeSqlOption($pOptions=null) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_makeSqlOption()',MYMVC_LOG);
		$o = '' ;
		if( $this->_groupBy != '') $o .= ' GROUP BY '. $this->_groupBy ;
		if( $this->_order !== null ) $o .= ' ORDER BY '.$this->_order ;
		if( $this->_limit !== null ) {
			if( $this->_offset !== null ) {
				$o .= ' LIMIT '.$this->_offset.','.$this->_limit ;
			} else {
				$o .= ' LIMIT '.$this->_limit ;
			}
		}
		return $o;
	}

	/**
	 * Renvoie le résultat d'une requete SQL
    * sous forme de tableau ($toArray == true) 
    * ou de dbObject ($toArray == false) 
	 *
	 * @param string $pSql
    * @param bool  $toArray
    * 
	 * @return array
	 * 
	*/
	private function __getResult( $pSql, $toArray=false ) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::__getResult()',MYMVC_LOG);
	 	//$mymvc = MyMVC::_getInstance() ;
		$db = new MyMVC_DbQuery( $this->_dbConfig ) ;
		$res = $db->_query($pSql) ;
	 	$this->_lastQuery = $db->_getLastQuery() ;
	 	$this->_nbLines = $db->_getNbLines() ;
	 	$ob = null ;
		if( $this->_nbLines > 0 ) {
			MyMVC::_getInstance()->_log(MYMVC_SQL, $db->_getLastQuery().' => '.$this->_nbLines.' line(s) returned', MYMVC_LOG) ;
			$ob = array();
			// apply afterRead format
			for( $i=0 ; $i<$this->_nbLines ; $i++ ) {
				if( $this->_applyReadWriteFunc === true ) {
					$tmp = $this->__afterReadFormat($res[$i]);
				} else {
					$tmp = $res[$i];
				}
				$tmp = $this->__updateSpecialCols($tmp); // ajout colonne spéciales
				if( $toArray ) {
					$ob[] = $tmp; // retour sous forme de tableaux de valeurs
				} else {
					// renvoie un tableau d'objets
					$o = new MyMVC_DbObject($this,$tmp);
					$o->_setFromDb(true);
					$ob[] = $o ;
				}
				//d($ob);
			}
						
		} else {
			MyMVC::_getInstance()->_log(MYMVC_SQL, $db->_getLastQuery()." (lines=0)", MYMVC_LOG) ;
		}
	 	return $ob ; 
	}
      
   /*
	public function _getDbQuery()
	{
		return new MyMVC_DbQuery( $this->_dbConfig ) ;
	}
	*/
	
	/**
	 * set func to set default values to col
	 * used when create new object
	 * 
	 * @param string $pCol
	 * @param string $pFunc
	 * @param bool $pMethode
	 * 
	 */
	public function _setDefaultValueFunc($pCol, $pFunc, $pIsMethode = true ) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::_setDefaultValueFunc()',MYMVC_LOG);
		if( $pCol === null or $pCol == '' or $pFunc === null or $pFunc == '') {
	 		throw new Exception("MyMVC_Model::_setDefaultValueFunc() param incorrect(s) pFunc, pCol");
	 	}
	 	$this->_defaultValueFuncs["$pCol"] = array("$pFunc",$pIsMethode) ;
	}
	
	// méthodes qui peuvent être surchargées par les modèles
	public function initTable() {} // Exécuté une seule fois lors de la création de la table
	
	public function afterRead($data,$aspect) { return $data; } // formatage des données après lecture
	
	public function isValid($pColName , $pColsValues) { return '' ; }
	public function isDeletable($id) { return true ; }
	
	public function beforeDelete($pId) { return true; } // est exécutée avant un delete
	public function afterDelete(array $pRec) { return true; } // est exécutée après un delete
	
	//@TODO vérifier si beforeWrite et beforeSave ne fond pas doublon
	public function beforeWrite($data) { return $data;} // formatage des données avant enregistrement 
	public function afterSave(MyMVC_DbObject $dbObj) { return true; } 
	public function beforeSave(MyMVC_DbObject $dbObj) { return true; } // si false le save est annulé
		  
  //
	#############################################################################################
  /**
   * format a field from db with a custom function
   * 
  */
	private function __afterReadFormat($data) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::__afterReadFormat()',MYMVC_LOG);
		// unserialize
		foreach( $this->_serializedCols as $sc) {
			$data[$sc] = unserialize($data[$sc]);
		}
		// afterRead formatage
		if( $this->_applyReadWriteFunc ) {
			$data = $this->afterRead( $data , $this->_aspect);
		}
		return $data ;
  }
  
  private function __updateSpecialCols($data) {
		MyMVC::_getInstance()->_log(MYMVC_DEBUG,'MyMVC_Model::__updateSpecialCols()',MYMVC_LOG);
		// add special cols
		foreach($this->_specialCols as $col=>$func) {
			$data[$col] = $this->$func($data);
		}
		return $data;
  }
  
}

