<?php
/*
Copyright (C) 2007 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

#################################################################

 * class 	MyMVC
 * 
 * création le		31/03/07
 * 
 * 15/04/07 - $dbCnx = DbConnect::getInstance() ; $config = Config::getInstance() ;
 * 06/10/07 - utilisation mymvcPath
 * 14/10/07 - $myMVCRelations  liste des relations entre models active, pour éviter boucle entre model
 * 						_newRelation() ajoute une relation, _relationExist() indique (true) si une relation
 * 						entre 2 models est déja active
 * 17/10/07 - maj pour utiliser $Config (class config globale), maj _analyseReq, appel depuis le constructeur
 * 						ajout de getControleur(), getAction(), getParams()
 * 22/05/09 -	add pagesUrl and pages.ini parsing, new _analyseReq() function
 * 15/07/09 - _getInstance(), make this class a singleton
 * 16/07/09 - add load of registry skeleton class, add log info levels  info adn debug
 * 21/07/09 - clean code, fix bug if request empty => use default controler
 * 27/07/09 - parse params in pages.ini, _GET and _POST arrays
 * 30/07/09 - TEMPLATE_EXT, to load  template file controler/action
 * 24/09/09 - _checkUserAuth(), registerUser(), unregisterCurrentUser()
 * 29/09/09 - deplacement logique user dans user.class.php
 * 30/09/09 - appel accessControl->loadConfig()
 * 01/10/09 - trans  checkAccess => accessControl class
 * 02/10/09 - add page process time to log INFO
 * 08/10/09 - add current_controler to view vars
 * 09/10/09 - _loadAppClass($pControler, $pFiles)
 * 12/10/09 - _loadViewVars($pControlerName, $pActionName)
 * 30/10/09 - prefix all methods and properties with
 * 07/11/09 - $appControler->_registry  _load() and _save()
 * 10/11/09 -	check if instance MyMVC already exist
 * 13/01/10 - _getControler()
 * 25/01/10 - add check $appControler->_useDefaultView before load template
 * 27/01/10 - _mainLibLoaded, add mainLib var to $appControler
 * 26/03/10 - ne charge le defaultLayout que si le controler n'a definit un layout dans son constructeur
 * 31/03/10 - ajout recup action _getAction() avant de charger la vue, cela permet au controler d'appeler
 * 						une action différente en utilisant _setAction() (voir auth iphone)
 * 						utilisation de _getViewName() et _setViewName()
 * 30/04/10 - ajout autoload pour charger class model et class dans application/lib
 * 						suppresion mainLib proprieté controler
 * 22/09/10 - fix bug affectation vars dans la view 
 * 22/12/10 - ajout redirect 403 denyUrl sir accès refusé
 * 09/02/11 - _userInGroup($pGroup), renvoie true si le user est membre du groupe
 * 09/02/11 - Suppression de _loadConst(), il faut utiliser views.ini avec [ALL:ALL]
 * 09/02/11 - ajout config pour fonctionnement sans SGBD, limite la registry a session ou sqllite
 * 10/02/11 - Création _init() pour limite le contenu de _construct() 
 * 14/02/11 - ajout test enableRegistry  (config.ini), modif syntaxe pages.ini    url = "controler/action/params"
 * 04/04/11 - utilisation de _disableDatasourceProcessing pour ne pas traiter les datasources 
 * 09/03/12 - ajout config->_loadDbConfig()  use ini file in config/db/ dir
 * 07/04/12 - maj pour utiliser le nouveau format de pages.ini
 * 12/10/12 - appel _init() du controler en cours, LogDir pour les fichiers de logs
 * 12/11/12 - modif pour utiliser des chemins complets pour les JS, CSS et appLib dans config.ini
 *            cela permet d'intégrer des packages (type bootstrap) avec leur propre arbo  bootstrap/js/... par exemple * 
 * 21/01/13 - modif ordre traitemnet  startAPP() par rapport à la récup du prefix après la connexion user
 * 08/02/13 - modif tag pour définir les fonctions dans views.ini => _FUNCS (remplace func)
 * 13/03/13 - _analyseReq(), modif pour tenir compte de BASE_URL en absolu (http://...../)  
 * 13/03/13 - suppression methode _getControler()
 * 14/03/13 - modif pour charger coreLib en premier a disposer de la class LogModel pour écrire les log dans la BDD
 * 15/03/13 - require_once direct et non depuis loadCoreLibs() et loadAppLibs()
 * 15/03/13 - ajout detection requete Ajax
 * 26/07/13 - fix buf _unregisterCurrentUser(), l'id n'était pas sauvegardé avant la suppression
 * 24/10/13 - Ajout test return methode init des controlers, si false l'action n'est pas exécutée, seule la vue est affichée
 *            il est donc nécessaire de bien configurer la vue dans init()
 * 14/01/14 - chargement des coreLibs suivant valeur de config.ini sauf dbFuncs
 * 16/01/14 - Renommage class MyMVC_Controler => MyMVC_Controler
 * 22/01/14 - Gestion multilingue via fichier ini fr.ini, uk.ini dans config/lang
 * 24/01/14 - _loadLocal() et _localStrings
 * 17/02/14 - chargement registry après initApp pour permettre de setter le prefix si besoin dans initApp
 * 20/02/14 - Modif code pour gérer les urls spéciales  /_mymvc/ qui sont redirigé vers myControler
 * 24/02/14 - modif chargement registry pour tenir compte du prefix user
 * 24/02/14 - ajout traduction pour MyMVC dans mymvc/lang/xx.ini
 * 25/02/14 - gestion des traductions imbriquées avec {id_trad}
 * 28/02/14 - Ajout message log sur loadLocal(), Chargement conditionnel des models pour la config fonction de CONFIG_TYPE
 * 03/03/14 - Ajout _logEnabled pour pouvoir couper les logs dans myControler
 * 04/03/04 - remplacement de __getTrad() par une fonction static  getTrad() appel avec MyMVC::getTrad($id)
 * 07/04/14 - _logSQL($sql) pour logger les requetes SQL, désactivation process datasource et viewvars pour myControler
 * 10/04/14 - test si datasources definit avant de charger fichier datasources.class.php
 * 10/04/14 - idem pour viewvars.class.php, passage en private de _init() et renommage en __init()
 * 10/04/14 - Possibilité d'insérer des valeurs dans les traductions via {$1},..{$n}
 * 15/04/14 - Chargement par défaut de myControler.php, suppresion chartgement config.inc.php
 * 15/04/14 - ajout {BASE_URL} pour les fichiers JS et CSS du controler
 * 23/04/14 - ajout prise en compte $mymvcCssFiles 
 * 03/05/13 - Suppresion _logSQL(), ajout niveau de log SQL MYMVC_SQL = 16
 * 23/04/14 - 1.02 - Ajout prise en compte $mymvcCssFiles
 * 1.0.3
 * 15/05/14 - Modif log pour logguer les req SQL dans mymvc.log et comme préfixe SQL, ajout niveau de log MYMVC_SQL = 16
 * 1.0.4
 * 10/06/14 - Numérotation des lignes de logs
 * 24/06/14 - fix bug _showDebug() manquait un param dans l'appel
 *						ajout MyMVC_appName et MyMVC_appVersion dans la vue (et dans config.ini)
 * 26/06/14 - _storeValue() & _getValue()  
 * 30/06/14 - Optimisation code _startApp(), suppression test sur _userDefaultView (MyMVC_Controler) 
 * 01/04/14 - refonte fonction __analyseReq()
 * 06/10/14 - fix bug avec port 8080 dans _analyseReq(), ajout $ret=true si pas de init controler
 * 08/11/14 - Création branche V2
 * 11/11/14 - Remplacement /lib par /libs
 * 
 * 
 * 
 * 
 * Alabama - Alaska - Arizona - Arkansas - Californie - Caroline du Nord - Caroline du Sud
 * Colorado - Connecticut - Dakota du Nord - Dakota du Sud - Delaware - Floride - Géorgie - Hawaï - Idaho - Illinois
 * Indiana - Iowa - Kansas - Kentucky - Louisiane - Maine - Maryland - Massachusetts - Michigan - Minnesota
 * Mississippi - Missouri - Montana - Nebraska - Nevada - New Hampshire 
 * New Jersey - New York - Nouveau-Mexique - Ohio - Oklahoma - Oregon - Pennsylvanie 
 * Rhode Island - Tennessee - Texas - Utah - Vermont - Virginie - Virginie occidentale
 * Washington - Wisconsin - Wyoming 
 * 
 * 
*/

define ('MyMVC_VERSION','0.7 (beta)'); // 11/11/14

require_once(MYMVC_PATH.'funcs.php') ;

// Main config file of MyMVC frameworks
require_once(MYMVC_PATH.'error.class.php') ;
require_once(MYMVC_PATH.'config.class.php') ;

// Classes MyMVC principales dans /application/mymvc/
require_once(MYMVC_PATH.'template.class.php') ; 
require_once(MYMVC_PATH.'controler.class.php') ;
require_once(MYMVC_PATH.'model.class.php') ; // Model2
require_once(MYMVC_PATH.'view.class.php') ;
require_once(MYMVC_PATH.'datasource.class.php') ; 
require_once(MYMVC_PATH.'registry.class.php') ; 
require_once(MYMVC_PATH.'myControler.php') ;
//require_once(MYMVC_PATH.'dbquery.class.php') ; 
//require_once(MYMVC_PATH.'dbobject.class.php') ;
 
// Model interne à MYMVC pour la gestion des variables de configuration
if( MYMVC_CONFIG_TYPE == 'db') {
   require_once(MYMVC_PATH.'LogModel.class.php') ;
   require_once(MYMVC_PATH.'PageModel.class.php') ;
   require_once(MYMVC_PATH.'DatasourceModel.class.php') ;
   require_once(MYMVC_PATH.'ConfigModel.class.php') ;
   require_once(MYMVC_PATH.'ViewvarModel.class.php') ;
   require_once(MYMVC_PATH.'FileModel.class.php');
}

class MyMVC {
    
	private static $_instance 	= NULL ;
 	private     $_config 		; //= array() ; // object MyMVC_Config 
 	private     $_query 		= array() ; // controleur, action et params
 	private     $_datasources	= null ;
 	private     $_pageUrls		= null ;
 	private		$_viewVars		= null ; // config use in _loadViewVars()
 	public      $_localStrings = array(); // string pour les traductions (fr.ini...)
   
 	public		$_currentControler ;
 	public		$_currentAction	; 	
 	private     $_debugInfo ;   // stockage de texte à afficher dans la div Debug
   
  private     $_logEnabled = true; // permet de couper le log
	
	private $_storage = array(); // stockage de nom/valeur pendant l'execution
 	/**
 	 * 
 	 * Permet de récuperer l'instance courante de la class MyMVC
 	 *
 	 * @return MyMVC instance
 	 * 
 	*/
 	static public function _getInstance() {
 		if(self::$_instance == NULL ) {
          self::$_instance = new MyMVC();
     	}
     	return self::$_instance;
 	}
 	
   /** methode statique pour traduction */
  static public function getTrad($pTexteId,$pVars=null) {
      $m = MyMVC::_getInstance();
      $trad = '(PHP) Non traduit : ['.$pTexteId.']';
      if( $pTexteId != '' ) {
         if( array_key_exists($pTexteId,$m->_localStrings) ) { // trad de l'application
            $trad = $m->_localStrings[$pTexteId];
         } else {
            $pTexteId = '_mymvc_'.$pTexteId;
            if( array_key_exists($pTexteId,$m->_localStrings) ) { // trad MyMVC
               $trad = $m->_localStrings[$pTexteId];
            } 
         }
      }
      // recherche s'il y a des variables a intégrer dans la traduction
      if(is_array($pVars) AND count($pVars)>0) {
         $i=1;
         foreach($pVars as $one) { 
            $trad = str_replace('{$'.$i.'}',$one,$trad);
            $i++;
         }
      }
    return $trad;
  }
  
	public function _storeValue($pName,$pValue) {
		if($pName!='') {
			$this->_storage[$pName] = $pValue;
		}
	}
	
	public function _getValue($pName) {
		$val = null;
		if( $pName!='' ) {
			if(isset($this->_storage[$pName])) {
				$val = $this->_storage[$pName];
			}
		}
		return $val;
	} 
	
 	/** constructor */
	public function __construct() {
		// check if MyMVC instance already exist
		//if( self::$_instance != null ) return self::$_instance ;
		//$this->__loadCoreLibs();
      
		// load config from ini
		$this->_config = MyMVC_Config::_getInstance() ;
        // Chargement configuration principale db ou ini
        
		// set local instance
		self::$_instance = $this ;
		$this->_log(MYMVC_INFO,"",MYMVC_LOG) ;
		$this->_log(MYMVC_INFO,"---[START]---",MYMVC_LOG) ;
		$this->_log(MYMVC_INFO,$this->_config->appName.'('.$this->_config->appVersion.')',MYMVC_LOG) ;
		$this->_log(MYMVC_INFO,"CoreLibs, Applibs, config.ini, DbConfig loaded", MYMVC_LOG) ; 
		$this->__init(); // charge les libs/class/regsitry/dbConfig....
      
	}
	
	/** fonction init qui charge toutes les libs, class, dbconfig, registry */
	private function __init() {
		$this->_log(MYMVC_INFO,"MyMVC init()",MYMVC_LOG) ;
		$this->__loadCoreLibs();
      
		//global $mymvcJsFiles, $mymvcCssFiles ;
		$this->__loadAppLibs();
    $details = 'App libs';
      
		// Chargement configuration des datasources db ou ini
		if( file_exists(BASE_PATH . "config/datasources.ini") ) {
			$ds = parse_ini_file(BASE_PATH . "config/datasources.ini",true);
         if( count($ds)>0 ) {
            $this->__loadLib(BASE_PATH . "libs/datasources.class.php"); 
            $this->_datasources = new MyMVC_Datasource($ds) ; 		// init datasource class 
            $this->_datasources->_setFuncs( new Datasources() ) ;  	// class with all datasources methods
            $details .= " / datasources class";
         } else {
            $details .= " / no datasource";
         }
		}
      
		// Chargement configuration des pages (url) db ou ini
		if( file_exists(BASE_PATH . "config/pages.ini" ) ) {
			$tmp = parse_ini_file(BASE_PATH . "config/pages.ini" ,true);
			if( sizeof($tmp)>0)
			{
				$this->_pageUrls = $tmp;
			}
         $details .= " / pages.ini";
		}
      
		// Chargement configuration des variables de view db ou ini
		if( file_exists(BASE_PATH.'config/viewsvars.ini')) {
			$this->_viewVars = parse_ini_file( BASE_PATH.'config/viewsvars.ini',true) ;
         if( count($this->_viewVars)>0 ) {
            $this->__loadLib(BASE_PATH . "libs/viewVars.class.php") ;
            $details .= " / viewsvars" ;
         } else {
            $details .= " / no viewvar" ;
         }
		} else {
			$this->_viewVars = null;
		}
		
    $this->_log(MYMVC_INFO,$details. ' loaded',MYMVC_LOG) ;
		// js files for MyMVC
		//$this->_config->mymvcJsFiles = $mymvcJsFiles ;
    //$this->_config->mymvcCssFiles = $mymvcCssFiles ;
		
		//locals
		if($this->_config->defaultLocal != '') {
			 $this->__loadLocal($this->_config->defaultLocal);
		}
	}
	
	/**
    * 
    * 14/01/14 
    * 
	 * load coreLibs for MyMVC
    * def dans config.ini
	 *
	 */
	private function __loadCoreLibs() { 
		//global $MyMVC_Libs, $MyMVC_coreLibs ; // def in config.inc.php
      $path = MYMVC_PATH.'libs/'; // mymvc/libs
      if( $this->_config->libAcl == 1 ) $this->__loadLib($path.'acl.class.php');
      if( $this->_config->libDate == 1) $this->__loadLib($path.'date.inc.php');
      if( $this->_config->libForms == 1) $this->__loadLib($path.'forms.inc.php');
      if( $this->_config->libFuncs == 1) $this->__loadLib($path.'mymvc_funcs.inc.php');
      if( $this->_config->libHtml == 1) $this->__loadLib($path.'html.inc.php');
      if( $this->_config->libNumbers == 1) $this->__loadLib($path.'numbers.inc.php');
      if( $this->_config->libValidators == 1) $this->__loadLib($path.'validators.inc.php');
      if( $this->_config->libXul == 1) $this->__loadLib($path.'xul.inc.php');
	}
 	
	/*
	 * 
	 * Load appLibs files set in config file with appLibs[]
	 * 
	 */
	private function __loadAppLibs() { // 26/05/07
		if( is_array($this->_config->appLibs) and count($this->_config->appLibs)>0 ) {
			// load app lib, def in config file
			foreach( $this->_config->appLibs as $lib) {	
				$this->__loadLib(BASE_PATH.$lib) ;
			}
		}
	}

  public function __addDebug($pTexte) {
    $this->_debugInfo[] = $pTexte;
  }
   	
	/**
	 * StartApp, call controler and action from uri request
	 *
	 * TODO:  get datasources for controler/action
	 * 
	 */
	public function _startApp() {
		$mt = explode(' ',microtime());
		$start = $mt[0]+$mt[1];
		$this->__analyseReq(); // parse url, read params
    if( isset($_SERVER['HTTP_X_REQUESTED_WITH']) and $_SERVER['HTTP_X_REQUESTED_WITH']=='XMLHttpRequest' ){ // requete AJAX ?
			define('MyMVC_AJAX',true); // utilisé pour les retours d'erreur Ajax
    } else {
      define('MyMVC_AJAX',false);
    }
		
		// init controler et chargement fichier de class
		$controler = $this->_query['controler']; 
		if( $controler == '' ) $this->_showDebug('No Controler to exec' , 'mymvc.class.php' , '_getControler()' ) ; 
		if( $controler != '_mymvc') {
			$controlerClassName = $controler.'Controler'; //ucfirst($controler) . 'Controler' ;
			$controlerFileName = BASE_PATH.'controlers/'.$controler.'Controler.php' ;
			$this->__loadLib($controlerFileName) ;
		} else {
			$this->_log( MYMVC_INFO , 'Log disabled in myControler' , MYMVC_LOG ) ;
			$this->_logEnabled = false ; // coupure des logs pour myControler
			$controler = 'myControler';
			$controlerClassName = 'myControler' ;
			//$controlerFileName = MYMVC_PATH.'myControler.php' ;
			//$this->__loadLib($controlerFileName) ;
		}
		//d($controlerClassName);
		if( class_exists($controlerClassName) ) {
			$this->_log( MYMVC_INFO , 'Creating an instance of : '.$controler , MYMVC_LOG ) ;
			$this->_currentControler = new $controlerClassName() ;
			$this->_currentControler->_params = $this->_getParams() ; // load params/values in controler
		} else {
			// display error if class not found
			$this->_showDebug("Class controler <b>$controlerClassName</b> not found in $controlerFileName" , 'mymvc.class.php' , 'startAPP()') ;
		}

		$this->_currentAction = $this->_getAction($this->_currentControler) ;// Action a executer par défaut

		if( $controler != 'myControler' ) {
			// controle des droits d'accès
			if( $this->_config->enableAcl == 1) {
				$this->__loadLib(BASE_PATH.'controlers/authControler.php') ; // load authControler class
				$auth = new authControler();
				if( !$auth->checkAccess($controler,$this->_currentAction) ) {
					$this->_log(MYMVC_INFO,'Access denied, exec auth/deny',MYMVC_LOG);
					// on change le controler => auth et l'action => deny
					$this->_currentControler = $auth ;
					$controler = 'auth';
					$this->_currentAction = "deny";
					$this->_currentControler->_params = $this->_getParams() ;
					$controlerClassName = "AuthControler";
				} else {
					$this->_log(MYMVC_INFO,'Access OK',MYMVC_LOG);
				}
			} else {
				$this->_log(MYMVC_INFO,'ACLs disabled',MYMVC_LOG);
			}
		} else {
			$this->_log(MYMVC_INFO,'No ACL for myControler',MYMVC_LOG);
		}
		$this->_currentControler->_setViewName($this->_currentAction);// Par défaut utilise la vue avec le même nom que l'action
    $actionName = $this->_currentAction.'Action';
		$this->_log(MYMVC_INFO,"Controler : ".$this->_currentControler->_name." / Action : ".$actionName,MYMVC_LOG);
    
		// check if method exist
		if( !method_exists( $this->_currentControler,$actionName) ) {
			$this->_showDebug("Method <b>$actionName</b> not found in class <b>$controlerClassName</b>" , 'mymvc.class.php' ,'startAPP()' ) ;
		} else {
			// variables globales utilisables dans les vues
			$this->_currentControler->_view->_MyMVC_Controler = $this->_currentControler->_name;
			$this->_currentControler->_view->_MyMVC_Action = $this->_currentAction;
			$this->_currentControler->_view->_MyMVC_Url = $this->_query['pageUrl'];
			// init registry
			$this->_currentControler->_registry->_init($this->_config->registryStorage);

			// appel initApp si la function existe
			if(function_exists('initApp')) {
				initApp($this->_currentControler, $this->_currentAction);
			}
			
			// load datasources if needed
			if( ($this->_currentControler->_datasourceProcessing) and $this->_datasources != null and $controler!='myControler') {
				$this->_datasources->_process($this->_currentControler, $this->_currentAction);
				//$details .= "Datasources process";
			}

			// layout par défaut
			$this->_currentControler->_view->_layout = $this->_config->defaultLayout;

			// Chargement des vars depuis viewvars
			if( $controler != 'myControler' ) {
				$this->__loadViewVars();
				$this->_log( MYMVC_INFO , 'Controler init()', MYMVC_LOG ) ;
				$ret = $this->_currentControler->init();
			} else {
				$this->_log( MYMVC_INFO , 'myControler starting', MYMVC_LOG ) ;
				$ret = true;
			}
			$details = '';
			if($ret!==false) { // si init renvoie false on n'execute pas la méthode 
				$this->_log( MYMVC_INFO ,'Running '.$this->_currentControler->_name.'->'.$actionName, MYMVC_LOG);
				if( $this->_currentControler->$actionName() === false ) { // return == false n'affiche la vue par défaut
					$details = 'Action return false (JSON?), no view rendered';
					$tmp = explode(' ',microtime());
					$end = $tmp[0] + $tmp[1];
					$processTime = number_format($end-$start,3)."s";
				} else {
					/*if( $this->_currentControler->_useDefaultView ) {*/
						$viewName = $controler.'/'.$this->_currentControler->_getViewName().'.'.TEMPLATE_EXT;
						$details .= 'Loading template '.$viewName ;
						$this->_currentControler->_view->_load($viewName);
					//}
					$this->__setDefaultViewContent();
					// calcul temp exécution
					$tmp = explode(' ',microtime());
					$end = $tmp[0] + $tmp[1];
					$processTime = number_format($end-$start,3)."s";
					$this->_currentControler->_view->_MyMVC_PageTime = $processTime;
					$this->_currentControler->_showView();
				}
			} else {
				$viewName = $controler.'/'.$this->_currentControler->_getViewName().'.'.TEMPLATE_EXT;
				$details = 'controler::init() return false. Loading template '.$viewName ;
				$this->_currentControler->_view->_load($viewName);
				$this->__setDefaultViewContent();
				// calcul temp exécution
				$tmp = explode(' ',microtime());
				$end = $tmp[0] + $tmp[1];
				$processTime = number_format($end-$start,3)."s";
				$this->_currentControler->_view->_MyMVC_PageTime = $processTime;
				$this->_currentControler->_showView();
			}
			$this->_log( MYMVC_INFO , $details , MYMVC_LOG ) ;
			if( $this->_config->enableRegistry == 1 ) { $this->_currentControler->_registry->_save(); } 
			$this->_log( MYMVC_INFO , '[END in '.$processTime.']' , MYMVC_LOG ) ;
		}
		session_write_close();
	}
	
   /**
    * 13/03/13
    * 
    * Init de la vue 
    * n'est exécuté que si l'action du controler retourne True ou rien
    * permet d'optimier les traitements ajax qui n'utilise pas les vues 
    * 
    * @param MyMVC_Controler $appControler
    * @param String $action
    * 
    */
	private function __setDefaultViewContent() {
		//global $mymvcCssFiles, $mymvcJsFiles;
		
		$this->_currentControler->_view->MyMVC_appName = $this->_config->appName;
		$this->_currentControler->_view->MyMVC_appVersion = $this->_config->appVersion;
		
		// add mymvc js files to views 
		$this->_currentControler->_view->_addCssFiles(MyMVC_Config::_getInstance()->_getMyConfig('cssFiles')) ;
		$this->_currentControler->_view->_addJsFiles(MyMVC_Config::_getInstance()->_getMyConfig('jsFiles')) ;

		// add app js files to views
		if( count($this->_config->appJsFiles) > 0 ) {
			 $this->_currentControler->_view->_addJsFiles($this->_config->appJsFiles);
		}

		// add app css files to views 
		if( count($this->_config->appCssFiles) > 0) {
			$this->_currentControler->_view->_addCssFiles($this->_config->appCssFiles) ;
		}

		// Chargement par defaut d'un fichier js associé au controler
		$jsControlerFile = 'js/'.$this->_currentControler->_name.'.js';
		if( file_exists(WWW_PATH.$jsControlerFile) ) $this->_currentControler->_view->_addJsFiles('{BASE_URL}'.$jsControlerFile );

		// Chargement par defaut d'un fichier css associé au controler
		$cssControlerFile = 'css/'.$this->_currentControler->_name.'.css';
		if( file_exists(WWW_PATH.$cssControlerFile) ) $this->_currentControler->_view->_addCssFiles('{BASE_URL}'.$cssControlerFile );

		//chargement des locals
		if(count($this->_localStrings)>0) {
			 foreach($this->_localStrings as $n=>$v) {
					$n = 'l_'.$n ; // ajout du prefix {l_...}
					$this->_currentControler->_view->$n = $v;
			 }
		}

		/* aff les info de debug s'il y en a */
		if( count($this->_debugInfo)>0 ) {
			 $v = new MyMVC_View();
			 $v->_setTemplateDir(MYMVC_PATH.'templates/');
			 $v->_load('debugInfo.html');
			 $v->texte = join('<br/>',$this->_debugInfo);
			 $v->_render();
			 $this->_currentControler->_view->MYMVC_Debug = $v->_getCode();
		} else {
			 $this->_currentControler->_view->MYMVC_Debug = '' ;
		}
	}
   
   /**
    * 24/01/14
    * 
    * Charge un fichier ini de lang  fr.ini par exemple
    * dans la variable privée _localStrings
    *  
    * @param string $pLocal
    * @throws Exception
    * 
    */
   public function __loadLocal($pLocal) {
      $this->_localStrings = null; // raz des trads
      $this->_log(MYMVC_INFO,'Setting language to : '.$pLocal,MYMVC_LOG);
      
      // traduction MyMVC par défaut
      $file = MYMVC_PATH.'/lang/'.$pLocal.'.ini';
      if(!file_exists($file)) { 
         $file = MYMVC_PATH.'/lang/fr.ini'; // fr par défaut si la local définie n'existe pas
      }
      $this->_localStrings = parse_ini_file($file);
      
      // traduction application
      $file = BASE_PATH.'config/lang/'.$pLocal.'.ini';
      if(file_exists($file)) {
         $tmp = parse_ini_file($file);
         foreach($tmp as $id=>$trad) {
            $this->_localStrings[$id] = $trad;
         }
         unset($tmp);
      } 
      
      // recherche des imbrications {id} dans les textes
      foreach($this->_localStrings as $id=>$trad) {
         $list = array();
         $imbrication = preg_match_all("/\{\w+\}/",$trad,$list);
         if(count($list[0])>0) {
            foreach($list[0] as $value) {
               $src = substr($value,1,-1); // recup id
               if( isset($this->_localStrings[$src])) {
                  $this->_localStrings[$id] = str_replace($value,$this->_localStrings[$src],$this->_localStrings[$id]);
               }
            }
         }
      }
      unset($list);
   }
   
	/**
	 * load viewVars 
	 * search in views.ini file
	 *
	 * @param string $pControlerName
	 * @param string $pActionName
    * 
    * TODO optimiser le code
    * Save viewvars def in registry
    * 
	 */
	private function __loadViewVars() {
      if( $this->_currentControler->_viewVarProcessing ) {
         $pControlerName = $this->_currentControler->_name;
         $pActionName = $this->_currentAction;
         if( $this->_viewVars != null ) {
            $viewClass = new ViewVars() ; // load class viewVars
            foreach( $this->_viewVars as $ca=>$data ) {
               $c = explode(':',$ca); // syntax  "[controler:action]"
               if( ($pControlerName == $c[0] or $c[0] == 'ALL')  // check controler 
                   and ( $pActionName == $c[1] or $c[1] == 'ALL') )  // and action 
               {
                  foreach( $data as $var=>$val) {  // get all vars and func
                      if( $var == '_FUNCS') {
                        $funcs = explode(',',$val);
                        foreach( $funcs as $oneFunc) {
                           if(method_exists($viewClass, $oneFunc)) {
                              $this->_currentControler->_view->_addVars($viewClass->$oneFunc($pControlerName,$pActionName));
                           } else {
                              throw new Exception("Fonction <b>$oneFunc</b> non trouvée dans ViewVarsClass.php (view.ini)");
                           }
                        }
                      } else {
                        $this->_currentControler->_view->_addVar($var,$val);
                      }
                  }
               }
            }
         }
		}
		return;		
	}
	
	/**
	 * Affiche la page404
	 * si page non trouvée  xxx.html
	 * ou controler/action erroné
	 * 
	 */
	private function __page404($pMessage) {
		if( $this->_config->page404 == '' ) { //pas de page 404 définie
			throw new Exception($pMessage);
		} else {
			header("Location: ".BASE_URL.$this->_config->page404);
		}
		exit;
	}
	
	/**
	 * Explode request   _SERVER['request_uri']
	 * check if requesting a page.html or  controler/action 
	 * load _GET and _POST params and param from  controler/action/param=val/param2=val2...  url syntax
	 * if page or controler or action not found display an error page
	 * 
	 * 01/07/14 - refonte traitement
	 * 
	 */
	private function __analyseReq() {
		// valeur par défaut
		$this->_query['controler'] = $this->_config->defaultControler ; 
		$this->_query['action'] 	= '' ; 
		$this->_query['params']		= array() ;
		$this->_query['pageUrl']   = ''; 
		// extract URI from REQUEST_URI
    // $uri = urldecode($_SERVER['SCRIPT_URI']).urldecode($_SERVER['REQUEST_URL']) ;
    // 14/06/13  Modif serveur BLIZZ
		
	  //echo urldecode($_SERVER['SERVER_NAME']).urldecode($_SERVER['REQUEST_URI']);
		
		if(strpos(BASE_URL,'http')!==false) { // BASE_URL absolue
			//echo 'http ' ;
			$protocol = ($_SERVER['SERVER_PORT']==443)? 'https://' : 'http://';
			if( $_SERVER['SERVER_PORT'] == 80 ) {
				$pageUrl = $protocol.urldecode($_SERVER['SERVER_NAME']).urldecode($_SERVER['REQUEST_URI']);
			} else {
				// ajout du port si != de 80
				$pageUrl = $port.urldecode($_SERVER['SERVER_NAME']).':'.$_SERVER['SERVER_PORT'].urldecode($_SERVER['REQUEST_URI']);
			}
      //echo $pageUrl;
		} else {
			$pageUrl = urldecode($_SERVER['REQUEST_URI']);
		}
    // suppresion du path url pour ne garder que page.html ou controler/action
		$pageUrl = substr($pageUrl,strlen(BASE_URL),255);
		//d($pageUrl);
		
		if( $pageUrl == ''  ) { return; } // racine de l'app
        //d($pageUrl.'/'.$_SERVER['REQUEST_URI']);
       
		// on ignore les appels spéciaux
		if( in_array($pageUrl,MyMVC_Config::_getInstance()->_getMyConfig('urlToIgnore')) ) { 
			$this->_log(MYMVC_INFO,$this->getTrad('mymvc_urlIgnoree',array($pageUrl)),MYMVC_LOG) ;
			exit();
		}  
		
		// page HTML ?
		$pageFound = false ;
		if( strpos($pageUrl,'.html')!==false) {
			$i = strpos($pageUrl,'?') ; // check if params in url  pages.html?...
			if( $i !== false ) { $pageUrl = substr($pageUrl,0,$i); } // suppression de ?param=xx... si present
            // TODO ajout des params dans l'url aux params de pages.ini
			if( array_key_exists($pageUrl,$this->_pageUrls) ) {	
				$pageFound = true ;
				$this->_log(MYMVC_INFO,'Requested url is valid : '.$pageUrl,MYMVC_LOG) ;
				$this->_query['controler']  = $this->_pageUrls[$pageUrl]['controler'] ;
				$this->_query['action']= $this->_pageUrls[$pageUrl]['action'];
				$this->_query['pageUrl'] = $pageUrl ; // url en cours 
				if( $this->_pageUrls[$pageUrl]['params'] != '' ) {
                  // ajout des parametres (pages.ini) : format  nom=valuer&nom2=valeur...
					$p = explode('&',$this->_pageUrls[$pageUrl]['params']) ;
					if( count($p) > 0) {
						foreach( $p as $one ) {
							$t = explode('=',$one ) ;
							$name = $t[0];
							$t = array_slice( $t, 1, count($t)-1); // remove first element of array
							$this->_query['params'][$name] = implode('',$t) ; // get all value even if separator is in value (=) 
						}
					}
				}
				//d($this->_query['params']);
			} else {
              $this->_log(MYMVC_INFO,'Requested url is not valid : '.$pageUrl,MYMVC_LOG) ;
			  $this->__page404($this->getTrad('mymvc_urlDemandeeIntrouvable',array($pageUrl))); // page demandée non trouvée)
			}
		} else { // request a controler
			$reqParts = explode('/',$pageUrl);
			if(empty($reqParts[0]) OR empty($reqParts[1])) {
				$this->__page404($this->getTrad('mymvc_urlDemandeeIncorrecte',array($pageUrl))); // page demandée non trouvée)
			}
			if( $reqParts[0]!='index.php') {   
				if( isset($reqParts[0])) $this->_query['controler'] = $reqParts[0];
				if( isset($reqParts[1])) $this->_query['action'] = $reqParts[1];
				if( $reqParts[0]!='_mymvc') {
					// controle si le fichier controler existe => non erreur 404
					$f = BASE_PATH . 'controlers/' . $reqParts[0] . 'Controler.php' ;
					if( !file_exists($f) ) { 
						$this->__page404( $this->getTrad('mymvc_fichierControlerNonTrouve',array($f)) );
					}
				} 
			} // demande diff de index.php
			// params
			if( count($reqParts) > 2 ) { // liste  par1=val1/par2=val2...
				for($i=2;$i<count($reqParts);$i++) {
					$pTmp2 = explode('=',$reqParts[$i]) ;
					if( count($pTmp2)==2) {
						$this->_query['params']["{$pTmp2[0]}"] = $pTmp2[1] ;
					}
				}
			}
		}
		// add _GET and _POST params
		foreach( $_GET as $p=>$v) {
			$this->_query['params'][$p] = $v ;
		}
		foreach( $_POST as $p=>$v) {
			$this->_query['params'][$p] = $v ;
		}
		//d($this->_query);
		return;
		/*
    if( $uri == '/' ) { // racine du site
			$request = '/' ;
		} else {
			$p = strpos($uri, BASE_URL) + strlen(BASE_URL) ;
			$request =  substr($uri,$p) ;
			d($request);
			//$this->_log(MYMVC_INFO,"Parsing requested URI : ".$request,MYMVC_LOG) ;
			if( $request != '') {
				if( strpos($request,'.html') >0 ) { // check if request a page or a controler
					$i = strpos($request,'?') ; // check if params in url  pages.html?...
					if( $i !== false ) {
						$pageUrl = substr($request,0,$i);
					} else {
						 $pageUrl = $request ;
					}
					$pageFound = false ;
					// find controler and action bind to page url
					//d($this->_pageUrls);
					foreach( $this->_pageUrls as $page=>$data) {
						if( $page == $pageUrl) {
							//$pageData = explode('/',$data);   // format dans pages.ini  url = "controler/action/params"
							$this->_query['controler']  = $data['controler'] ;
							$this->_query['action']= $data['action'];
							$pageFound = true ;
							$this->_query['pageUrl'] = $pageUrl ; // url en cours 
							$this->_log(MYMVC_INFO,'Requested url is valid : '.$pageUrl,MYMVC_LOG) ;
							// ajout des parametres :  format  nom=valuer&nom2=valeur...
							if( $data['params'] != '' ) {
								// parse params in ini file to pass them to controler
								$p = explode('&',$data['params']) ;
								if( count($p) > 0) {
									foreach( $p as $one ) {
										$t = explode('=',$one ) ;
										$name = $t[0];
										$t = array_slice( $t, 1, count($t)-1); // remove first element of array
										$this->_query['params'][$name] = implode('',$t) ; // get all value even if separator is in value (=) 
									}
								}
							}
						}
					}
					if(!$pageFound) {
						//throw new Exception("Requested url invalid <b>$pageUrl</b>") ;
						// TODO LOG
						header("Location: ".BASE_URL.$this->_config->page404);
						exit;
					}
				} else {
					// request a controler
					$reqParts = explode('/',$request);
					if( $reqParts[0]!='index.php') {   
						if( isset($reqParts[0])) $this->_query['controler'] = $reqParts[0];
						if( isset($reqParts[1])) $this->_query['action'] = $reqParts[1];
						if( $reqParts[0]!='_mymvc') {
							// controle si le fichier controler existe => non erreur 404
							$f = BASE_PATH . 'controlers/' . $reqParts[0] . 'Controler.php' ;
							if( !file_exists($f)) {
								// TODO LOG
								header("Location: ".BASE_URL.$this->_config->page404);
								exit;
							}
						} 
					}
					// params
					if( count($reqParts) > 2 ) { // liste  par1=val1/par2=val2...
						for($i=2;$i<count($reqParts);$i++) {
							$pTmp2 = explode('=',$reqParts[$i]) ;
							if( count($pTmp2)==2) {
								$this->_query['params']["{$pTmp2[0]}"] = $pTmp2[1] ;
							}
						}
						//d($reqParts);
					}
				}
				// add _GET and _POST params
				foreach( $_GET as $p=>$v) {
					$this->_query['params'][$p] = $v ;
				}
				foreach( $_POST as $p=>$v) {
					$this->_query['params'][$p] = $v ;
				}	
			} // $request != ''
		} // $uri = BASE_URL
		//$message = 'Final Request => '.$this->_query['controler']. '/'. $this->_query['action'];
		//$this->_log(MYMVC_INFO,$message,MYMVC_LOG);
		 */
	}
	    
	/**
	 * Get name of current controler (extracted for uri)
	 * 
	 * @return string   nameControler
	 *//*
  private function _getControler()
  { 
      $controler = '' ;
      if( $this->_query['controler'] != '' )
      {
         $controler = $this->_query['controler'] ;
      } else {
         if( $this->config->defaultControler != '')
         {
            $controler = $this->config->defaultControler ;
         }
      }
      if( $controler == '' ) 
      { 
         $this->_showDebug("No Controler to exec" , 'mymvc.class.php' , '_getControler()' ) ; 
      }
      //die($controler);
      return $controler;
  }*/
    
  /**
   * def action to exec for current controler
   * priority  url action, default controler action, config default action
   *
   * @param MyMVC_Controler $pControler
   * 
   * @return string  action name : nameAction
   */
  private function _getAction($pControler) { 
      $action = '' ;
      if( $this->_query['action'] != '') { // action dans l url ou definit via pages.ini
         $action = $this->_query['action'];
         $pControler->_setAction($action);
      } else {
         if( $pControler->_action != '') { // action définit dans le controler  _setAction()
            $action = $pControler->_action ;
         } else {
            $action = $this->_config->defaultAction ;  // action par défaut pour tous les controlers  config.ini
            $pControler->_setAction($action);
         }
      }
      if( $action == '' ) { 
         $this->_showDebug("No Action to exec" , 'mymvc.class.php' , '_getAction()' ) ; 
         //throw new Exception (" MyMVC:_getAction() : Action indéfinie") ; 
      }
      return $action;
  }
  
  // TODO  vérifier si utile
	public function _getParams() { 
		return $this->_query['params'] ; 
	}
 
	/**
	 * Load a lib file
	 * 
	 * @param  string  $pLib  file with full path
	 *  
	 */
	private function __loadLib($pLib) {  //28/03/07 
   	if( file_exists($pLib) ) {
			require_once($pLib) ;
		} else {
         $this->_log(MYMVC_DEBUG,"Lib $pLib  not found",MYMVC_LOG);
			throw new Exception("File <b>$pLib</b> not found" );
			//$this->_showDebug("Lib file $pLib not found", 'mymvc.class.php', '_loadLib()');
      }
		return true ;
	}
	
	/**
 	 * log message file in log  BASE_PATH/logs dir
 	 *
 	 * TODO : managed several type of logs , config.ini => logType=CSV|FILE|DB
 	 * if DB = [logDbConfig] section with database config 
 	 * 
    * file = app log, 1 = mymvc log, 2 = sql log
  */
	
  public function _log($level,$message,$file=APP_LOG) { 
		static $ligne = 0;
		
		if( $this->_logEnabled AND LOG_ENABLED == 1 and LOG_LEVEL & $level ) {
			$ligne++;
			if( LOG_TYPE == 'db' ) {
				$level = ($file==SQL_LOG)? 'SQL' : $level;
				$this->__logToDb($level,$message); // log dans la BDD
			} else {
				//echo $level;
				$d = date('Y-m-d H:i:s') ;
				switch ($file) {
					case APP_LOG : { $logFile = LOG_DIR.'app.log' ; break; }
					case MYMVC_LOG : { $logFile = LOG_DIR.'mymvc.log' ; break ; }
					case SQL_LOG : { $logFile = LOG_DIR.'mymvc.log' ; break ; } 
					case ERROR_LOG : { $logFile = LOG_DIR.'error.log' ; break ; } 
					default : { 
						//$this->_showDebug('Log file undefined','mymvc.class.php','log()',false); 
						Throw new Exception('Fichier de log indéfini');
						break ; } // no log !
				}
				switch($level) {
					case MYMVC_INFO :    { $libLevel	= "[INF][$ligne] ->" ; break ; }
					case MYMVC_WARNING : { $libLevel = "[WAR][$ligne] ->" ; break ; }
					case MYMVC_ERROR :		{ $libLevel = "[ERR][$ligne] ->" ; break ; }
					case MYMVC_DEBUG :		{ $libLevel = "[DEB][$ligne] ->" ; break ; }
					case MYMVC_SQL :			{ $libLevel = "[SQL][$ligne] ->" ; break ; }
					default : { $libLevel = "[??]" ; }
				}
				// creation du fichier si besoin
				if( !file_exists($logFile) ) {
					$f = fopen($logFile,'w');
				} else {
					$f = fopen( $logFile,'a+') ;   
				} 
				if( $f ) {
					fputs($f, "$d - $libLevel $message \n") ;
					fclose($f);
				} else {
					die('Erreur ouverture fichier de log ' . $logFile );  // pas d'exception pour éviter un boucle infinie
					// @TODO  utiliser la classe MyMVC_Error() pour afficher une erreur sans log
				}
			} // LOG_TYPE == 'db'
		} // LOG_ENABLED
		return true ;
  }
 
  
  /**
   * 
   * Message de log stockés en base
   * table __log par défaut
   * 
   * @param int $level
   * @param string $message
   * @param int $file
   * 
   */
  private function __logToDb($level,$message) {
     // convertion du level en chaine
     switch($level) {
				case MYMVC_DEBUG:		{ $level = 'DEBUG'; break; }
				case MYMVC_ERROR:		{ $level = 'ERROR'; break; }
				case MYMVC_INFO:		{ $level = 'INFO'; break; }
				case MYMVC_WARNING: { $level = 'WARNING'; break; }
				case MYMVC_SQL:			{ $level = 'SQL' ; break; }
        // $level = SQL 
     }
     $l = new Log();
     $data = "'".date('Y-m-d h:i:s')."','".ENV."','".addslashes($message)."','".$level."'";
     $query = 'INSERT INTO '.$l->_table.' (date,env,message,level) values ('.$data.')' ;
     $l->_directQuery($query,false); // false = ne pas logger sinon boucle sans fin
     //$log = $l->_create($data);
     //$log->_save();
     return;
  }
  
	/*
	* Stop if an unknown method call 
	* 
	*/
  public function __call($pMethode,$pParams) {
  	// TODO  add exception error display
  	 throw new Exception("Erreur class MyMVC appel methode inexistante  $pMethode ");
  }
	
  /**
   * display MyMVC error
   * with custom layout and colors
   *
   * @param string $pError
   * @param string $pFile
   * @param string $pSource
   */
  public function _showDebug( $pError , $pFile='' , $pSource='' ) {
		// on indique quel est l'objet parent pour info a l'affichage
		$error = new MyMVC_Error(); 
		$error->_show('',$pError,$pFile,$pSource);
	} 	
  
   /**
    * Affiche une erreur application     * 
    * 
    * @param type $pError
    * @param type $pFile
    * @param type $pSource
    */
   public function _showAppError($pError) {
      print <<<_FIN
        <html lang="fr"><head>
           <meta http-equiv="content-type" content="text/html; charset=UTF-8">
            </head>
            <body>
            <h1 style="text-align:center">Erreur applicative</h1>
           <h3>$pError</h3>
         </body>
        </html>
_FIN;
       exit;
   }
}