<?php
/*
Copyright (C) 2005 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

###################################################################
 *  
 * 29/03/05 - constructeur, LoadTemplate, AddVar, ParseTemplate
 * 30/03/05 - Gestion des blocks de répétitions HTML
 * 31/03/05 - Gestion des sous blocks
 * 01/04/05 - Gestion des sous blocks
 * 04/04/05 - Maj nom des variables, test sous blocks
 * 25/04/05 - modif M_ParseBlock pour pouvoir passer un tableau vide et garder un block tel quel
 * 29/04/05 - fix bug  si fin de block non trouvée
 * 07/06/05 - fix bug manquait ajout de \n dans le traitement des sous-blocks de 2ieme niveaux.
 * 07/06/05 - ajout M_EffSousBlockRef pour pouvoir nettoyer un block des ref a des eventuels sous-block qui ne sont pas utilisés
 * 18/07/05 - ajout init des T_Blocks='' pour éviter  php Notice
 * 13/09/05 - __clone(pour creer un nouvel objet a partir d'un autre, utilisation du meme dossier de template
 * 		__clone = methode utilise par défaut en PHP5 pour le clonage( $obj2 = clone $bj1 ) ;
 * 05/12/05 - 	ajout test si fichier existe dans M_LoadTemplate
 * 12/12/05 - 	passage en OFF de la methode __clone, pb si migration PHP5
 * 28/08/06 - 	ajout méthode getParsed(), qui  appelle M_ParseTemplate et renvoie $s_HtmlOut ;
 * 29/08/06 - 	ajout méthode addVar($ref, $val)
 * 28/03/07 - 	inclusion comme lib dans PHPFMK
 * 24/05/09 - 	update, MyMVC 1.0
 * 25/06/09 - 	update BLOCK_START and end tags => {BLOCK_START/blockName} ...  {BLOCK_END/blockName}
 * 25/06/09 - 	EMPTY_BLOCK  contant
 * 22/07/09 - 	update block tags => BLOCK_START:NAME
 * 09/11/09 - 	getCode() -> _getCode(), setCode() => _setCode()
 * 10/11/09 - 	$T_Blocks => $_blocks, $T_TmpBlocks => $_tmpBlocks, $T_TemplateVars => $_templateVars
 * $_htmlCode => $_templateCode, $_htmlOut => $_finalCode
 * 		getParsed() => _getParsed(), clean() => _clean(), parse() => _parse()
 * 11/11/09 -	delete toUpper() in _parseBlock(), ref can be in lower or upper case in template file
 * 12/07/10 - _loadExternals(), permet de precharger un fichier template avec un tag {{nomfichier}}
 * 		ex : {{form-operation}} permet de charger le template  TEMPLATE_DIR/_externals/form.operation.html
 * 
 * 09/03/12 - replace all die(..) with throw new Exception(...)
 * 02/05/12 - _getblock() 
 * 12/11/12 - ajotu exception si fichier external non trouvé
 * 19/11/12 - maj _loadExternals() pour gérer les imbrications multiples
 * 14/12/12 - Ajout log debug si pas de données pour un block, au lieu d'une exception
 * 06/12/12 - fix bug analyse tag debut block
 * 14/02/14 - Modif _mergeBlocks() pour gérer le multiNiveau. l'ajout du tag de block est désactivable
 * 14/03/14 - modif boucle for par foreach pour parseBlock() pour accepter les tableaux avec des indices non continus
 * 02/04/14 - Ajout d'une deuxième passe dans _parse() pour gérer le cas de variables imbriquées
 * 02/04/14 - Supression de l'exception dans M_ExtractBlocks() si code vide, pour traiter des templates vides.
 * 03/11/14 - 2 passe dans _parse() pour les tags imbriqués
 * 12/11/14 - Changement de nom TemplateLib devient MyMVC_Template
 * 
 * TODO
 * 
 * rename  public and private vars and methods
 * clean code, delete unused methods
 * create all var TAG  {TAG} as empty var
 * usefull to disable display without need to set it to '' in code
 * like blocks traitement do
 * 
 * 																																					
*/

define ('MyMVC_TEMPLATE_VERSION','1.1') ; // 12/11/14

// constante pour le marquage des blocks de répétition
Define( 'Cs_BLOCK_START' ,  'BLOCK_START' ) ;
Define( 'Cs_BLOCK_END' ,  'BLOCK_END' ) ;

// use to _addBlock() with no data to parse
Define('EMPTY_BLOCK' , 1);

class MyMVC_Template   //   12/11/14
{
	
	public $_repTemplate 		= '' ;  		// dossier contenant les fichier html template
	public $_templateCode			= '' ;   		// code HTML du template (non modifié)
	public $_templateVars 	= array() ; 	// tableau ref/valeur des variables à remplacer dans le template
	public $_finalCode 			= '' ;   		// code html template modifié, les refs sont remplacée pardes valeurs a partir du tableu $_templateVars
	
	public $_blocks 				= array() ;  	// tableau pour stocker le code des blocks de répétition (block et sous block)
	public $_tmpBlocks 		= array() ;		// tableau pour stocker le code des blocks en cours de création

	private $_version ;
 	private $_dateVersion ;	
 	private $_author ;

	##############################################
	####	constructeur, $s_Rep  = dossier contenant les templates
	##############################################
	public function __construct( $pDir = null )  // constructeur
	{
		//echo $pDir."<br/>" ; 
		if( !is_dir( $pDir ) )
		{
			throw new Exception( "Error : MyMVC_Template::__construct() <br/> <b>$pDir</b> <br/> is not a valid template dir" ) ;
		}
			
		$this->_repTemplate 	= $pDir ;
 		/*$this->_version 		= "1.0" ;
 		$this->_dateVersion 	= "10/11/09" ;
 		$this->_author			= "Auguste  - oguste@free.fr" ;*/
 
	}
	
	/* 
	 * fonction pour injecter du code  parser
	 * directement sans passer par le chargement d'un fichier
	 * 
	 */
	public function _setCode($pCode) // 01/04/07
	{
		$this->_templateCode= $pCode ;
	}
	
	/* 
	 * renvoie le code brut du template sans modif
	 * 
	 */
	public function _getCode() // 01/04/07 
	{
		return $this->_templateCode;
	}
	
	###########################################################
	####		chargement d'un fichier template et stockage du code dans  _htmlCode
	####		et stockage des blocks de repetition dans _blocks
	###########################################################
	public function _load( $s_Fichier )
	{
		// raz des vars, utilisé même objet utilisé pour charger plusieurs templates
		$this->_raz() ;
		$s_File2Load = $this->_repTemplate . $s_Fichier ;   // chemin template + nom fichier 
		if( is_file($s_File2Load ) )
		{
    		$this->_templateCode = implode( "", @file( $s_File2Load ) ) ; 
			$this->_loadExternals();	
			$this->extractBlocks() ;  // extraction du code des blocks et sous blocks
		} else {
			return false ;
		}
		return true ;
	}
	
   /**
    * charge les templates à partir des tags {{nomDuTemplate}}
    * les templates sont dans templates/_externals/NomDuTemplate.TemplateExt
    * 
    */
	private function _loadExternals() {
		$externalTag = array();
		$code = $this->_templateCode;
		preg_match_all( "({{([a-zA-Z0-9\.\-\_]*)}})" , $code , $externalTag); // [0] = {{tag}}  [1] = tag
      while( count($externalTag[1]) > 0 )
		{
			foreach($externalTag[1] as $tag ) {
				$file = $this->_repTemplate.'_externals/'.$tag . '.' . TEMPLATE_EXT ;
				//MyMVC::_getInstance()->_log( MYMVC_INFO , "Include external template $file" , MYMVC_LOG ) ;
            if(file_exists($file)) {
              	$tplCode =  implode( "", file($file)) ;			
               $code = str_replace( '{{'.$tag.'}}', $tplCode , $code ); 
            } else {
               throw new Exception("Fichier template introuvable : ".$file); 
            }
			}
         // on relis le code pour permettre les inclusions imbriquées
         $externalTag = array();
         preg_match_all( "({{([a-zA-Z0-9\.\-\_]*)}})" , $code , $externalTag); // [0] = {{tag}}  [1] = tag
		}
		$this->_templateCode = $code ;
	}
	
	private function _raz() //31/03/07
	{
		$this->_templateVars = array() ;
		$this->_blocks = array();
		$this->_tmpBlocks =  array() ;
		$this->_finalCode = "" ;
		$this->_templateCode= "" ;		
	}
	
	/**
	 * add blocks informations to current blocks array
	 * used with layout to get blocks parsed from layout
	 * 
	 * @param array $blocks
	 */
	public function _addBlocksInformation($blocks)
	{
		if(is_array($blocks) and sizeof($blocks)>0)
		{
			array_merge($this->_blocks,$blocks);
		}
	}
	
	/** return array with blocks information
	 * 
	 * @return array
	 * 
	 */
	public function _getBlocks()
	{
		return $this->_blocks;
	}
	
	###################################################
	##  clonage d'un objet pour utiliser plusieur template
	##  dans un même script PHP
	##  le clone utilise le même dossier pour lire
	##  les fichiers templates
	###################################################
	/*function M_Copie() // 13/02/06 
	{
		$Obj_New = new C_Template( $this->_repTemplate );
		return $Obj_New ;
	}*/
	
	
	########################################################
	####		extraction des informations de block du source HTML 'template'
	####		et des sous-blocks 
	########################################################
	private function extractBlocks()  //  maj 07/06/05 
	{
		if( empty($this->_templateCode) )
		{
			//throw new Exception( "Erreur: Aucun code dispo pour M_ExtractBlocks()" ) ;
         return true;
		} 
		$s_HtmlWoBlock = '' ;				
		$T_Code = explode ( "\n" , $this->_templateCode) ;  // on eclate les ligne en supprimant les CRLF
		$i_NbLignes = sizeof($T_Code) ;
		for( $i=0 ; $i<$i_NbLignes ; $i++ )
		{
			if( !(strpos( $T_Code[$i] , Cs_BLOCK_START) === False) )   // recherche début block
			{
				$d = strpos( $T_Code[$i] , ':') + 1 ;
				$f = strpos( $T_Code[$i] , '}' ) ;
				$s_NomBlock = substr($T_Code[$i], $d, $f-$d  ) ;
            if( $f == 0 or $d == 1 or $s_NomBlock == '')
            {
               $i += 1;
               throw new Exception("Erreur tag block invalide, ligne $i ") ;
            }
				//echo( "debut block $s_NomBlock trouvé $d - $f <br/>") ;
				$s_FinBlock = "{".Cs_BLOCK_END.":$s_NomBlock}" ;
				// on initalise la ref pour le parseur, ainsi si le block n'est pas utilisé il sera remplacé par '' => vide en HTML, évite d'affichage parasite  
				// permet de gerer les affichages de block conditionnels
				$this->_templateVars["{BLOCK_" . $s_NomBlock."}"] = '' ;
				// on insere une ligne {BLOCK_NomDUBlock} pour ensuite inserer le code HTML de block aprés parsage
				$s_HtmlWoBlock .=  "{BLOCK_" . $s_NomBlock."}" ;
				$i++ ;
				$this->_blocks[$s_NomBlock] = '' ;
				do {
					$this->_blocks[$s_NomBlock] .= $T_Code[$i] . "\n" ; //  on remet un retour chariot (pour que l'HTML soit plus lisible)
					$i++ ;
					if( $i == $i_NbLignes) // fin de bloc non trouvée
					{
						throw new Exception("Erreur fin block '$s_NomBlock' non trouvée");
					} 
				}  while( strpos( $T_Code[$i] , $s_FinBlock  ) === False ) ;  // fin du bloc marqué avec le nom du bloc, utile pour les blocks imbriqu�s
			} else {
				$s_HtmlWoBlock .= $T_Code[$i] . "\n"  ; // on copie les lignes tant que la fin de block pas trouvée et on remet CRLF (\n)
			}
		}
		// on remplace le code HTML d'origine par une version épurée du code concernant les blocks
		$this->_templateCode= $s_HtmlWoBlock ; 
		
		// boucle de recherche de sous blocks dans les blocks extrait ci dessus
		// cette boucle s'execute tant que l'on trouve un debut de blocks a extraire
		// $s_SousBlockTrouve = True
		// on remplace le code du block parent , on enleve a chaque passage un niveau de sous block 

		do
		{
			$b_SousBlockTrouve = False ;
			foreach( $this->_blocks as $s_NomBlockParent => $s_CodeBlock )
			{
				$T_Code = explode ( "\n" , $this->_blocks[$s_NomBlockParent] ) ;
				$s_NewCode = '' ;
				for( $i=0 ; $i<sizeof($T_Code) ; $i++ )
				{
					##fecho ($T_Code[$i]) ;
					if( ! (strpos( $T_Code[$i] , Cs_BLOCK_START ) === False ))  // recherche debut de sous block
					{
						$b_SousBlockTrouve = True ;  // on continue la boucle
						// recherche du nom du block
						$d = strpos( $T_Code[$i] , ':' ) +1 ;
						$f = strpos( $T_Code[$i] , '}' ) ;
						$s_NomBlock = substr($T_Code[$i] , $d , $f-$d  ) ;
						##fecho( "debut block $s_NomBlock trouvé");
						// on creer une var vide pour remplacer le block meme s'il n'est pas utilisé
						// ainsi on peut avoir dans une page des blocks qui seront ignoré si on appelle pas parseblock
						// permet de gerer des affichage de blocks conditionnels
						$this->_templateVars["{BLOCK_" . $s_NomBlock."}"] = '' ; 
						$s_FinBlock = '{'.Cs_BLOCK_END.":$s_NomBlock}" ;
						$s_NewCode .=  "{BLOCK_" . $s_NomBlock."}" ;
						$i++ ;
						$this->_blocks[$s_NomBlock] = ''; 
						do  // recherche la fin du sous-block
						{
							$this->_blocks[$s_NomBlock] .= $T_Code[$i]."\n" ;
							$i++ ;
							if( $i == sizeof($T_Code) ) // fin de bloc non trouvée
							{
								throw new Exception( "Erreur fin de block : $s_NomBlock non trouvée");
							} 
						}  while( strpos( $T_Code[$i] , $s_FinBlock  ) === False ) ;
					} else {
						$s_NewCode .= $T_Code[$i]."\n"  ; // on recopie la ligne a chaque passage si pas de fin de block trouv�
					}
				}
				##fecho('maj code block parent');
				$this->_blocks[$s_NomBlockParent] = $s_NewCode ; 
			} 
		} while  ( $b_SousBlockTrouve === True ) ;
		//print_r($this->_blocks) ;
	}
	
	################################################################
	####		Stockage dans un tableau des ref/var pour remplacement dans le template
	####		cette méthode peut être appellé plusieur fois avant traitement du template
	####		$T_Vars = array ( 'ref1'=> 'val1' ,  'ref2'=>'val2' .....)
	################################################################
	public function _addVars( $T_Vars )
	{
		if( !is_array($T_Vars) )
       	{
       		throw new Exception( " Error : addVar() : incorect param, need an array() " ) ;
       	}

        /*if( !empty( $this->_templateCode) )
        {*/
           	foreach( $T_Vars as $s_Ref=>$s_Val )
           	{
               	$this->_templateVars['{' . $s_Ref . '}'] = $s_Val ;
           	}
       	 /*} else {    
            	die( "Error : addVar() : not template code available, need to load a template !." ) ;
        	}*/
	}
	
	######  equiv M_AddVar mais avec une seule variable
	public function _addVar($ref, $val)  // 29/08/06 
	{
		if( $ref == '' ) return false ;
		$this->_templateVars['{' . $ref . '}'] = $val ;
	}
	
	############################################################
	###  Ajoute une itération de block de niveau 1 dans la  variable {BLOCK_NomDuBlock)
	###  ensuite au parsage général la var sera remplacé par le contenu du block
	###  cette mêthode peut être appelée plusieur fois, elle opère par concaténation à chaque appel
	############################################################
	public function _addBlock( $s_NomBlock )
	{
		//debug("adding block $s_NomBlock") ;
		if( empty( $this->_tmpBlocks[$s_NomBlock]) )
		{
			//throw new Exception( "Error : addBlock( $s_NomBlock) : block tmp empty ! ") ;
         MyMVC::_getInstance()->_log(MYMVC_DEBUG,'Aucune données pour le block : '.$s_NomBlock);
		}
		
		$s_Ref = "{BLOCK_" . $s_NomBlock . "}" ;
		if( isset( $this->_templateVars[$s_Ref]) )
		{
			// si le block existe deja on ajoute le code
			$this->_templateVars[$s_Ref] .= $this->_tmpBlocks[$s_NomBlock] ;
		} else {
			// premiere ajout on crée la ref 
			$this->_templateVars[$s_Ref] = $this->_tmpBlocks[$s_NomBlock] ;
		}
		//echo $this->_templateVars[$s_Ref] ;
	}
	
		
	##################################### 
	###   Remplace dans le code du block par les var
	###   et repete le block autant de fois qu'il
	###   y a d'elements dans T_RefVars et place le code modifie
	###   dans un block tmp qui sera placer dans la page finale par addblock 
	###   si $T_RefVars == '' on initialise block tmp avec le code de block sans modif
	###   si on a un block parent sans var qui doit incorporer un block enfant
	###   il faut avant de faire le merge block, appelle parseblock pour le block paent
	###  de maniere a ce que le block tmp correspondant soit initialisé
	###  ATTENTION : a chaque appel le contenu de TmpBlock[NomDuBlock] est effacé
	###  ce qui veut dire qu'il faut faire un AddBlock avant d'utiliser ParseBlock pour ne pas perdre 
	###   les données déjà parsées
	
	###   TODO check if params are valid
	
	#####################################
	public function _parseBlock( $s_NomBlock , $T_RefVars )
	{
      //if( $s_NomBlock == 'niv5') d($T_RefVars);
      
		if( empty( $this->_blocks[$s_NomBlock]) ) // controle si on a bien un block temporaire pour recevoir le résultat
		{
			throw new Exception("Error :  parseBlock( $s_NomBlock ) :  empty block" ) ;
		}

		$this->_tmpBlocks[$s_NomBlock] = '' ;
		$i_NbRepeteBlock = sizeof( $T_RefVars) ;  // nombre d'elements = nombre de fois qu'il faut repeter le block
		
		if( $T_RefVars == EMPTY_BLOCK )   //$i_NbRepeteBlock == 0 )  // tableau vide on garde le block tel quel ss rech/templ
		{
			$this->_tmpBlocks[$s_NomBlock] = $this->_blocks[$s_NomBlock] ; // peut être utile pour init d'un block tmp ou recup du code si aucune var dedans
		} else {
			//for( $i=0 ; $i < $i_NbRepeteBlock ; $i++ )
			foreach( $T_RefVars as $T_VarBlock)
         {   
            //echo $i;
				//$T_VarBlock = $T_RefVars[$i] ;
	
				$T_Code = explode ( "\n" , $this->_blocks[$s_NomBlock]  ) ;
				$i_NbLigneCode =  sizeof( $T_Code) ;
				for( $j = 0 ; $j < $i_NbLigneCode ; $j++ )  // pour chaque ligne de code
				{
					$s_LigneBlock = $T_Code[$j] ;
					
						//echo "$s_LigneBlock " ;
						foreach( $T_VarBlock as $s_Ref=>$s_Val )   // on rech/rempl toutes les occurences de ref par var 
						{
							//$s_Ref = strtoupper($s_Ref);
							$s_Ref = "{" . $s_Ref . "}" ; // ref en uppercase
							if( !(strpos( $T_Code[$j] , $s_Ref ) === False) ) // si on trouve une Ref sur la ligne
							{
								$s_LigneBlock = str_replace( $s_Ref , $s_Val , $s_LigneBlock ) ;
								//echo " $s_NomBlock :  ligne block : $s_LigneBlock <br>" ; 
							}
						}
						$this->_tmpBlocks[$s_NomBlock] .= $s_LigneBlock."\n"  ;
					}
				
			}
			//echo "<p><b>$s_NomBlock</b><br> : " . $this->_tmpBlocks[$s_NomBlock] ;
		}
	}
	
	
	###########################################
	####   Permet d'insere le code d'un sous block dans le code du block parent
	####   on fait un rech/remplace du tag Block par le code de tmpblock
	####   on replace le tag a la fin du code pour pouvoir faire plusieur appels à merge
	####   le dernier tag sera effacé par ParseTemplate() car il y a dans TemplateVars
	####   une variable vide pour chaque block pour ne pas afficher les blocks inutiles
	###########################################
	
	public function _mergeBlocks( $s_BlockParent , $s_SousBlock, $addBlockTag = true )
	{
		if( empty( $this->_tmpBlocks[$s_BlockParent] )  or empty( $this->_tmpBlocks[$s_SousBlock]) )
		{
			throw new Exception("Error : mergeBlock()  empty block ($s_BlockParent) or subblock  ($s_SousBlock)" ) ;
		}
		$s_RefSousBlock =  "{BLOCK_" . $s_SousBlock ."}" ; 
		// on incorpore le code du block enfant dans le code du block parent
		//$this->_tmpBlocks[$s_BlockParent] = str_replace( $s_RefSousBlock, $this->_tmpBlocks[$s_SousBlock] , 	$this->_tmpBlocks[$s_BlockParent] )   ;
		// on garde une ref pour le sous block cela permet de faire plusieur merge
		// la derniere occurence sera enleve au moment du parse
		// car la TemplateVars du sous block est toujours egal à '' 
      if( $addBlockTag ) { // ajout conditionel du tag de block
         $this->_tmpBlocks[$s_BlockParent] = str_replace( $s_RefSousBlock, $this->_tmpBlocks[$s_SousBlock]."\n $s_RefSousBlock \n",$this->_tmpBlocks[$s_BlockParent]);
      } else {
         $this->_tmpBlocks[$s_BlockParent] = str_replace( $s_RefSousBlock, $this->_tmpBlocks[$s_SousBlock],$this->_tmpBlocks[$s_BlockParent] )   ;
      }
   }
	
	#####################################################
	###	Cette fonction permet de retirer le tag {NomSousBlock} d'un block parent
	###    ceci est a faire lorsqu'un sousblock ne doit pas être affiché car pas de données
	###    mais que le block parent doit lui être affichés
	#####################################################
	public function OFF_effSousBlockRef( $s_BlockParent, $s_SousBlock)
	{
		if( empty( $this->_tmpBlocks[$s_BlockParent] )  )
		{
			throw new Exception("Error : _effSousBlockRef() block $s_BlockParent is empty" ) ;
		}
		$s_RefSousBlock = "{BLOCK_" . $s_SousBlock ."}" ;
		$this->_tmpBlocks[$s_BlockParent]  = str_replace( $s_RefSousBlock , '', $this->_tmpBlocks[$s_BlockParent] );
	}
	
	
	#################################################
	####	fonction  qui remplace  les refs dans le template (_htmlCode)
	####	par leurs valeurs a partir du tableau $_templateVars
	####	le code HTML modifié est stocké dans  $_finalCode
	#################################################
	private function _parse()
	{
      $this->_finalCode = '';
		$T_Code = explode( "\n", $this->_templateCode) ;
		$i_NbLignes = sizeof( $T_Code) ;
		for ( $i=0 ; $i < $i_NbLignes ; $i++) {
 			foreach( $this->_templateVars as $s_Ref=>$s_Val) {  // pour chaque ref
				if( !(strpos( $T_Code[$i] , $s_Ref ) === False) ) { // si on trouve une Ref sur la ligne
					$T_Code[$i] = str_replace( $s_Ref, $s_Val, $T_Code[$i] ) ;  // on la remplace par sa valeur
				}	
			}
			//deuxième passage pour le tags imbriqués
			foreach( $this->_templateVars as $s_Ref=>$s_Val) {  // pour chaque ref
				if( !(strpos( $T_Code[$i] , $s_Ref ) === False) ) { // si on trouve une Ref sur la ligne
					$T_Code[$i] = str_replace( $s_Ref, $s_Val, $T_Code[$i] ) ;  // on la remplace par sa valeur
				}	
			}
			$this->_finalCode .= $T_Code[$i]."\n" ;
		}
      //var_dump($this->_templateVars);
      //d($this->_finalCode);
      // 2eme passe pour les imbrications
      $T_Code = explode( "\n", $this->_finalCode); 
      $i_NbLignes = sizeof( $T_Code) ;
      $this->_finalCode = '';
		for ( $i=0 ; $i < $i_NbLignes ; $i++) {
 			foreach( $this->_templateVars as $s_Ref=>$s_Val){  // pour chaque ref
				if( !(strpos( $T_Code[$i] , $s_Ref ) === False) ) { // si on trouve une Ref sur la ligne
					$T_Code[$i] = str_replace( $s_Ref, $s_Val, $T_Code[$i] ) ;  // on la remplace par sa valeur
				}	
			}
			$this->_finalCode .= $T_Code[$i]."\n" ;
		}
		$this->_clean() ;  // suprime toutes les lignes blanche
	}	
				
	private function _clean()
	{
		$T_Code = explode( "\n" , $this->_finalCode) ;
		$s_NewCode = '' ; 
		foreach( $T_Code as $ligne)
		{
			if( $ligne != '' )
			{
				$s_NewCode .= $ligne."\n"  ;
			}
		}
		$this->_finalCode = $s_NewCode ;
	}
		
	public function _getParsed()
	{
		$this->_parse() ;
		return $this->_finalCode ;
	}	
	
}


