<?php
/*
Copyright (C) 2009 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 

#################################################################

 *
 * 
 * 24/07/09 - sendJsonResponse()
 * 28/07/09 - suppr makeArrayForTplblock() 
 * 30/07/09 - exception if template file not found in load()
 * 02/10/09 - update log message when layout is disable
 * 09/11/09 - getCode() => _getCode(), setCode() => _setCode(), load()=>_load()
 * 						setLayout() => _setLayuout(), disasble getData(), render() => _render()
 * 						parseBlock() => _parseBlock()
 * 10/11/09 - parseFile() => _parseFile(), addExternal() => _addExternal()
 * 11/01/10 - _processViewTags()						
 * 25/01/10 - fix bug on loading layout and setting CONTENT tag
 * 26/03/10 - _getLayout() to know if a layout is set
 * 03/06/10 - _loadExternals(), ajout chr . - et _ pour les tags de templates
 * 12/07/10 - supression _loadExternals(), méthode transférée dans la class Template
 * 22/09/11 - ajout _externalCode pour parser en 1er les codes des externals avant les variables de view
 * 04/04/12 - remplamcement ereg par preg_match l299
 * 04/12/12 - Maj _addVar() pour permettre l'utilisation d'un array en entrée
 * 13/03/13 - suppression de _getLayout() et _setLayout()  modif _layout en variable public
 * 25/03/13 - optimisation du code
 * 30/01/14 - fix bug si aucun JS_file et CSS_file , pour fixer valeur = '' de {CSS_FILES} et {JS_FILES}
 * 14/02/14 - ajout param addTagBlock dans _mergeBlocks() pour gérer le cas de plus de 2 niveaux d'imbrication (voir mergeBlocks() dans templateLib
 * 25/02/14 - _setTemplateDir()
 * 26/06/14 - _storeValue() et _getValue()
 * 27/06/14 - fix err si appel _addBlocks() avec data1==null, le bloc parent était quand même ajouté
 * 01/07/14 - _addBlocks() ajout test si !empty(data1)
 * TODO 
 * 
 * utf-8 header before sending JSON result
 * 
 * Bug: pb d'ordre de parsage des codes externes (dashboard), les vars ne sont pas dispo dans le constructeur !
 * 
 * 
 */

define ('MyMVC_VIEW_VERSION','1.02');

class MyMVC_View  {
	
	private		$_templateCode ;
	private		$_name ;
	private		$_data ; 
	private		$_tpl ; 
	private		$_jsFiles ;
	private		$_cssFiles ;
	private		$_removeCss;
	private		$_headers ;
	
	public		$_externalCode;
	public		$_blocks ;
	public		$_layout ;
	
	public function __construct() {
		// default values 
		$this->_tpl						= new MyMVC_Template(TEMPLATE_DIR);
		$this->_templateCode            = null;
		$this->_layout					= '';
		$this->_jsFiles					= array();
		$this->_cssFiles				= array();
        $this->_removeCss				= array();
		$this->_headers					= null; 
		$this->_data['MyMVC_VERSION']				= MyMVC_VERSION;
		$this->_data['MyMVC_CONTROLER_VERSION']		= MyMVC_CONTROLER_VERSION;
		$this->_data['MyMVC_VIEW_VERSION']			= MyMVC_VIEW_VERSION;
		$this->_data['MyMVC_MODEL_VERSION']			= MyMVC_MODEL_VERSION;
		$this->_data['MyMVC_TEMPLATE_VERSION']		= MyMVC_TEMPLATE_VERSION;
		$this->_data['MyMVC_REGISTRY_VERSION']		= MyMVC_REGISTRY_VERSION;
		$this->_data['MyMVC_MYCONTROLER_VERSION']	= MyMVC_MYCONTROLER_VERSION;
		$this->_data['MyMVC_ERROR_VERSION']			= MyMVC_ERROR_VERSION;
		//$this->_data['MyMVC_DBQUERY_VERSION']		= MyMVC_DBQUERY_VERSION;
		//$this->_data['MyMVC_DBOBJECT_VERSION']	= MyMVC_DBOBJECT_VERSION;
		$this->_data['MyMVC_DATASOURCE_VERSION']	= MyMVC_DATASOURCE_VERSION;
		$this->_data['MyMVC_CONFIG_VERSION']		= MyMVC_CONFIG_VERSION;
		$this->_data['MyMVC_VERSION']				= MyMVC_VERSION;
		$this->_data['JQUERY_VERSION']				= JQUERY_VERSION;
		$this->_addHeader('Content-type: text/html'); //TODO set in config.ini ?
	}
  
	/** stockage de variable globale pendant l'exécution du script uniquement */
	public function _storeValue($pName,$pValue) { MyMVC::_getInstance()->_storeValue($pName,$pValue); }
	/** récupération de variable globale */
	public function _getValue($pName) { return MyMVC::_getInstance()->_getValue($pName); }
	
	
	public function _setTemplateDir($pTemplateDir) {
		if($pTemplateDir!=='') {
			if(!is_dir($pTemplateDir)) throw new Exception(MyMVC::getTrad ('mymvc_ViewDossierTemplateInvalide'));
			$this->_tpl->_repTemplate = $pTemplateDir;
		}
	}
	
	//public function _getTemplateDir() { return $this->_tpl->_repTemplate; }
   
	/**
	 * return templace code 
	 *
	 * @return unknown
	 */
	public function _getCode() {
		return $this->_templateCode ;	
	}
	
	/*public function _setCode($pViewCode)
	{
		$this->_templateCode = $pViewCode;
	}*/
	
	public function _load($pName) {
		$this->_name = $pName;
		if( !$this->_tpl->_load($this->_name) ) { // load template file and externals {{xxxx}}
			throw new Exception('Fichier template non trouvé  : MyMVC_View::_load() <b>'.$this->_name.'</b>') ;
		}
		$this->_templateCode = $this->_tpl->_getCode(); // get code of template
	}
	
   /** 
    * Affecte un ou plusieurs variables à la vue en cours 
    * 
    * @param  $pVar  String ou Array
    * @param  $pVal  String 
    * 
    * @return nothing 
    * 
    */
	public function __set($pVar, $pVal=null)   {
		if( is_array($pVar) ) {
			foreach( $pVal as $n=>$v) {
				$this->_data[$n] = $v ;
			}
		} else {
			$this->_data[$pVar] = $pVal ; 
		}
	}

	/**
	 * check if a unknown method is called
	 *
	 * @param string $pMethode
	 * @param array $pArgs
	 */
	public function __call($pMethode,$pArgs) {
		throw new Exception('Appel méthode inconnue : <b>'.$pMethode.' </b> (Classe : MyMVC_View)');
	}
	
	/**
	 * check if trying to get unknown property
	 *
	 * @param string $pVar
	 * 
	 */
	public function __get($pVar) {
		//if( isset( $this->_data[$pVar]) )
		//{
		return $this->_data[$pVar];
		//} 
	}
   
	/**
	 * main methode, render the entire view
	 * A) if a layout if def, load it, and replace {CONTENT} with the view code
	 * the resulting code is the final view code.
	 * B) If _jsFiles def, create full HTML TAGS for JS and set {JS_FILES} value
	 * C) If _cssFiles def, create full HTML TAGS for CSS and set {CSS_FILES} value
	 * D) Process View Tags if def :  {/viewname/param&1=val1/param2=val2../}
	 *    view are class with a processView method, the tag is replaced with the resulting code are this method
	 *    so this method must return a string. view class are in  views/ dirs and call  viewnameView.php
	 * E) load all  _data (vars) in template (_tpl) for final parsing
	 * F) process blocks, load all blocks in template if def in _blocks
	 * G) load code in template and parse it 
	 * H) $this->_templaceCode get final view code parsed, can be modified with afterRender(), beforeShow() hooks
	 *
	 */
	public function _render() {
		// parse layout if set
		if( $this->_layout != '' ){
			$this->_templateCode = $this->_parseFile( LAYOUT_DIR . $this->_layout.'.'.TEMPLATE_EXT , array('CONTENT'=>$this->_tpl->_getCode()));
   	}	
		// search for view tags {/viewname/.../}
		$this->__processViewTags() ;
		// set JS files for {JS_FILES} tag
		if(count($this->_jsFiles)>0) {
			$links='';
			foreach( $this->_jsFiles as $jsFile) {
				$links .= str_replace(':1', $jsFile ,JS_TAG)."\n" ;
			}
			$this->JS_FILES = $links ; //echo $links ;
		} else {
			 $this->JS_FILES = '';
		}
		// set CSS files for {CSS_FILES} tag
		if( count($this->_cssFiles)>0 ) {
			$links='';
			foreach( $this->_cssFiles as $cssFile) {
				if( !in_array($cssFile, $this->_removeCss) ) // test si le css doit être ignoré
				{
					 $links .= str_replace(':1', $cssFile,CSS_TAG)."\n" ; //CSS_TAG def in config.inc.php
				}
			}
			$this->CSS_FILES = $links ;
		} else {
			$this->CSS_FILES = '';
		}
      
		// Variables globales;
		$this->BASE_URL = BASE_URL ;
		$this->JQUERY = JQUERY ;
		
    // load external code
		if( count($this->_externalCode) > 0 ) { 
			$this->_tpl->_addVars($this->_externalCode) ;
		}
    	   	
		// load vars in template object
		$this->_tpl->_addVars($this->_data) ;

		//var_dump($this->_tpl->_blocks);

		// process blocks
		//d($this->_blocks);
		if( count($this->_blocks)>0) {
			foreach($this->_blocks as $oneBlockCde) {
				$action = $oneBlockCde['action'];
				$name = $oneBlockCde['name'];
				$param = $oneBlockCde['param'];
				$addTagBlock = $oneBlockCde['addTagBlock'];
				if( $param != null) {
					$this->_tpl->$action($name,$param,$addTagBlock) ;  // parseBlock and mergeBlocks
				} else {
					$this->_tpl->$action($name); // addBlock
				}
			}
		}
       
		// templaceCode contient le code préparé pour être parsé
		$this->_tpl->_setCode($this->_templateCode); // on affecte le code au moteur tpl
		$this->_templateCode = $this->_tpl->_getParsed() ; // on parse le tout
	}
   
	/**
	 * charge les sous-templates via les tags {{xxx}}
	 * xx = path relatif du template dans le dossier templates
	 * aucun traitement n'est effectuée le tag est simplement remplacé par le
	 * code du template
	 * 
	 */
   /*
	private function _loadExternals()
	{
		$externalTag = array();
		$code = $this->_templateCode;
		preg_match_all( "({{([a-zA-Z0-9\.\-\_]*)}})" , $code , $externalTag); // [0] = {{tag}}  [1] = tag
		//var_dump($externalTag); 
		if( count($externalTag[1]) > 0 )
		{
			foreach($externalTag[1] as $tag )
			{
				$file = '_externals/'.$tag . '.' . TEMPLATE_EXT ;
				MyMVC::_getInstance()->_log( MYMVC_INFO , "Include external template $file" , MYMVC_LOG ) ;
				$tplCode =  $this->_parseFile($file);			
				$code = str_replace( '{{'.$tag.'}}', $tplCode ,  $code );
			}
		}
		$this->_templateCode = $code ;
		return true;
	}
	*/
	
	/**
	 * look for tags like {/VIEWNAME/../}
	 * set it to {VIEW_VIEWNAME} in code 
	 * param can be passed to methode call with {/VIEWNAME/param1=val1/param2=val2}
	 * 
	 * TODO  parse parameters in tag  {/VIEWNAME/param1=val1/param2=val2/}
	 */
	private function __processViewTags() {
		$code = $this->_templateCode ;
		while( preg_match( "/\{\/[a-zA-Z0-9\.\-\_]*\/\}/" , $code , $viewTag) ) {
			$tagParts = explode('/',$viewTag[0]) ;
			$name = $tagParts[1]; 
			MyMVC::_getInstance()->_log( MYMVC_DEBUG , "Processing view class $name" , MYMVC_LOG ) ;			
			$this->__loadViewClassFile($name.'View') ;
			$className = ucfirst($name).'View';
			$view = new $className() ;
			// check if params are define in tag {/viewname/param1=val1/param2=val2.../}
			$params = array();
			if( count($tagParts)>3 ) {
				for( $c = 2 ; $c < count($tagParts)-1;$c++) {
					$t = explode('=',$tagParts[$c]) ;
					$params[$t[0]] = $t[1] ;
				}
			}
			$view->processView($params);
			$view->_render();
			$code = str_replace( $viewTag[0], $view->_getCode(),$code);
		}
		$this->_templateCode = $code ;
		return true ;
	}
	
	/**
	 * check if view file exist in BASE_PATH.views/
	 * load it, else get an error
	 *
	 * @param string $pName
	 * 
	 */
	private function __loadViewClassFile($pName) {
		$file = BASE_PATH.'views/'.$pName.'.php' ;
		//echo "loading  $file";
		if( file_exists( $file)) {
			require_once( $file ) ;
		} else {
			throw new Exception('MyMVC_View::__loadViewClassFile => Fichier de classe View non trouvé : <b>'.$pName.'</b>');
		}
	}
	
	/**
	 * get an array and send it directly to client
	 * send header if set and return JSON encoded array 
	 *
	 * @param array $pData
	 */
	public function _sendJsonResponse($pData) {
 		$this->_addHeader('Cache-Control: no-cache, must-revalidate');
   	$this->_addHeader('Content-type: text/html');
		$this->_sendHeaders();
		if( !is_array($pData) ) {
         $pData = array('requestOk'=>false,'message'=>MyMVC::getTrad('mymvc_ViewAucuneDonneeJsonAEnvoyer'));
		}
		print json_encode($pData) ;
		return true;
	}
	
	
	/**
	 * used to parse the code of blocks
	 * need to be used for parent and child block (not for 'simple' block)
	 * parse the code of the block and if a parentName block supplied the block parsed 
	 * is merged with the parentName block, the parent block MUST be parsed before the child block
	 * if not the mergeBlocks() will result in a error
	 *
	 * @param string $pName    				name of block to parse
	 * @param array() $pContent    		content of block 
	 * @param string $pParentName    	name of parent block to merge into
	 * 
	 */
	/*
	public function _parseBlock($pName,$pContent,$pParentName=null,$addTagBlock=true)
	{
		// first parse block content
		$this->_blocks[] = array('action'=>'_parseBlock','name'=>$pName,'param'=>$pContent,'addTagBlock'=>$addTagBlock);
		// if a parent block if supplied, merge de parsed block with is parent
		// the parent block must be parsed before !! 
		if( $pParentName != null )
		{
         $this->_blocks[] = array('action'=>'_mergeBlocks','name'=>$pParentName,'param'=>$pName,'addTagBlock'=>$addTagBlock);
		}
	}
	*/
	/**
	 * Charge plusieurs vairables dans la vue
	 * 
	 * @param array $pArray
	 * 
	 */
	public function _addVars(Array $pVars) {
		foreach( $pVars as $n=>$v) {
			$this->_data[$n] = $v ;
		}
	}
	
	/**
	*	Charge une variable dans la vue
	*	@param  string   $pName
	*	@param  sttring  $pVal	
	*/
	public function _addVar($pName, $pVal) {
		if( $pName != '' ){
			$this->_data[$pName] = $pVal;
		}
	}
	
	/**
	 * Merge a child block content in its parent block 
	 * can be called several time before adding ( addBlock() ) 
	 * the parent block
	 *
	 * @param string $pParentName   name of parent block
	 * @param string $pChildName    name of child block
	 * 
	 *//*
	private function _mergeBlocks($pParentName,$pChildName)
	{
		$this->_blocks[] = array('action'=>'_mergeBlocks','name'=>$pParentName,'param'=>$pChildName);
	}*/
	
	/**
	 * 
	 * Ajoute un block au template
	 *
	 * A) if adding a parent block, we need to call before parseBlock() for parent and child block
	 * and at end call  addBlock('parentNameBlock'). 
	 * 
	 * B) if adding a 'simple' block (no childs) call it directly with content of block
	 * addBlock('blockName', $arrayWithBlockContent)
	 * 
    * EMPTY_BLOCK permet d'afficher un bloc sans contenu dynamique
    * 
	 * @param $pName  string      Nom du block
	 * @param $pContent array()   Données pour le block ou EMPTY_BLOCK
	 * 
	 */
	public function OFF_addBlock($pName,$pContent=null) {		
		if( is_array($pContent) or $pContent == EMPTY_BLOCK ){
			// parse le block uniquement si du contenu est disponible
			$this->_blocks[] = array('action'=>'_parseBlock','name'=>$pName,'param'=>$pContent,'addTagBlock'=>'');		
		}
		// ajout du block dans le template
		$this->_blocks[] = array('action'=>'_addBlock','name'=>$pName,'param'=>null,'addTagBlock'=>'');
	}
	
	public function _addBlocks($pBlock1,$pData1,$pBlock2=null,$pData2=null) {
		if($pData1 != null AND !empty($pData1)) {
			$this->_blocks[] = array('action'=>'_parseBlock','name'=>$pBlock1,'param'=>$pData1,'addTagBlock'=>'');
			// ajout du block parent
			$this->_blocks[] = array('action'=>'_addBlock','name'=>$pBlock1,'param'=>null,'addTagBlock'=>'');
		} 
		// controle si un block de niveau 2 doit être intégré
		if( $pBlock2!=null ) {
			if($pData2 != null ) {
				$this->_blocks[] = array('action'=>'_parseBlock','name'=>$pBlock2,'param'=>$pData2,'addTagBlock'=>'');
			}
			// intégration block enfant (block2) dans block parent (block1)
			$this->_blocks[] = array('action'=>'_mergeBlocks','name'=>$pBlock1,'param'=>$pBlock2,'addTagBlock'=>'');
			// ajout du block parent
			$this->_blocks[] = array('action'=>'_addBlock','name'=>$pBlock1,'param'=>null,'addTagBlock'=>'');
		}
	}
	
  /**
   * load a specific js file
   * 
   * @param $pScriptJs
   * 
  */
  public function _addJsFiles( $pJsFile ) {
		if( is_array( $pJsFile) ) {
			$this->_jsFiles = array_merge($this->_jsFiles,$pJsFile);
		} else {
			$this->_jsFiles[] = $pJsFile;
		}
  }
    
 	/**
     * add a specific css file to view
     * 
     * @param $pCss
     * 
   */
  public function _addCssFiles( $pCssFile ) { // charge un css spécifique  06/10/07 
  	if( is_array( $pCssFile)) {
      $this->_cssFiles = array_merge($this->_cssFiles,$pCssFile);
  	} else {
			$this->_cssFiles[] = $pCssFile ;
  	}
  }

  /**
   * 15/05/13
   * Enleve un fichier CSS de la liste 
   * 
   */
	public function _removeCssFile($pCssFile) {
		if( $pCssFile!='') $this->_removeCss[] = $pCssFile;
	}
   
   
 	/** 
	 * Ajoute un header spécifique  06/10/07
	 * 
	 * 
	 */
  public function _addHeader($pHeader) { 
		$this->_headers[] = $pHeader ;
  }
	
  /** 
	 * Envoie les headers spécifiques au browser 06/10/07
	 * 
	 */
  public function _sendHeaders() { 
  	if( is_array( $this->_headers)) {
   	 foreach( $this->_headers as $oneHeader) {
   	   header($oneHeader);
    	}
  	}
  }   
    
  /**
   * parse a file template, an array with pairs  data=>values can be passed
   * return the parsed code of template
   *
   * @param string $pFile
   * @param array $pData
   * @param array $pBlocks
   * 
   * @return string
   * 
   */   
  private function _parseFile( $pFile , $pData=null , $pBlocks=null  ) {
    $tmp = new MyMVC_Template( TEMPLATE_DIR ) ;
  	
  	if( ! $tmp->_load( $pFile )) {
  		throw new Exception("Erreur chargement template <b>$pFile</b>");
  	}
  	
  	if( is_array($pData)) {
  		$tmp->_addVars($pData);
  	}
  	
  	if( is_array($pBlocks)) {
  		foreach( $pBlocks as $nomBlock=>$dataBlock ) {
			$tmp->_parseBlock($nomBlock, $dataBlock);
			$tmp->_addBlock($nomBlock);
   		}
   	}
   	$code = $tmp->_getParsed();
   	unset($tmp);
   	return $code;
	}
   
   /**
    * 
    * parse an file in _externals dirs, and set the tag {..} in current view
    * to the parsedCode 
    *
    * @param string $pFile
    * @param array $pData
    * @param array $pBlocks
    * 
   */
	public function _addExternal($pTag, $pFile , $pData=null , $pBlocks=null )
	{
		if( $pTag != '' and $pFile!='' ) {
			$ext = $this->_parseFile( EXTERNAL_DIR.$pFile , $pData, $pBlocks) ; 
			$this->_externalCode[$pTag] = $ext ;
		} else {
			// TODO log error
		}
	}
    
}
