<?php
/*
 * index.php
 * 
 * fichier principale de l'application
 * ne rien modifié ici
 * 
 * dernière maj : 10/04/14
 * 
*/
try {
   if(file_exists('site-conf.php')) {
      require_once('site-conf.php') ; // Chargement fichier de configuration
   } else {
      throw new Exception('Erreur : fichier site-conf.php manquant');
   }
   if(file_exists(MYMVC_PATH.'mymvc.class.php')) {
      require_once(MYMVC_PATH.'mymvc.class.php'); // Classe principale de MyMVC
   } else {
      throw new Exception('Erreur : fichier '.MYMVC_PATH.'mymvc.class.php manquant');
   }
} catch (Exception $e) {

   $message = $e->getMessage();
   $code = $e->getTrace();
   print <<<FIN
   <html>
   <body>
   <h2 style="text-align:center">Erreur Traitement</h2>
   <p><strong>
   $message</strong>
   </p>      
   </body>
  </html>
FIN;
   exit(1);
}


// @TODO vérifier si le fichier existe
if( MYMVC_MAINTENANT == 1 ) { header('Location: '.BASE_URL.'maintenance.html'); } 



try {
   $MyMVC = new MyMVC();  				// initialise MyMVC
   $MyMVC->_startApp();  				// démarrage application
} catch (Exception $e) {
   $error = new MyMVC_Error();
   $error->_displayException($e);	// affichage des erreurs & exceptions
   exit(1) ;
}


