/*
Copyright (C) 2003 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 


 *  Main MyMVC JS API
 *  
 *  04/07/12 - focus login input if error on auth
 *  17/12/12 - Ajout exclusion (array) pour  MyMVC.resetForm()
 *  04/12/12 - Ajout type file dans resetForm()
 *  14/01/13 - remplacement de SHOW_SPEED par MyMVC.showSpeed
 *  18/02/13 - ajout type=range dans fillForm....()
 *  06/03/13 - fillFromWithArray() ajout pour le type Range l'affichage de la valeur dans un champ  ID_value
 *  17/06/13 - gotoPage(page), gotoUrl(url)
 *  25/07/13 - ajout message personnalisé pour la confirmation de la suppresion MyMVC_CRUD.erase()
 *  31/07/13 - Suppression de la transformation du retour Ajax dans MyMVC_CRUD.processRequest !!
 *  20/02/14 - MyMVC.getTrad(id), utilise url spéciale  /_mymvc/getTrad pour precharger les textes traduits (voir myControler.php)
 *  25/02/14 - fix bug sur controle valeur rep.startPage dans processAuth, teste authOk au lieu de authOK
 *  28/02/14 - auth => envoie du form complet et non plus login et password uniquement
 *  13/03/14 - modif traitement des exclusion pour resetForm un tableau avec la liste des champs suffit maintenant
 *  04/04/14 - copie du code de MyMVC_CRUD.call dans MyMVC_CRUD.read
 *  10/04/14 - chargement des trads uniquement si besoin, chargement en mode asynchrone
 *  10/04/14 - Ajout possibilité d'ajouter des variables dans les traductions avec  {$1}..{$n}
 *  23/04/14 - hideMasque(), showMasque(), msgboxConfirm(), closeMsgboxConfirm()
 *  1.02 - 15/05/14
 *		Accepte url ='' dans gotoPage() pour retour vers page d'accueil
 *		Utilisation de msgboxWithBouton pour confirmer la suppression dans MyMVC_CRUD.erase()
 *		MyMVC.setReadOnlyForm()
 *	1.03 - 
 *	06/06/14 - Mise à jour déclaration variable ajout 'var..'
 *	18/06/14 - ajout  function MyMVC.dateFr(obj date) retourne la date au format JJ/MM/AAAA
 *	18/06/14 - ajout function MyMVC.dateMysql(obj date)  retourne la date au format AAAA-MM-JJ
 *	19/06/14 - MyMVC.goback()  retour page précédente
 *	1.04
 *	21/06/14 - MyMVC_Pagination.init(idTBody,nbLines, idNext, idPrevious, hideButtons FALSE|TRUE );
 *	27/06/14 - Suppression des variables globales => intégration dans l'objet MyMVC 
 *						 renommage msgboxWithButtons => msgBoxWithButtons()
 *						 empty(var), retourne true si var est vide ou undefined
 *	30/09/14 - ajout ajaxError() pour afficher les erreurs Ajax => modif de tous les appels .post() nécessaire
 *	13/10/14 - fix bug test retour JSON dans getTrad, ne pas utiliser DOM.json qui lui meme utilise getTrad()
 *	11/11/14 - Fusion apis.js -> MyMVC.js		  
 * 
*/

MYMVC_JS_VERSION = "1.07"; // 11/11/14

function cl(t) { console.log(t); }

var BASE_URL = '' ;
$(document).ready( function() {
	var b = document.getElementsByTagName('base');	// set BASE_URL global
	if (b && b[0] && b[0].href) {
		if (b[0].href.substr(b[0].href.length - 1) != '/' ) {
      b[0].href = b[0].href + '/';
		}
		BASE_URL = b[0].href;
	}
});

var MyMVC = {
	
  msgboxCallback: null,
	showSpeed: 250,
	currentTrad: '',	
	traductions: null,
    
	/* aff une erreur Ajax bloquante */
	ajaxError: function(message) {
		errMessage = MyMVC.getTrad('mymvcJs_erreurTraitementInterne',[message]);
		alert(errMessage);
	},
	
	empty: function(pVar) {
		if( pVar == '' || pVar == undefined) {
			return true;
		} else {
			return false;
		}
	},

	showMasque: function() {
		if( window.scrollY == 0 ) divTop = 20; else divTop = window.scrollY + 20; 
    $("#mymvc_masque").css('top',window.scrollY); // idem pour le masque
		$("#mymvc_masque").show();
	},
	
	hideMasque: function() {
		$("#mymvc_masque").hide();
	},
	
	msgBox: function(type,message,callBack) {
		//if( window.scrollY == 0 ) divTop = 20; else divTop = window.scrollY + 20; 
    //$("#mymvc_msgbox").css('top',divTop); // calage du top si la page est scrollée
    if(callBack !== null) MyMVC.msgboxCallback = callBack;
    if( type === 'error') {
      $("#mymvc_msgbox").attr('class','error');
      $(".msgBoxIconError").hide();
      $(".msgBoxIconInfo").show();
    } else {
      $("#mymvc_msgbox").attr('class','info');
      $(".msgBoxIconError").hide();
      $(".msgBoxIconInfo").show();
    }
		
    if( message != '' ) {
      CSS.centerElement('mymvc_msgbox',-20);
      MyMVC.showMasque();
      $("#mymvc_msgbox p").html(message);
      $("#mymvc_msgbox").show();
    }
  },
  
  closeMsg: function() {
    MyMVC.hideMasque();
    $("#mymvc_msgbox").hide();
    if(MyMVC.msgboxCallback !== null & MyMVC.msgboxCallback !== undefined) {
			MyMVC.msgboxCallback();
		}
    MyMVC.msgboxCallback = null; // raz du callback après exécution
  },
	
	/**
	* 
	* Affiche une msgbox avec plusieurs boutons
	*  
	* @param string message
	* @param array boutons
	* @param string callback
	* @returns 
	* 
	*/
	msgBoxWithButtons: function(message,boutons,callback) {
        // masquage icone
        $(".msgBoxIconError").hide();
        $(".msgBoxIconInfo").show();
		MyMVC.msgboxCallback = callback;
		if( window.scrollY == 0 ) divTop = 20; else divTop = window.scrollY + 20; 
        $("#mymvc_msgboxWithButtons").css('top',divTop); // calage du top si la page est scrollée
		var nbBoutons = boutons.length ;
		if( nbBoutons>5) { alert(MyMVC.getTrad('mymvcJs_erreurLimiteBoutonDepassee5')); return false; } // TODO show clean alert message
		$(".btMsgboxConfirm").hide();
		for(var i=0;i<nbBoutons;i++)
		{
			var ii = i+1;
			$("#btMsgboxConfirm_"+ii).html(boutons[i]);
			$("#btMsgboxConfirm_"+ii).val(ii);
			$("#btMsgboxConfirm_"+ii).show();
		}
		$(".btMsgboxConfirm").click(function() {
			MyMVC.closeMsgboxWithButtons(parseInt(this.value));
		});
		CSS.centerElement('mymvc_msgboxWithButtons',-50);
    MyMVC.showMasque();
    $("#mymvc_msgboxWithButtons p").html(message)
    $("#mymvc_msgboxWithButtons").show();
	},
	
	/**
  * ferme la msgbox et appele la fonction 
	* avec le nom du bouton pressé
	* 
	* @param string pressedBt
	* @returns 
  */
  closeMsgboxWithButtons: function(pressedBt) {
		MyMVC.hideMasque();
    $("#mymvc_msgboxWithButtons").hide();
		if(MyMVC.msgboxCallback !== null & MyMVC.msgboxCallback !== undefined) {
			MyMVC.msgboxCallback(pressedBt);
		}
		MyMVC.msgboxCallback = null;
	},
	
  /**
   * 
   * Recuperation d'un texte traduit
   * 1) recherche un id xxxx 
   * 2) recherche un id _mymvc_xxxx
   * 
   * il est possible de surcharger une trad mymvc dans les trad de l'application
   * en utilisant un id _mymvc_xxxx
   * 
   * @param {String} id
   * @returns {String}
   * 
   */
  getTrad: function(id,vars) {
    MyMVC.currentTrad = '(JS) Non traduit : [' + id +']' ; // texte par défaut
		//cl(id);
    if( id !== '') {
      if( MyMVC.traductions == null ) {
        MyMVC.traductions = {};
        $.ajax( {
          type: 'POST',
          url: BASE_URL+'_mymvc/getTrad',
          data: {id: id},
          async: false,
          success: function(jsonString) {
            if( (jsonString != null) & (jsonString != '') & (jsonString.substr(0,2)=='{"')  )
						{
							r = eval( '('+jsonString+')' ) ;
							if( r.data != undefined ) {
								for(var i=0; i<r.data.length ; i++) {
									var k = r.data[i].id ;
									//cl(k);
									if( k == id) {
										//cl(id+" => "+r.data[i].trad);
										MyMVC.currentTrad = r.data[i].trad;
									}
									//cl(k+" -> "+r.data[i].trad);
									MyMVC.traductions[k] = r.data[i].trad;
								}
							}
						} else {
							MyMVC.msgBox('error',"Erreur lecture fichier de traduction / Error reading traductions file");
						}
          },
					error: function() { MyMVC.msgBox('error','MyMVC.getTrad() error'); }
        });
      } else {
				if( MyMVC.traductions[id] != undefined ) {
					MyMVC.currentTrad = MyMVC.traductions[id] ;
				}
      }
			if( vars !== undefined && vars.length>0 ) {
				var nbVars = vars.length;
				for(var j=0; j<nbVars ; j++) {
					indice = j+1
					if( MyMVC.currentTrad.indexOf("{$"+indice+"}")!== false) {
						MyMVC.currentTrad = MyMVC.currentTrad.replace( "{$"+indice+"}" , vars[j] );
					}
				}
			}
		}	// id != ''
    return MyMVC.currentTrad;
  }, 
        
  showElement: function(e) { 
    $("#"+e).fadeIn(MyMVC.showSpeed); //jquery lib
  },
   
  hideElement: function(e) {
    $("#"+e).fadeOut(MyMVC.showSpeed); //jquery lib 
  },
   
  // blank all input of a form, text, hidden, textarea, selectedIndex=0
  resetForm: function( frm , exclusion) {
    obj = document.getElementById(frm) ;
    var lg = obj.length ;
    for(var f=0 ;  f<lg ; f++) {
      var n = obj[f].name ;
      // do not reset crud_model field if exist
      if(   n === 'crud_model' || exclusion.indexOf(n)!==-1 ) { //exclusion[n] === true ) {
        continue;
      }
      switch( obj[f].type ) {
        case 'text':
              case 'file':
        case 'hidden':
        case 'password':
        case 'textarea': 	{ obj[f].value = ''; break; }
        case 'checkbox' : 	{ obj[f].checked = false ; break; }
        //case 'select-one' : { obj[f].selectedIndex = 0 ; break; }
      }
    }
  },
  
	/**
	 * passe tous les champs d'un formulaire en readonly
	 * @param string frm : id du formulaire
	 * @param string color : code html couleur background (facultatif)
	 * 
	 * @returns {Boolean}
	 */
	setReadOnlyForm: function(frm,color) {
		var obj = document.getElementById(frm);
		var lg = obj.length;
		for(var f=0;f<lg;f++) {
			obj[f].readOnly = true ;
			obj[f].disabled = true ;
			if( color != undefined && color != '') {
				obj[f].style.background = color ;
			}
		}
		return true;
	},

   selectVal: function( idSelect , selectedVal ) {
	   var s = document.getElementById( idSelect );
	   var i=0;
	   for( var opt in s) {
		   if( opt.value == selectedVal) {
			   s.selectedIndex = i ;
			   break;
		   }
		   i++;
	   }
   },
      
   fillFormWithArray: function(frm,data) {
    if( frm == undefined ) {
      MyMVC.fillFormWithArrayById(data);
    } else {
      var theForm = document.getElementById(frm) ; 
      for( one in data ) {
       if( theForm[one]) {
        var field = theForm[one] ;
         // affectation valeur diff suivant type de champ
         switch( field.type) {
           case 'text' : 
           case 'date' :
           case 'number':
           case 'password':
           case 'textarea':
           case 'hidden' : { field.value = data[one] ; break ; }
           case 'range': { 
               field.value = data[one] ; 
               var id = field.name+'_value'; // champ texte (span) pour afficher la valeur du slider
               var v = document.getElementById(id);
               if( v != undefined) v.innerHTML = data[one];
               break ; }
           case 'select-one' : {
             // recherche de la cle dans le select
             for(var f=0; f< field.length; f++) {
               if( field[f].value == data[one] ) {
                 field.selectedIndex = f ; // on affecte l'index des que la cle est trouvee
               }
             }
             break;
           }	

           case 'checkbox' : {
             if( data[one] == 1 ) {
               field.checked = true ; 
             } else {
               field.checked = false ;
             }
             break;
           }
         }
       }
      }
    }
   },
   
   
   fillFormWithArrayById: function(data) {
	   for( var p in data ) { 
			var field = document.getElementById(p) ;
			if( field  ) {  // controle si col existe dans le form (id d'un input, select, textarea)
				// affectation valeur diff suivant type de champ
				switch( field.type) {
       	  case 'text' : 
					case 'password':
          case 'date':
          case 'number':
					case 'textarea':
          case 'hidden' : { field.value = data[p] ; break ; }
          case 'range':{ field.value = data[p] ; break ; }
          case 'select-one' : {
						// recherche de la cle dans le select
						for(var f=0; f< field.length; f++) {
							if( field[f].value == data[p] )	{
								field.selectedIndex = f ; // on affecte l'index des que la cle est trouvee
							}
						}
						break;
					}	
           
					case 'checkbox' : {
						if( data[p] == 1 ) {
							field.checked = true ; 
						} else {
							field.checked = false ;
						}
						break;
					}
				}
			}
		}
   },
   
	 dateFr: function(d) {
		 //var d = new Date();
		 var mois = d.getMonth()+1;
		 var jour = d.getDate();
		 var annee = d.getFullYear();
		 if(mois<9) { mois = "0"+mois; }
		 if(jour<9) { jour = "0"+jour; }
		 return jour+"/"+mois+"/"+annee; 
	 },
	 
	 dateMysql: function(d) {
		 //var d = new Date();
		 var mois = d.getMonth()+1;
		 var jour = d.getDate();
		 var annee = d.getFullYear();
		 if(mois<9) { mois = "0"+mois; }
		 if(jour<9) { jour = "0"+jour; }
		 return annee+"-"+mois+"-"+jour; 
	 },
	 
	/*numberFormat: function(val, precision)
	{
	   p = 100 ;
	   val *= p ;
	   val = Math.round(val);
	   return val/p;
	}*/
   
   /**
    * renvoie sur une page du site
    * BASE_URL est ajouté automatiquement
    */
  gotoPage: function(url) {
    //if( url != '') {
		var url = BASE_URL + url;
		window.document.location.assign(url);
    //}
  },
  /**
   * Renvoie sur une url absolue 
   * l'url n'est pas modifiée
   */
  gotoUrl: function(url) {
    if( url != '') {
       window.document.location.assign(url);
    }
  },
	
	/**
	 * Retourne à la page précédente
	 * 
	 */
	goback: function() {
		window.history.go(-1);
	},
    
    reloadPage: function()
    {
      document.location.reload();
    },
    
		/**
		 * 
		 * @param string className
		 * @param string id
		 * @param string href
		 * @param string title
		 * @param string content
		 * @returns A (DOM Element)
		 */
    createA: function(className,id,href,title,content) {
      var a = document.createElement('a');
      a.href = href;
      a.className = className;
      a.title = title;
      a.innerHTML = content;
      a.id = id;
      return a;
    },
    
    createTr: function(className,id) {
      var tr = document.createElement('tr');
      tr.className = className;
      tr.id = id;
      return tr;
    },
    
		createTd: function(htmlContent)
		{
			var td = document.createElement('td');
      if( htmlContent!=undefined ) {
        td.innerHTML = htmlContent;
      }
			return td;
		},
		
		createTh: function(htmlContent)
		{
			var td = document.createElement('th');
      if( htmlContent!=undefined ) {
        td.innerHTML = htmlContent;
      }
			return td;
		},
		
		// select a index by is value in a select input
		selectValue: function(idSelect,val)
		{
			var s = document.getElementById(idSelect) ;
			var i = 0 ;
			while( i < s.length)
			{
				//alert(s.options[i].value);
				if( s.options[i].value == val)
				{
					s.selectedIndex = i ;
				}
				i++;
			}
		},
		
		// return an array, d = json string
		getJSON: function(jsonString) // 13/04/14
		{
			var ret = new Array();
			ret['requestOk'] = false 
			ret['message'] = 'Error JSON Format' ;
			if( (jsonString != null) & (jsonString != '')  ) {
				if( jsonString.substr(0,2)=='{"' ) {
					ret = eval( '('+jsonString+')' ) ;
				}
			}
			return ret ;  
		},
		
		// get value of a select input, select must have a id 
		getSelectValue: function( idSelect )
		{
			var s = document.getElementById(idSelect) ;
			if( s) 
			{
				return s.options[s.selectedIndex].value ;
			} else {
				return "" ;
			}
		},
		// get text of a select input, select must have a id 
		getSelectText: function( idSelect )
		{
			var s = document.getElementById(idSelect) ;
			if( s) 
			{
				return s.options[s.selectedIndex].text ;
			} else {
				return "" ;
			}
		},
		// delete all entries of a select input
		emptySelect: function ( idSelect )
		{
			var s = document.getElementById(idSelect);
			if( s )
			{	
				while(s.options.length)
				{
					s.options[s.options.length - 1] = null;
				}
			}
		},
		//add an option to a select
		appendSelectOption: function(id,txt,val) {
			var sel = document.getElementById(id);
			if( sel != undefined ) {
				newOption 	= document.createElement('option') ; 
				newOption.text 		= txt ;
				newOption.value 	= val ;	
				//cl(txt);
				sel.appendChild(newOption) ;
			}
		},
		
		// fill a select with data 
		fillSelect: function ( id, data, addEmptyOption)
		{
      DOM.emptySelect(id);
			var sel = document.getElementById(id);
      var s=0;
			if( sel && data.length>0 )
			{
				var newOption = '' ;
        if(addEmptyOption === true) {
          newOption 	= document.createElement('option') ; 
					//vue 			= data[j].view.substr(0,1) ;	
					newOption.text 	= '';
					newOption.value = '';		 
					sel.options[s] 	= newOption ;
          s++;
        }
				for( var j = 0 ; j < data.length ; j++ )
				{
					newOption 	= document.createElement('option') ; 
					newOption.text 		= data[j].text ;
					newOption.value 	= data[j].value ;		 
					sel.options[s]	= newOption ;
          s++;
				}
			}
		},
		// fill an UL 		
		fillUl: function(id,data,onclickFunc,cl) 
		{
			var newLi = '' ;
			var ul = document.getElementById(id);
			if( ul)
			{	
				for(var i=0 ; i< data.length ; i++ ) 
				{
					newLi 					= document.createElement('li'); 
					newLi.innerHTML 		= data[i].name;
					newLi.id				= data[i].id;
					if( onclickFunc != '') newLi.onclick = onclickFunc ;
					if( cl != '')	newLi.className 	 = cl; 
					ul.appendChild(newLi) ;
				}
			}
		},
		// delete all (childs) of ul
		emptyUl: function(id)	
		{
			var ul = document.getElementById(id);
			if( ul)
			{
				while( ul.hasChildNodes() )
				{
					ul.removeChild( ul.firstChild);
				} 
			}
		},
		
		/** 
			delete all lines tr from tbl (table or tbody)
			start = firstline to delete
			end = last line, or false to delete all lines after start
	 	*/
		deleteRows: function(tbl,start,end)
		{
  		var rows = $('#'+tbl+' tr');
  		if( end == false ) end = rows.length ;
  		for( var r = start ; r <rows.length; r++) // keep first line
  		{
  			$( "#"+tbl+" tr:last").remove();
  		}
		},

    focus: function(id)
    {
      var obj = document.getElementById(id);
      if(obj)
      {
        obj.focus();
      }
    },
		
		// set visibility visible
		setVisible: function(id)
		{
			var el = document.getElementById(id);
			if(el)
			{
				el.style.visibility = 'visible' ;
			} 
		},
		// set visibility hidden
		setHidden: function(id)
		{
			var el = document.getElementById(id);
			if(el)
			{
				el.style.visibility = 'hidden' ;
			} 
		},
		// set display None
		setDisplayNone: function(id)
		{
			var el = document.getElementById(id);
			if(el)
			{
				el.style.display = 'none' ;
			}
		},
		// set display block 
		setDisplayBlock: function(id)
		{
			var el = document.getElementById(id);
			if(el)
			{
  				el.style.display = 'block' ;
  			}
		},
		// set class 
		setClass: function(id,className)
		{
			var el = document.getElementById(id);
			if(el)
			{
    		el.className = className ;
			} else {
				el.className = '' ;
			}
		},
		
		// altern 2 class css sur le element paire et impair
		// exemple sur les ligne d'une table
		rowAltern: function(element,classEven,classOdd)
		{
			// set table rows colors
      $(element+":odd").addClass(classOdd) ;
      $(element+":even").addClass(classEven) ;
		},
		
    /**
     * Centre un element (div) à partir de son ID
     * l'élement doit être en position absolue
     * 
     * @param {type} id
     * @returns {undefined}
     */
    centerElement: function(id,topOffset) {
      var windowSize = window.innerHeight;
      //cl(windowSize);
			//cl(document.getElementById(id).style.width);
      var elHeight = parseInt($("#"+id).css('height'));
      //cl(elHeight);
      var elWidth = parseInt($("#"+id).css('width'));
      //cl(elWidth);
      var top = window.scrollY + parseInt(topOffset);
      if( elHeight < windowSize) {
        top = top + (windowSize - elHeight)/2 ;
      } else {
        top = top + 20;
      }
			//cl(top);
      $("#"+id).css('margin-left','50%');
      $("#"+id).css('top',top);
      $("#"+id).css('left',-elWidth/2);
      //cl(top);
    }
}

