/*
Copyright (C) 2011 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 


 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 * 
 * 27/06/14 - Suppression variables globales, intégration dans l'objet
 * 30/06/14 - MyMVC_CRUD.list(), possibilité de passer un form ou un objet en entrée
 * 24/09/14 - var callback => callBack dans MyMVC_CRUD.list()
 * 01/10/14 - Modif pour utiliser objet $.ajax() au lieu de $.post()
 * 02/10/14 - Ajout callIfCancel dans MyMVC_CRUD.erase() 
 * 
 */

MYMVC_CRUD_VERSION = "1.05.1" //02/10/14

var MyMVC_CRUD = {
  
	formInProcess: false,
	callback: null,
	mdata: null,
	ifCancel: null,
	
	erase: function(data) {  // delete can't be used reserved word
    var mc = 'Confirmer la suppresion ?'; //message par défaut
    if( data.message != undefined ) mc = data.message;
		if( data.callIfCancel != undefined) MyMVC_CRUD.ifCancel = data.callIfCancel ;
		if( data.callBack == undefined) {
			MyMVC.msgBox('error',MyMVC.getTrad('mymvcJs_methodeCallbackMyMVCCRUDManquante'));
			return false;
		}
		MyMVC_CRUD.mdata = data;
		MyMVC.msgBoxWithButtons(mc,[MyMVC.getTrad('mymvc_ok'),MyMVC.getTrad('mymvc_annuler')],MyMVC_CRUD.eraseResponse);
		/*if( confirm(mc) ) {
			MyMVC_CRUD.call(data) ;
		} else {
			return false;
		}*/
	},
	
	
	eraseResponse: function(pressedBt) {
		if(pressedBt == 1) { // bouton OK
			MyMVC_CRUD.call(MyMVC_CRUD.mdata);
		} else { // annuler
			if( MyMVC_CRUD.ifCancel != null ) MyMVC_CRUD.ifCancel() ;
		}
		MyMVC_CRUD.ifCancel = null;
	},
	
	read: function(data) {
		MyMVC_CRUD.call(data);
		return false;
	},
		
	call: function( data) {
		if( !MyMVC_CRUD.formInProcess ) {
			MyMVC_CRUD.callback = data.callBack ;
			MyMVC_CRUD.formInProcess = true ;
			// ajax call with Jquery
			data.url = BASE_URL + data.url ;
			//$.post( data.url , { id: data.id, crud_model: data.crud_model }, MyMVC_CRUD.processRequest ) ; 
			$.ajax({
				type: "post",
				url: data.url,
				data: { id: data.id, crud_model: data.crud_model },
				success: MyMVC_CRUD.processRequest,
				error: function() { MyMVC.ajaxError('MyMVC_CRUD.call()') },
				async: false
			});
		}
		return false;
	},
	
	save: function( data ) {
		if( !MyMVC_CRUD.formInProcess ) {
		  //$("#"+data.frm+" #crud_model").val(data.crud_model) ;
		  MyMVC_CRUD.callback = data.callBack ;
		  MyMVC_CRUD.formInProcess = true ;
		  data.url = BASE_URL + data.url ;
		  /* var ajaxRS = $.post( data.url , $("#"+ data.frm ).serialize())
							.done( MyMVC_CRUD.processRequest)
							.failed(MyMVC.ajaxError('MyMVC_Crud.save()'));*/
			$.ajax( {
				type: "post",
				url: data.url,
				data: $("#"+data.frm).serialize(),
				success: MyMVC_CRUD.processRequest,
				error: function() { MyMVC.ajaxError('MyMVC_CRUD.save()') },
				async: true
			});
		}
		return false;
	},
	
	processRequest: function(ajaxResponse) { 
		MyMVC_CRUD.formInProcess = false;
		MyMVC_CRUD.callback(ajaxResponse);
	},
	
	list: function(data) {
		if(MyMVC.empty(data.url) || MyMVC.empty(data.callBack)) {
			MyMVC.msgBox('error', MyMVC.getTrad('mymvc_CrudListParametresIncorrects'));
			return false;
		}
		var url = BASE_URL + data.url;
		if( !MyMVC.empty(data.frm) ) { 
			//cl('with form');
			/*var ajaxRs = $.post( url , $("#"+data.frm).serialize())
							.done( function() { data.callBack ; }  ) //envoie via un form
							.fail( function() { alert('error') } ) ;*/
			$.ajax( {
				type: "post",
				url: url,
				async: true,
				data: $("#"+data.frm).serialize(),
				success: data.callBack,
				error: function() { MyMVC.ajaxError('MyMVC_CRUD.list()') }
			});
		} else {
			//cl('no form' + data.url);
			var cb = data.callBack;
			data.callBack = '';
			//$.post( url , data , cb  ) ; // envoie direct via un objet {n1:v1, n2:v2...}
			$.ajax( {
				type: "post",
				url: url,
				async: true,
				data: data,
				success: cb,
				error: function() { MyMVC.ajaxError('MyMVC_CRUD.list()') }
			});
		}
	},
	
};