/*
Copyright (C) 2013 - 2014 Auguste  <postmaster@pajagus.fr>
    
This file is part of MyMVC PHP Framework.

MyMVC PHP Framework is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MyMVC PHP Framework is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MyMVC PHP Framework.  If not, see <http://www.gnu.org/licenses/> 
/**

 init( 
 	idTbody => id du tbody à paginer
 	nbLines => nombre de lignes par page
 	idNext => id du bouton pour passer à la page suivante
 	idPrevious => id du bouton pour passer à la page précédente)
	hideButtons => true|false , indique s'il faut masquer les boutons sur 1ere et dernière page
	callBack => nom de fonction qui sera appelée après chaque changement de page, cette fonction recevra en entrée un objet :
		currentPage => numéro de la page courante
		nbPage: => nombre total de pages
		first: => numéro de la première ligne affichée
		last => numéro de la dernière ligne affichée
	la fonction init retourne également le même objet lors du premier appel
)

Si vous souhaiter changer de page manuellement il faut utiliser 
MyMVC_Pagination.changePage('next' ou 'previous');
cette fonction retourne un objet :
	currentPage => numéro de la page courante
	nbPage: => nombre total de pages
	first: => numéro de la première ligne affichée
	last => numéro de la dernière ligne affichée
 
 */
var MyMVC_Pagination = {
	
	currentPage: 1,
	maxPage: 1,
	nbLines : 10,  // valeur par défaut
	tbody: '',
	hideButtons: true,
	btNext: '',
	btPrevious: '',
	callBack: '',
	infoPagination: '',
	
	init: function(idTbody, nbLines, idNext, idPrevious, hideButtons, callBack) {
		MyMVC_Pagination.currentPage = 1;
		MyMVC_Pagination.hideButtons = hideButtons;
		MyMVC_Pagination.callBack = callBack;
		if( parseInt(nbLines)>0 )MyMVC_Pagination.nbLines = nbLines;
		if( idNext != '' ) { 
			MyMVC_Pagination.btNext = $("#"+idNext);
			MyMVC_Pagination.btNext.off('click','');
			MyMVC_Pagination.btNext.on('click', function() { MyMVC_Pagination.changePage('next'); });
		} else {
			MyMVC_Pagination.btNext = '';
		}
		if( idPrevious!='' ) { 
			MyMVC_Pagination.btPrevious = $("#"+idPrevious);
			MyMVC_Pagination.btPrevious.off('click','');
			MyMVC_Pagination.btPrevious.on('click', function() { MyMVC_Pagination.changePage('previous'); });
		} else {
			MyMVC_Pagination.btPrevious = '';
		}
		MyMVC_Pagination.tbody = $("#"+idTbody+" TR") ;
		var nbTr = MyMVC_Pagination.tbody.length;
		if( nbTr>0 ) {
			MyMVC_Pagination.maxPage = parseInt(nbTr/nbLines) ;
			if( (MyMVC_Pagination.maxPage * nbLines) < nbTr ) MyMVC_Pagination.maxPage++;
			return MyMVC_Pagination.update();
		} else {
			MyMVC_Pagination.maxPage = 0 ;
			return false;
		}
	},
	
	update: function() {
		//cl('MyMVC_Pagination.update');
		var last = MyMVC_Pagination.nbLines * MyMVC_Pagination.currentPage ;
		var first = last - MyMVC_Pagination.nbLines+1;
		var i=1;
		//cl(first+"-"+last); 
		MyMVC_Pagination.tbody.each( function(i) {
			i++;
			if( i <= last && i >= first ) {
				$(this).show();
			} else {
				$(this).hide();
			}
		});
		// masquage des boutons s'ils sont gérés par MyMVC_Pagination
		if(MyMVC_Pagination.hideButtons && MyMVC_Pagination.btNext!='' && MyMVC_Pagination.btPrevious != '') {
			if( MyMVC_Pagination.currentPage == MyMVC_Pagination.maxPage) { 
				MyMVC_Pagination.btNext.hide();
			} else {
				if(MyMVC_Pagination.maxPage>1) MyMVC_Pagination.btNext.show();
			}
			if( MyMVC_Pagination.currentPage == 1) { 
				MyMVC_Pagination.btPrevious.hide();
			} else {
				if(MyMVC_Pagination.maxPage>1) MyMVC_Pagination.btPrevious.show();
			}
		}
		MyMVC_Pagination.infoPagination = {'currentPage':MyMVC_Pagination.currentPage, 'firstLine':first, 'lastLine':last, 'nbPage':MyMVC_Pagination.maxPage};
		if( MyMVC_Pagination.callBack!='' && MyMVC_Pagination.callBack!=undefined ) {
			MyMVC_Pagination.callBack(MyMVC_Pagination.infoPagination);
		}
		return MyMVC_Pagination.infoPagination ;
	},
	
	changePage: function(sens) {
		switch(sens) {
			case 'next': {
					if(MyMVC_Pagination.currentPage<MyMVC_Pagination.maxPage) MyMVC_Pagination.currentPage++;
					break;
			}
			case 'previous': {
				if(MyMVC_Pagination.currentPage>1) MyMVC_Pagination.currentPage--;
				break;
			}
		}
		return MyMVC_Pagination.update();
	}
	
}