/**
 * 
 * Fonctions admin pour MyMVC
 * 
 * pour la gestion en bdd des données
 * 
 * pages.ini
 * config.ini
 * datasources.ini
 * acl.ini
 * viewvars.ini
 * 
 * 01/08/13 - Création
 * 
 * 
 */

MYMVC_JSADMIN_VERSION = "1.01"; // 01/08/13

CRUD_MODEL = '';
FRM = '';
CONTAINER = '';

var MyMVC_Admin = {
  
  init: function(frmId,cnt) {
    CRUD_MODEL = $("#crud_model").val();
    FRM = frmId;
    CONTAINER = cnt;
    MyMVC_Admin.updateList();
    $("#btSave").click(function() {
       MyMVC_CRUD.save({
          url:'mymvc/admin/mymvc-adm.php',
          frm: FRM,
          callBack: MyMVC_Admin.saveProcess
       });
    });
    $("#btRaz").click(function(){
       MyMVC.resetForm(FRM,{action:true,crud_model:true});
    });
  },
  
  enableButton: function() {
    $(".btDelete").click(function() {
      if(confirm('Confirmez la suppresion de cette ligne ?')) {
        $.post( BASE_URL+'mymvc/admin/mymvc-adm.php', { action: 'delete', id: this.id, crud_model: CRUD_MODEL }, MyMVC_Admin.deleteProcess);
      }
    });
    $(".btEdit").click(function() {
      $.post( BASE_URL+'mymvc/admin/mymvc-adm.php',{ action: 'read', id: this.id, crud_model: CRUD_MODEL }, MyMVC_Admin.fillForm);
    })
  },
  
  showError: function (message) {
    $("#errorLine").html(message);
    $("#errorLine").show();
    setTimeout(function() {$("#errorLine").hide(); },4000);
  },

  showList: function(ajaxResp)
  {
    resp = DOM.getJSON(ajaxResp);
    container = document.getElementById(CONTAINER);
    container.innerHTML = '';
    if(!resp.requestOk) { 
      MyMVC_Admin.showError(resp.message); 
      return;
    } else {
      fillTable(resp.data);
      MyMVC.resetForm(FRM,{action:true});
    }
  },
  
  saveProcess: function(ajaxResponse)
  {
    var resp = DOM.getJSON(ajaxResponse);
    if(!resp.requestOk) {
      MyMVC_Admin.showError(resp.message);
    } else {
      // update table
      MyMVC_Admin.updateList();
    }
  },
    
    updateList: function()
    {
      $.post('mymvc/admin/mymvc-adm.php',{action: 'getList' , crud_model: CRUD_MODEL }, MyMVC_Admin.showList);
    },
    
    fillForm: function(respx)
    {
      resp = DOM.getJSON(respx);
      if( !resp.requestOk) {
        MyMVC_Admin.showError(resp.message);
      } else {
        MyMVC.fillFormWithArray(FRM,resp.data);
      }
    },
    
    deleteProcess: function(ajaxResponse)
    {
      resp = DOM.getJSON(ajaxResponse);
      if( !resp.requestOk) {
        MyMVC_Admin.showError(resp.message);
      } else {
        // update table
        MyMVC_Admin.updateList();
      }
    }
    
 }